/*
    GL-117
    Copyright 2001, 2002 Thomas A. Drexl aka heptargon

    This file is part of GL-117.

    GL-117 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GL-117 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Jabytad; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
TODO:
- Weather implementieren
- Mondlandschaft
- Flarak
- Schiffe
- Richtige Missionen
- Missionsdaten speichern
*/

#ifndef IS_UGL_H

#include "ugl.h"

#define MAXX2 512
#define ZOOM 256

#define VERSIONSTRING "GL-117 V0.3 BY THOMAS A. DREXL"

bool debug = false;
bool multiplayer = false, isserver = false;
int fullscreen = 1;
int day = 1;
int weather = 0;
int volumesound = 100;
int volumemusic = 100;

int mousex, mousey;

float sine [360], cosi [360];
float view = 75.0, zoomz = 1.0/(100.0*MAXX2);
int width = 800, height = 600, bpp = 32;
int quality = 3;
float mypi = atan (1) * 4.0;
float sungamma = 45.0;

Server *server;
Client *client;

#ifdef HAVE_SDL
SDL_Thread *threadnet = NULL;
#endif

int net_thread_main (void *data);

int lighting = 1;

int mode = 0;

#define GAME_INIT 0
#define GAME_PLAY 1
#define GAME_PAUSE 2
#define GAME_MENU 3
#define GAME_CREDITS 4
#define GAME_CREATE 5
#define GAME_JOIN 6

//#define USE_GLUT

int game = GAME_INIT;

SoundSystem *sound = NULL;

int myrandom (int n)
{
  if (n == 0) return 0;
  return rand () % n;
}

float dist (float dx, float dy)
{
  return sqrt (dx*dx + dy*dy);
}


GL *gl;
//#include "3ds.cpp"

const int maxsmokeelem = 20;
CTexture *texsmoke, *texsmoke2;
float smokezoom [] = { 0.02, 0.035, 0.05, 0.065, 0.085, 0.1, 0.11, 0.12, 0.1, 0.09, 0.05 };

float getView ()
{
  if (weather == 1 && view > 40.0)
    return 40.0;
  return view;
}

class CSmoke
{
  public:
  CVector3 v [maxsmokeelem];
  float zoom [maxsmokeelem];
  int time [maxsmokeelem];
  int phi [maxsmokeelem];
  int last;
  int type;
  CSmoke (int type)
  {
    for (int i = 0; i < maxsmokeelem; i ++)
    {
      time [i] = 0;
      zoom [i] = 0.1;
      phi [i] = 0;
    }
    last = 0;
    this->type = type;
  }
  void setSmoke (float x, float y, float z, int myphi, int mytime)
  {
    last ++;
    if (last >= maxsmokeelem)
      last = 0;
    v [last].x = x;
    v [last].y = y;
    v [last].z = z;
    time [last] = mytime;
    phi [last] = myphi;
  }
  void move ()
  {
    for (int i = 0; i < maxsmokeelem; i ++)
      if (time [i] > 0)
      {
        time [i] -= 3;
        if (time [i] < 0) time [i] = 0;
      }
  }
  void drawElem (int n)
  {
//    glRotatef (phi [n], 0, 1, 0);
    if (n < 0 || n >= maxsmokeelem) return;
    glBegin (GL_QUADS);
    glColor4ub (255, 255, 255, time [n] * 20 + 55);
    float myzoom = smokezoom [time [n]];
    glTexCoord2f (0, 0);
    glVertex3f (v [n].x - myzoom * cosi [phi [n]], v [n].y + myzoom, v [n].z + myzoom * sine [phi [n]]);
    glTexCoord2f (1, 0);
    glVertex3f (v [n].x + myzoom * cosi [phi [n]], v [n].y + myzoom, v [n].z - myzoom * sine [phi [n]]);
    glTexCoord2f (1, 1);
    glVertex3f (v [n].x + myzoom * cosi [phi [n]], v [n].y - myzoom, v [n].z - myzoom * sine [phi [n]]);
    glTexCoord2f (0, 1);
    glVertex3f (v [n].x - myzoom * cosi [phi [n]], v [n].y - myzoom, v [n].z + myzoom * sine [phi [n]]);
    glEnd ();
  }
  void drawElemHQ (int n)
  {
//    glRotatef (phi [n], 0, 1, 0);
    if (n < 0 || n >= maxsmokeelem) return;
    glBegin (GL_QUADS);
    glColor4ub (255, 255, 255, time [n] * 20 + 55);
    float myzoom = smokezoom [time [n]];
    glTexCoord2f (0, 0);
    glVertex3f (v [n].x - myzoom, v [n].y + myzoom, v [n].z);
    glTexCoord2f (1, 0);
    glVertex3f (v [n].x + myzoom, v [n].y + myzoom, v [n].z);
    glTexCoord2f (1, 1);
    glVertex3f (v [n].x + myzoom, v [n].y - myzoom, v [n].z);
    glTexCoord2f (0, 1);
    glVertex3f (v [n].x - myzoom, v [n].y - myzoom, v [n].z);
    glTexCoord2f (0, 0);
    glVertex3f (v [n].x, v [n].y + myzoom, v [n].z - myzoom);
    glTexCoord2f (1, 0);
    glVertex3f (v [n].x, v [n].y + myzoom, v [n].z + myzoom);
    glTexCoord2f (1, 1);
    glVertex3f (v [n].x, v [n].y - myzoom, v [n].z + myzoom);
    glTexCoord2f (0, 1);
    glVertex3f (v [n].x, v [n].y - myzoom, v [n].z - myzoom);
    glEnd ();
  }
  void draw ()
  {
    int i;
    gl->enableAlphaBlending ();
    glEnable (GL_ALPHA_TEST);
    glAlphaFunc (GL_GEQUAL, 0.1);
    if (type == 0) gl->enableTextures (texsmoke->textureID);
    else if (type == 1) gl->enableTextures (texsmoke2->textureID);
    for (i = last; i >= 0; i --)
    {
      if (time [i] > 0)
      {
        if (quality >= 3)
          drawElemHQ (i);
        else
          drawElem (i);
      }
    }
    for (i = maxsmokeelem - 1; i > last; i --)
    {
      if (time [i] > 0)
      {
        if (quality >= 3)
          drawElemHQ (i);
        else
          drawElem (i);
      }
    }
    glDisable (GL_TEXTURE_2D);
    glDisable (GL_ALPHA_TEST);
    gl->disableAlphaBlending ();
  }
};

class Flash
{
  public:
  int time;
  int phi;
  CVector3 w [10];
  Flash ()
  {
    phi = 0;
  }
  ~Flash ()
  {
  }
  void set (float x, float y, float z, int phi)
  {
    int i;
    this->phi = phi;
    w [0].x = x; w [0].y = y; w [0].z = z;
    for (i = 1; i < 10; i ++)
    {
      w [i].y = y + 6.0 * i;
      w [i].x = w [i - 1].x + 0.1 * myrandom (60) - 3.0;
      w [i].z = w [i - 1].z + 0.1 * myrandom (60) - 3.0;
    }
  }
  void draw ()
  {
    int i;
    glDisable (GL_TEXTURE_2D);
    glBegin (GL_QUAD_STRIP);
    glColor3ub (255, 255, 255);
    float myzoom = 0.3;
    for (i = 0; i < 10; i ++)
    {
      glVertex3f (w [i].x - myzoom * cosi [phi], w [i].y, w [i].z + myzoom * sine [phi]);
      glVertex3f (w [i].x + myzoom * cosi [phi], w [i].y, w [i].z - myzoom * sine [phi]);
    }
    glEnd ();
/*    gl->enableAlphaBlending ();
    glEnable (GL_ALPHA_TEST);
    glAlphaFunc (GL_GEQUAL, 0.05);
    gl->enableTextures (texsmoke2->textureID);
    i = 9;
    myzoom = 6.0;
    glBegin (GL_QUADS);
    glColor4ub (255, 255, 255, 200);
    glTexCoord2f (0, 0);
    glVertex3f (w [i].x - myzoom * cosi [phi], w [i].y + myzoom, w [i].z + myzoom * sine [phi]);
    glTexCoord2f (1, 0);
    glVertex3f (w [i].x + myzoom * cosi [phi], w [i].y + myzoom, w [i].z - myzoom * sine [phi]);
    glTexCoord2f (1, 1);
    glVertex3f (w [i].x + myzoom * cosi [phi], w [i].y - myzoom, w [i].z - myzoom * sine [phi]);
    glTexCoord2f (0, 1);
    glVertex3f (w [i].x - myzoom * cosi [phi], w [i].y - myzoom, w [i].z + myzoom * sine [phi]);
    glEnd ();
    glDisable (GL_TEXTURE_2D);
    glDisable (GL_ALPHA_TEST);
    gl->disableAlphaBlending ();*/
//    glTexCoord2f (1, 1);
//    glVertex3f (v.x + myzoom * cosi [phi], v.y - myzoom, v.z - myzoom * sine [phi]);
//    glTexCoord2f (0, 1);
//    glVertex3f (v.x - myzoom * cosi [phi], v.y - myzoom, v.z + myzoom * sine [phi]);
  }
};

class CSpaceObj
{
  public:
  int draw, explode;
  bool drawlight;
  float zoom, alpha, lum;
  CModel *o;
  CVector3 *tl;
  CRotation *rot;
  CSpaceObj ()
  { tl = new CVector3 ();
    rot = new CRotation ();
    zoom = 1; alpha = 1; draw = 1; lum = 1; drawlight = true; explode = 0; }
  CSpaceObj (CModel *o, float zoom)
  { this->o = o;
    this->zoom = zoom;
    tl = new CVector3 ();
    rot = new CRotation ();
    alpha = 1; draw = 1; lum = 1; drawlight = true; explode = 0; }
  ~CSpaceObj () { delete tl; delete rot; }
  void translate (CVector3 *v)
  { tl->x = v->x;
    tl->y = v->y;
    tl->z = v->z; }
  void translate (float x, float y, float z)
  { tl->x = x;
    tl->y = y;
    tl->z = z; }
  void rotate (short a, short b, short c)
  { rot->setAngles (a, b, c); }
  void rotateOn (short a, short b, short c)
  { rot->addAngles (a, b, c); }
  void drawGL (CVector3 *z1, CVector3 *z2, CVector3 *tl, float alpha2, float lum2, bool drawlight2, bool istextured2)
  {
    if (draw == 0) return;
    if (draw == 2 || gl->isCubeInFrustum (tl->x + this->tl->x, tl->y + this->tl->y, tl->z + this->tl->z, this->zoom))
    {
      if (drawlight && drawlight2)
      {
        glEnable (GL_LIGHTING);
        o->draw (tl, this->tl, this->rot, this->zoom, lum * lum2, explode);
      }
      else
      {
        glDisable (GL_LIGHTING);
        if (istextured2)
          o->draw2 (tl, this->tl, this->rot, this->zoom, explode);
        else
        {
          if (drawlight2)
            o->draw3 (tl, this->tl, this->rot, this->zoom, lum * lum2, explode);
          else
            o->draw3 (tl, this->tl, this->rot, this->zoom, explode);
        }
      }
    }
  }
};

const int maxobjperspace = 500;

class Space
{
  public:
  int no;
  bool drawlight;
  float alpha, lum;
  CSpaceObj *o [maxobjperspace];
  CVector3 *z1, *z2, *tl;
  Space ()
  { no = 0; alpha = 1; lum = 1; drawlight = true;
    tl = new CVector3 ();
    z1 = new CVector3 ();
    z2 = new CVector3 (); }
  Space (CVector3 *v, CVector3 *w)
  { no = 0; alpha = 1; lum = 1; drawlight = true;
    tl = new CVector3 ();
    z1 = new CVector3 (v);
    z2 = new CVector3 (w); }
  ~Space ()
  { delete tl; delete z1; delete z2; }
  void init ()
  {
    no = 0;
  }
  bool addObject (CSpaceObj *o2)
  {
    if (no < 0 || no >= maxobjperspace) return false;
    o [no] = o2;
    no ++;
    return true;
  }
  bool removeObject (CSpaceObj *o2)
  {
    int i, i2;
    for (i = 0; i < no; i ++)
      if (o [i] == o2)
      {
        for (i2 = i + 1; i2 < no; i2 ++)
        {
          o [i2 - 1] = o [i2];
        }
        no --;
        return true;
      }
    return false;
  }
  void translate (CVector3 *v)
  { tl->x = v->x;
    tl->y = v->y;
    tl->z = v->z; }
  void drawGL ()
  {
    if (drawlight)
    {
      for (int i = 0; i < no; i ++)
      {
        if (&o [i] != NULL)
          if (o [i]->draw)
            o [i]->drawGL (z1, z2, tl, alpha, lum, true, true);
      }
    }
    else /* not yet implemented */
    {
      for (int i = 0; i < no; i ++)
      {
        if (&o [i] != NULL)
          if (o [i]->draw)
            o [i]->drawGL (z1, z2, tl, alpha, lum, false, false);
      }
    }
  }
};



class RTerrain
{
public:
  void roam (Landscape *l);
};




class CExplosion : public CSpaceObj
{
  public:
  Space *space;
  int ttl, maxlen;
  float maxzoom;
  CExplosion (Space *space, CModel *sphere)
  {
    this->space = space;
    o = sphere;
    ttl = 0;
    space->addObject (this);
    draw = false;
    zoom = 0.1;
    drawlight = false;
  }
  void setExplosion (float x, float y, float z, float maxzoom, int len)
  {
    tl->x = x;
    tl->y = y;
    tl->z = z;
    this->maxzoom = maxzoom;
    ttl = len;
    maxlen = len;
    draw = true;
  }
  void move ()
  {
    if (ttl > 0)
    {
      zoom = sine [ttl * 180 / maxlen] * maxzoom;
      ttl --;
      if (ttl <= 0)
      {
        ttl = 0;
        draw = false;
      }
    }
  }
};




#define PARTS 12

class GLLandscape : public Landscape
{
  public:
  short nl [MAXX + 1] [MAXX + 1];
  float lv [3];
//  unsigned char rect [MAXX + 1] [MAXX + 1];
  RTerrain *rt;
  unsigned char r [MAXX + 1] [MAXX + 1];
  unsigned char g [MAXX + 1] [MAXX + 1];
  unsigned char b [MAXX + 1] [MAXX + 1];
  unsigned char drawrule [MAXX] [MAXX];
  unsigned char tex1 [MAXX] [MAXX];
  unsigned char tex2 [MAXX] [MAXX];
  unsigned char dl [MAXX + 1] [MAXX + 1];
  int lsticker;

  private:
  float hh, hh2, zoomz2;
  unsigned short hray [MAXX + 1] [MAXX + 1];
  GLfloat mat [13] [4], mata [13] [4];
  Space *space;
  CColor treecolor;

  void norm (float *c);

  void normalcrossproduct( float* a, float* b, float*c );

  float *selectMaterial (int x, int y);

  int selectColor (int x, int y);
  
  unsigned short lg [MAXX + 1] [MAXX + 1];

  void precalculate ();

  void subdivide (int x1, int y1, int x2, int y2);

  public:

  int getCoord (int a);
  float getCoord (float a);
	  
  float getHeight (float x, float z);

  float getExactHeight (float x, float z);

  float getExactLSHeight (float x, float z);

  float getRayHeight (float x, float z);

  float getExactRayHeight (float x, float z);

  void drawRotatedTree (float x, float y, float htree, float wtree, int phi);

  void drawTree (float x, float y, float htree, float wtree, int phi);

  int detail [PARTS] [PARTS];
  int done [100] [100];

  void drawCloudQuadStrip (int x1, int y1, int x2, int y2, int step);
  void drawQuadStrip (int x1, int y1, int x2, int y2, int step);
  void drawTexturedQuad (int x, int y, int step);
  void drawWaterTexturedQuad (int x, int y, int step);
  void drawTexturedTriangle1 (int x, int y, int step);
  void drawTexturedTriangle2 (int x, int y, int step);
  void draw (int phi, int gamma);

  void calcDynamicLight (CExplosion **explo);

  GLLandscape (Space *space2, int type, int *heightmask);
};

int ly [2] [MAXX + 1];

class RTriangle
{
public:
	unsigned short flags;
	unsigned short xh, yh, x1, y1, x2, y2;
  unsigned short visibility;
	RTriangle ();
	RTriangle (int level, int xh, int yh, int x1, int y1, int x2, int y2);
	bool isClean ();
	void setClean ();
	void setDirty ();
	int getLevel ();
	void setLevel (int level);
	void split ();
	void forceSplit (int d);
  void genBorders (int x1, int y1, int x2, int y2, int num);
	bool trySplit (Landscape *l);
};

class RMatrix
{
public:
  RTriangle ****t;
  RMatrix ();
  void allocate (int x, int y);
  void addVertex (RTriangle *t, int x, int y);
  void add (RTriangle *t);
  void removeVertex (RTriangle *t, int x, int y);
  void remove (RTriangle *t);
  RTriangle *getTriangle (unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2);
};

const int meminc = 400000;
int roamlevel = 17; // 18
#define DIVS (MAXX / 16 + 1)
#define DIVFAC 16

class RTriangleList
{
public:
	RTriangle *t;
	int aktlength, maxlength;
	RTriangleList ();
	void reallocate ();
	RTriangle *addTriangle (int level, unsigned short xh, unsigned short yh, unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2);
};

RTriangleList *trilist; // will cast this to RTriangleList later on
RMatrix *trimatrix;
int fsplit = 0;

RTriangle::RTriangle ()
	{
		xh = yh = x1 = x2 = y1 = y2 = 0;
    visibility = 0;
		setDirty ();
	}
RTriangle::RTriangle (int level, int xh, int yh, int x1, int y1, int x2, int y2)
	{
		this->xh = xh;
		this->x1 = x1;
		this->x2 = x2;
		this->yh = yh;
		this->y1 = y1;
		this->y2 = y2;
		setDirty ();
		setLevel (level);
	}
bool RTriangle::isClean ()
	{
		if (flags & 0x100) return true;
		return false;
	}
void RTriangle::setClean ()
	{
		flags |= 0x100;
	}
void RTriangle::setDirty ()
	{
		flags &= 0xFEFF;
	}
int RTriangle::getLevel ()
	{
		return flags & 0xFF;
	}
void RTriangle::setLevel (int level)
	{
		if (level > 127) level = 127;
		if (level < 0) level = 0;
		flags &= 0xFF00;
		flags |= level;
	}
void RTriangle::split ()
	{
		trimatrix->remove (this);
		int px1 = x1, py1 = y1/*, px2 = x2, py2 = y2*/;
		int xm = (x1 + x2) / 2, ym = (y1 + y2) / 2;
		int level = getLevel () + 1;
    if (level % 1)
    {
		  x1 = xh; y1 = yh;
    }
    else
    {
      x1 = x2; y1 = y2;
		  x2 = xh; y2 = yh;
    }
		xh = xm; yh = ym;
		setLevel (level);
		trimatrix->add (this);
		RTriangle *rt;
    if (level % 1)
      rt = trilist->addTriangle (level, xh, yh, px1, py1, x1, y1);
    else
      rt = trilist->addTriangle (level, xh, yh, x2, y2, px1, py1);
		trimatrix->add (rt);
		setDirty ();
	}
void RTriangle::forceSplit (int d)
	{
		int px1 = x1, py1 = y1, px2 = x2, py2 = y2;
		split ();
		RTriangle *t = trimatrix->getTriangle (px1, py1, px2, py2);
				fsplit ++;
    if (d > 5) printf (" %d ", d);
		if (t != NULL)
		{
			if ((t->xh == px1 && t->yh == py1) || (t->xh == px2 && t->yh == py2))
			{
				t->forceSplit (d + 1);
				t = trimatrix->getTriangle (px1, py1, px2, py2);
				t->forceSplit (d + 1);
			}
			else
			{
				t->forceSplit (d + 1);
			}
		}
	}

void RTriangle::genBorders (int x1, int y1, int x2, int y2, int num)
  {
    if (y2 < y1)
    {
      int temp = y1;
      y1 = y2;
      y2 = temp;
      temp = x1;
      x1 = x2;
      x2 = temp;
    }
    int dy = y2 - y1 + 1;
    int dx = x2 - x1 + 1;
    float m = (float) dx / dy;
    float pos = x1;
    for (int i = 0; i < dy; i ++)
    {
      ly [num] [y1 + i] = (int) pos;
      pos += m;
    }
  }

bool RTriangle::trySplit (Landscape *l)
	{
		int i, i2;
    int temp;
		if (getLevel () <= 7)
		{
			forceSplit (0);
			return true;
		}
    int px [3], py [3];
    GLLandscape *glland = (GLLandscape *) l;
    px [0] = x1; px [1] = x2; px [2] = xh;
    py [0] = y1; py [1] = y2; py [2] = yh;
    for (i = 1; i < 3; i ++)
      for (i2 = 0; i2 < i; i2 ++)
        if (py [i] < py [i2])
        {
          temp = px [i]; px [i] = px [i2]; px [i2] = temp;
          temp = py [i]; py [i] = py [i2]; py [i2] = temp;
        }
    if (px [1] <= px [0] && px [1] <= px [2])
    {
      genBorders (px [0], py [0], px [1], py [1], 0);
      genBorders (px [1], py [1], px [2], py [2], 0);
      genBorders (px [0], py [0], px [2], py [2], 1);
    }
    else
    {
      genBorders (px [0], py [0], px [1], py [1], 1);
      genBorders (px [1], py [1], px [2], py [2], 1);
      genBorders (px [0], py [0], px [2], py [2], 0);
    }
//		bool split = false;
    int ct = 150, lt = 500;

    int dx = abs (px[0]-px[1]);
    int dx2 = abs (px[2]-px[1]);
    int dx3 = abs (px[2]-px[0]);
    dx = dx2>dx?dx2:dx;
    dx = dx3>dx?dx3:dx;
    int dy = abs (py[0]-py[1]);
    int dy2 = abs (py[2]-py[1]);
    int dy3 = abs (py[2]-py[0]);
    dy = dy2>dy?dy2:dy;
    dy = dy3>dy?dy3:dy;
    if (dx <= 2 && dy <= 2)
      dy=dy;

    if (abs (glland->b[px[0]][py[0]]-glland->b[px[1]][py[1]]) > ct) { forceSplit (0); return true; }
    if (abs (glland->b[px[0]][py[0]]-glland->b[px[2]][py[2]]) > ct) { forceSplit (0); return true; }
    if (abs (glland->b[px[1]][py[1]]-glland->b[px[2]][py[2]]) > ct) { forceSplit (0); return true; }
    if (abs (glland->g[px[0]][py[0]]-glland->g[px[1]][py[1]]) > ct) { forceSplit (0); return true; }
    if (abs (glland->g[px[0]][py[0]]-glland->g[px[2]][py[2]]) > ct) { forceSplit (0); return true; }
    if (abs (glland->g[px[1]][py[1]]-glland->g[px[2]][py[2]]) > ct) { forceSplit (0); return true; }
    if (abs (glland->r[px[0]][py[0]]-glland->r[px[1]][py[1]]) > ct) { forceSplit (0); return true; }
    if (abs (glland->r[px[0]][py[0]]-glland->r[px[2]][py[2]]) > ct) { forceSplit (0); return true; }
    if (abs (glland->r[px[1]][py[1]]-glland->r[px[2]][py[2]]) > ct) { forceSplit (0); return true; }
    if (abs (glland->nl[px[0]][py[0]]-glland->nl[px[1]][py[1]]) > lt) { forceSplit (0); return true; }
    if (abs (glland->nl[px[0]][py[0]]-glland->nl[px[2]][py[2]]) > lt) { forceSplit (0); return true; }
    if (abs (glland->nl[px[1]][py[1]]-glland->nl[px[2]][py[2]]) > lt) { forceSplit (0); return true; }
    for (i = py [0]; i <= py [2]; i ++)
      for (i2 = ly [0] [i]; i2 <= ly [1] [i]; i2 ++)
      {
    		float reqheight = (float) glland->h[px[0]][py[0]]*(px[2]-i2)*(py[2]-i) + glland->h[px[2]][py[0]]*(i2-px[0])*(py[2]-i) +
			                            glland->h[px[0]][py[2]]*(px[2]-i2)*(i-py[0]) + glland->h[px[2]][py[2]]*(i2-px[0])*(i-py[0]);
		    reqheight /= (float) (py[2]-py[0])*(px[2]-px[0]);
		    if (fabs (glland->h[i2][i]-reqheight) > 250)
		    {
			    forceSplit (0); return true;
		    }
	    }
		// else
		setClean ();
		return false;
	}

RTriangleList::RTriangleList ()
	{
    aktlength = 0;
    maxlength = meminc;
	  t = (RTriangle *) malloc (maxlength * sizeof (RTriangle));
	if (t == NULL)
	{
		printf ("Out of memory"); fflush (stdout);
		exit (1);
	}
	}
void RTriangleList::reallocate ()
	{
		if (aktlength < maxlength) return;
		printf ("Calloc"); fflush (stdout);
		maxlength += meminc;
		t = (RTriangle *) realloc (t, maxlength * sizeof (RTriangle));
	}
RTriangle *RTriangleList::addTriangle (int level, unsigned short xh, unsigned short yh, unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2)
	{
		reallocate ();
    RTriangle *tr = &t [aktlength];
    tr->x1 = x1; tr->x2 = x2; tr->xh = xh;
    tr->y1 = y1; tr->y2 = y2; tr->yh = yh;
    tr->setLevel (level);
    tr->setDirty ();
		aktlength ++;
    return tr;
	}

RMatrix::RMatrix ()
{
	t = (RTriangle ****) malloc ((MAXX + 1) * sizeof (RTriangle ***));
	for (int i = 0; i < MAXX + 1; i ++)
	{
		t [i] = (RTriangle ***) malloc ((MAXX + 1) * sizeof (RTriangle **));
		for (int i2 = 0; i2 < MAXX + 1; i2 ++)
			t [i] [i2] = NULL;
	}
printf ("size=%d", sizeof (RTriangle *)); fflush (stdout);
printf ("size=%d", sizeof (RTriangle)); fflush (stdout);

}

void RMatrix::allocate (int x, int y)
{
  t [y] [x] = (RTriangle **) malloc (8 * sizeof (RTriangle *));
  for (int i = 0; i < 8; i ++)
    t [y] [x] [i] = NULL;
}

void RMatrix::addVertex (RTriangle *rt, int x, int y)
{
  if (t [y] [x] == NULL)
    allocate (x, y);
  for (int i = 0; i < 8; i ++)
    if (t [y] [x] [i] == 0x0)
    {
      t [y] [x] [i] = rt;
      return;
    }
  printf ("Fehler!\n");
  fflush (stdout);
}

void RMatrix::add (RTriangle *rt)
{
  addVertex (rt, rt->x1, rt->y1);
  addVertex (rt, rt->x2, rt->y2);
  addVertex (rt, rt->xh, rt->yh);
}

void RMatrix::removeVertex (RTriangle *rt, int x, int y)
{
  for (int i = 0; i < 8; i ++)
    if (t [y] [x] [i] == rt)
    {
      t [y] [x] [i] = NULL;
      return;
    }
}

void RMatrix::remove (RTriangle *rt)
{
  removeVertex (rt, rt->x1, rt->y1);
  removeVertex (rt, rt->x2, rt->y2);
  removeVertex (rt, rt->xh, rt->yh);
}

RTriangle *RMatrix::getTriangle (unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2)
{
  RTriangle *rt;
  if (t [y1] [x1] == NULL)
    return NULL;
  for (int i = 0; i < 8; i ++)
  {
    rt = t [y1] [x1] [i];
    if (rt != NULL)
      if ((x1 == rt->x1 && y1 == rt->y1) ||
          (x1 == rt->x2 && y1 == rt->y2) ||
          (x1 == rt->xh && y1 == rt->yh))
        if ((x2 == rt->x1 && y2 == rt->y1) ||
            (x2 == rt->x2 && y2 == rt->y2) ||
            (x2 == rt->xh && y2 == rt->yh))
          return rt;
  }
  return NULL;
}


//	RTriangle ****trimatrix;
void RTerrain::roam (Landscape *l)
	{
		int level = 1;
//		int i = 0;
    trimatrix = new RMatrix ();
		trilist = new RTriangleList ();
    RTriangle *rt;
		rt = trilist->addTriangle (1, 0, 0, MAXX, 0, 0, MAXX);
    trimatrix->add (rt);
		rt = trilist->addTriangle (1, MAXX, MAXX, 0, MAXX, MAXX, 0);
    trimatrix->add (rt);
		while (level <= roamlevel)
		{
      int n = trilist->aktlength;
      for (int i = 0; i < n; i ++)
//			if (!trilist->t [i].isClean ())
				if (trilist->t [i].getLevel () == level)
					if (trilist->t [i].trySplit (l))
					{
					}
level ++;
		}
    printf ("splits = %d\n", fsplit);
/*  trimatrix = (RTriangle ****) malloc ((MAXX + 1) * sizeof (RTriangle ***));
		for (i = 0; i < MAXX + 1; i ++)
		{
			trimatrix [i] = (RTriangle ***) malloc ((MAXX + 1) * sizeof (RTriangle **));
			for (int i2 = 0; i2 < MAXX + 1; i2 ++)
				trimatrix [i] [i2] = NULL;
		}
for (int ty = 0; ty < DIVS; ty ++)
  for (int tx = 0; tx < DIVS; tx ++)
		for (i = 0; i < trilist->aktlength [ty] [tx]; i ++)
		{
			int i2;
			int x, y;

			x = trilist->t [ty] [tx] [i].xh; y = trilist->t [ty] [tx] [i].yh;
			if (trimatrix [y] [x] == NULL)
			{
				trimatrix [y] [x] = (RTriangle **) malloc (8 * sizeof (RTriangle *));
				for (i2 = 0; i2 < 8; i2 ++)
					trimatrix [y] [x] [i2] = NULL;
			}
			i2 = 0;
			while (trimatrix [y] [x] [i2] != NULL) i2 ++;
			
			trimatrix [y] [x] [i2] = &trilist->t [ty] [tx] [i];
			x = trilist->t [ty] [tx] [i].x1; y = trilist->t [ty] [tx] [i].y1;
			if (trimatrix [y] [x] == NULL)
			{
				trimatrix [y] [x] = (RTriangle **) malloc (8 * sizeof (RTriangle *));
				for (i2 = 0; i2 < 8; i2 ++)
					trimatrix [y] [x] [i2] = NULL;
			}
			i2 = 0;
			while (trimatrix [y] [x] [i2] != NULL) i2 ++;
			trimatrix [y] [x] [i2] = &trilist->t [ty] [tx] [i];
			
			x = trilist->t [ty] [tx] [i].x2; y = trilist->t [ty] [tx] [i].y2;
			if (trimatrix [y] [x] == NULL)
			{
				trimatrix [y] [x] = (RTriangle **) malloc (8 * sizeof (RTriangle *));
				for (i2 = 0; i2 < 8; i2 ++)
					trimatrix [y] [x] [i2] = NULL;
			}
			i2 = 0;
			while (trimatrix [y] [x] [i2] != NULL) i2 ++;
			trimatrix [y] [x] [i2] = &trilist->t [ty] [tx] [i];
		}*/

	}





/****************************************************************************
Praktikum ACG
****************************************************************************/


const int maxfighter = 10, maxlaser = 120, maxmissile = 30, maxexplosion = 30, maxstar = 70, maxgroundobj = 10;

int camera = 0;
float camx = 0, camy = 0, camz = 0, camphi = 0, camgamma = 0, camtheta = 0;
float sunlight;
CTexture *texsun, *texflare, *texgrass, *texrocks, *texwater, *textree, *textree2, *textree3, *texfont1, *texmoon, *texcross, *texcross2, *texredstone, *textree4, *texearth;

//#define PARTS 6

void GLLandscape::norm (float *c)
  {
    float n;
    n = 1.0/sqrt(c[0]*c[0]+c[1]*c[1]+c[2]*c[2]);
    c[0] *= n;
    c[1] *= n;
    c[2] *= n;
  }

void GLLandscape::normalcrossproduct( float* a, float* b, float*c )
  {
    c[0] = a[1]*b[2] - a[2]*b[1];
    c[1] = a[2]*b[0] - a[0]*b[2];
    c[2] = a[0]*b[1] - a[1]*b[0];
    norm (c);
  }

float *GLLandscape::selectMaterial (int x, int y)
  {
    if (f [x] [y] == GRASS) return mata [0];
    else if (f [x] [y] >= CONIFEROUSWOODS1 && f [x] [y] <= MIXEDWOODS3) return mata [1];
    else if (f [x] [y] == ROCKS) return mata [2];
    else if (f [x] [y] == GLACIER) return mata [3];
    else if (f [x] [y] >= DWARFPINES1 && f [x] [y] <= BUSHES3) return mata [1];
    else if (f [x] [y] == WATER) return mata [5];
    else if (f [x] [y] == SHALLOWWATER) return mata [4];
    else if (f [x] [y] == DEEPWATER) return mata [6];
    else if (f [x] [y] == ROCKS2) return mata [7];
    else if (f [x] [y] == XSHALLOWWATER) return mata [8];
    else if (f [x] [y] == XDEEPWATER) return mata [9];
    else if (f [x] [y] == MOONSAND) return mata [10];
    else if (f [x] [y] == REDSTONE) return mata [11];
    else if (f [x] [y] == REDSAND || f [x] [y] == REDTREE0) return mata [12];
    else return mat [0];
  }

int GLLandscape::selectColor (int x, int y)
  {
    if (f [x] [y] == GRASS) return 0;
    else if (f [x] [y] >= CONIFEROUSWOODS1 && f [x] [y] <= MIXEDWOODS3) return 1;
    else if (f [x] [y] == ROCKS) return 2;
    else if (f [x] [y] == GLACIER) return 3;
    else if (f [x] [y] >= DWARFPINES1 && f [x] [y] <= BUSHES3) return 1;
    else if (f [x] [y] == WATER) return 5;
    else if (f [x] [y] == SHALLOWWATER) return 4;
    else if (f [x] [y] == DEEPWATER) return 6;
    else if (f [x] [y] == ROCKS2) return 7;
    else if (f [x] [y] == XSHALLOWWATER) return 8;
    else if (f [x] [y] == XDEEPWATER) return 9;
    else if (f [x] [y] == MOONSAND) return 10;
    else if (f [x] [y] == REDSTONE) return 11;
    else if (f [x] [y] == REDSAND || f [x] [y] == REDTREE0) return 12;
    else return 0;
  }

void GLLandscape::precalculate ()
  {
    int i, i2, i3, i4, x, z;
    float no[3];
    float nw[3];
    float so[3];
    float sw[3];
    float a[3];
    float c[3];

    memset (dl, 0, (MAXX + 1) * (MAXX + 1));

    norm (lv);

// Set the colors of the landscape
    float mzoom = zoomz;
    for(x=0;x<=MAXX;x++)
      for(z=0;z<=MAXX;z++)
      {
        int a;
        a = selectColor (x, z);
        if (type == 2 && a == 4)
        {
          a = 11;
        }
        r [x] [z] = (unsigned char) (mat [a] [0] * 255.9);
        g [x] [z] = (unsigned char) (mat [a] [1] * 255.9);
        b [x] [z] = (unsigned char) (mat [a] [2] * 255.9);
//        printf ("a=%d, r=%d, g=%d, b=%d\n", a, r[x][z],g[x][z],b[x][z]); fflush (stdout);
      }

// Smooth the colors
	long sum;
/*	long g3[3][3]={{0,1,0},
					{1,4,1},
					{0,1,0}};*/
    /*for (i = 1; i < MAXX; i ++)
      for (i2 = 1; i2 < MAXX; i2 ++)
      {
        sum = 0;
        for (i3 = 0; i3 < 3; i3 ++)
          for (i4 = 0; i4 < 3; i4 ++)
          {
            sum += g3[i3][i4] * r[i+i3-1][i2+i4-1];
          }
        sum /= 8;
        lg[i][i2]=sum;
      }
    for (i = 1; i <= MAXX - 1; i ++)
      for (i2 = 1; i2 <= MAXX - 1; i2 ++)
      {
        r [i] [i2] = (unsigned char) lg [i] [i2];
      }
    for (i = 1; i < MAXX; i ++)
      for (i2 = 1; i2 < MAXX; i2 ++)
      {
        sum = 0;
        for (i3 = 0; i3 < 3; i3 ++)
          for (i4 = 0; i4 < 3; i4 ++)
          {
            sum += g3[i3][i4] * g[i+i3-1][i2+i4-1];
          }
        sum /= 8;
        lg[i][i2]=sum;
      }
    for (i = 1; i <= MAXX - 1; i ++)
      for (i2 = 1; i2 <= MAXX - 1; i2 ++)
      {
        g [i] [i2] = (unsigned char) lg [i] [i2];
      }
    for (i = 1; i < MAXX; i ++)
      for (i2 = 1; i2 < MAXX; i2 ++)
      {
        float sum = 0;
        for (i3 = 0; i3 < 3; i3 ++)
          for (i4 = 0; i4 < 3; i4 ++)
          {
            sum += g3[i3][i4] * b[i+i3-1][i2+i4-1];
          }
        sum /= 8;
        lg[i][i2]=sum;
      }
    for (i = 1; i <= MAXX - 1; i ++)
      for (i2 = 1; i2 <= MAXX - 1; i2 ++)
      {
        b [i] [i2] = (unsigned char) lg [i] [i2];
      }*/

// Set the height mask for the lowest sunrays touching the landscape's surface
// This is just an approximation presuming the sun is a vertical line
    float m1 = mzoom / hh;
    float ih = tan ((sungamma + 10) * mypi / 180) / m1; // 10 degree vertical sun radius
	for (x = 0; x <= MAXX; x ++)
	{
	  float rayheight = hw [x] [MAXX];
      for (z = MAXX; z >= 0; z --)
	  {
		unsigned short maxheight = (int) rayheight;
		if (rayheight < hw [x] [z])
		{
	      rayheight = hw [x] [z];
		  maxheight = hw [x] [z];
		}
		rayheight -= ih;
		hray [x] [z] = maxheight;
	  }
	}

    int nlwater = 1200 - (int) (1000.0 * 2.0 * fabs ((90.0 - sungamma) * mypi / 180.0) / mypi);

// Set the luminance of the landscape
    for (x = 0; x <= MAXX; x ++)
      for (z = 0; z <= MAXX; z ++)
      {
        int xm1 = getCoord (x - 1);
        int xp1 = getCoord (x + 1);
        int zm1 = getCoord (z - 1);
        int zp1 = getCoord (z + 1);
// Calculate the normal vectors
      a[0] = 0;
      a[1] = (float) (hw[x][zm1] - hw[x][z]) * mzoom;
      a[2] = -hh;
      c[0] = -hh;
      c[1] = (float) (hw[xm1][z] - hw[x][z]) * mzoom;
      c[2] =  0;
      normalcrossproduct( a, c, nw );
      a[0] = hh;
      a[1] = (float) (hw[xp1][z] - hw[x][z]) * mzoom;
      a[2] = 0;
      c[0] = 0;
      c[1] = (float) (hw[x][zm1] - hw[x][z]) * mzoom;
      c[2] = -hh;
      normalcrossproduct( a, c, no );
      a[0] = 0;
      a[1] = (float) (hw[x][zp1] - hw[x][z]) * mzoom;
      a[2] = hh;
      c[0] = hh;
      c[1] = (float) (hw[xp1][z] - hw[x][z]) * mzoom;
      c[2] = 0;
      normalcrossproduct( a, c, so );
      a[0] = -hh;
      a[1] = (float) (hw[xm1][z] - hw[x][z]) * mzoom;
      a[2] =  0;
      c[0] = 0;
      c[1] = (float) (hw[x][zp1] - hw[x][z]) * mzoom;
      c[2] = hh;
      normalcrossproduct( a, c, sw );
      float normx = (no[0] + nw[0] + so[0] + sw[0]) / 4.0;
      float normy = (no[1] + nw[1] + so[1] + sw[1]) / 4.0;
      float normz = (no[2] + nw[2] + so[2] + sw[2]) / 4.0;
// Calculate the light hitting the surface
      float gamma = (float) acos (normx * lv [0] + normy * lv [1] + normz * lv [2]);
      if (!isWater (f [x] [z]))
      {
        nl [x] [z] = 1200 - (int) (1000.0 * 2.0 * fabs (gamma) / mypi);
      }
      else
        nl [x] [z] = nlwater;
      if (nl [x] [z] < 0) nl [x] [z] = 0;
/*      float vh = (float) h [x] [z];
      for (i = z + 1; i < MAXX; i ++)
      {
        vh += ih;
        if (h [x] [i] > vh)
        {
          nl [x] [z] /= 2;
          break;
        }
        if (i > z + 100) break;
      }*/
// Check whether this point is in the shadow of some mountain
      if (hw [x] [z] < hray [x] [z]) nl [x] [z] /= 2;
/*      if (isWater (f [x] [z]))
      {
        if (nl [x] [z] > 0.75) nl [x] [z] = 50.0;
      }*/
      }

    
// Smooth the luminance (very important)
	long g3_1[3][3]={{1,2,1},
                      {2,4,2},
                      {1,2,1}};
    for (i = 1; i <= MAXX - 1; i ++)
      for (i2 = 1; i2 <= MAXX - 1; i2 ++)
      {
        sum = 0;
        for (i3 = 0; i3 < 3; i3 ++)
          for (i4 = 0; i4 < 3; i4 ++)
          {
            sum += g3_1[i3][i4] * nl[i+i3-1][i2+i4-1];
          }
        sum /= 16;
        lg[i][i2]=sum;
      }
    for (i = 1; i <= MAXX - 1; i ++)
      for (i2 = 1; i2 <= MAXX - 1; i2 ++)
      {
        nl [i] [i2] = lg [i] [i2];
      }
//	rt = new RTerrain ();
//	rt->roam ((Landscape *) this);

    for (i = 0; i < MAXX; i ++)
      for (i2 = 0; i2 < MAXX; i2 ++)
      {
        drawrule [i] [i2] = 0;
        
        int f1 = f [i] [i2], f2 = f [i + 1] [i2], f3 = f [i] [i2 + 1], f4 = f [i + 1] [i2 + 1];
        if (isType (f1, GRASS) || isWoods (f1) || isType (f1, MOONSAND) || isType (f1, REDSAND) || isType (f1, REDTREE0))
          tex1 [i] [i2] = texgrass->textureID;
        else if (isWater (f1))
        {
/*          if (isWater (f2) && isWater (f3) && isWater (f4))
            tex1 [i] [i2] = texwater;
          else*/
          if (type == 0 || type == 2)
            tex1 [i] [i2] = texgrass->textureID;
          else if (type == 1)
            tex1 [i] [i2] = 0xFF;
        }
        else if (isType (f1, ROCKS) || isType (f1, ROCKS2))
          tex1 [i] [i2] = texrocks->textureID;
        else if (isType (f1, REDSTONE))
          tex1 [i] [i2] = texredstone->textureID;
        else
          tex1 [i] [i2] = 0xFF;
       
/*        if (!isWater (f1) && isWater (f2) && isWater (f3) && isWater (f4))
        { drawrule [i] [i2] = 1; tex1 [i] [i2] = texgrass; tex2 [i] [i2] = texwater; }
        if (isWater (f1) && !isWater (f2) && !isWater (f3) && !isWater (f4))
        { drawrule [i] [i2] = 1; tex1 [i] [i2] = texgrass; tex2 [i] [i2] = texgrass; }
        if (!isWater (f1) && !isWater (f2) && !isWater (f3) && isWater (f4))
        { drawrule [i] [i2] = 1; tex1 [i] [i2] = texgrass; tex2 [i] [i2] = texgrass; }
        if (isWater (f1) && isWater (f2) && isWater (f3) && !isWater (f4))
        { drawrule [i] [i2] = 1; tex1 [i] [i2] = texwater; tex2 [i] [i2] = texgrass; }
        
        if (isWater (f1) && !isWater (f2) && isWater (f3) && isWater (f4))
        { drawrule [i] [i2] = 2; tex1 [i] [i2] = texgrass; tex2 [i] [i2] = texwater; }
        if (!isWater (f1) && isWater (f2) && !isWater (f3) && !isWater (f4))
        { drawrule [i] [i2] = 2; tex1 [i] [i2] = texgrass; tex2 [i] [i2] = texgrass; }
        if (!isWater (f1) && !isWater (f2) && isWater (f3) && !isWater (f4))
        { drawrule [i] [i2] = 2; tex1 [i] [i2] = texgrass; tex2 [i] [i2] = texgrass; }
        if (isWater (f1) && isWater (f2) && !isWater (f3) && isWater (f4))
        { drawrule [i] [i2] = 2; tex1 [i] [i2] = texwater; tex2 [i] [i2] = texgrass; }*/

//        if (isWater (f1) || isWater (f2) || isWater (f3) || isWater (f4))
//        { tex1 [i] [i2] = texwater; }

        if (!isGlacier (f1) && isGlacier (f2) && isGlacier (f3) && isGlacier (f4))
        { drawrule [i] [i2] = 1; tex1 [i] [i2] = texrocks->textureID; tex2 [i] [i2] = 0xFF; }
        if (isGlacier (f1) && !isGlacier (f2) && !isGlacier (f3) && !isGlacier (f4))
        { drawrule [i] [i2] = 1; tex1 [i] [i2] = texrocks->textureID; tex2 [i] [i2] = texrocks->textureID; }
        if (!isGlacier (f1) && !isGlacier (f2) && !isGlacier (f3) && isGlacier (f4))
        { drawrule [i] [i2] = 1; tex1 [i] [i2] = texrocks->textureID; tex2 [i] [i2] = texrocks->textureID; }
        if (isGlacier (f1) && isGlacier (f2) && isGlacier (f3) && !isGlacier (f4))
        { drawrule [i] [i2] = 1; tex1 [i] [i2] = 0xFF; tex2 [i] [i2] = texrocks->textureID; }
        
        if (isGlacier (f1) && !isGlacier (f2) && isGlacier (f3) && isGlacier (f4))
        { drawrule [i] [i2] = 2; tex1 [i] [i2] = texrocks->textureID; tex2 [i] [i2] = 0xFF; }
        if (!isGlacier (f1) && isGlacier (f2) && !isGlacier (f3) && !isGlacier (f4))
        { drawrule [i] [i2] = 2; tex1 [i] [i2] = texrocks->textureID; tex2 [i] [i2] = texrocks->textureID; }
        if (!isGlacier (f1) && !isGlacier (f2) && isGlacier (f3) && !isGlacier (f4))
        { drawrule [i] [i2] = 2; tex1 [i] [i2] = texrocks->textureID; tex2 [i] [i2] = texrocks->textureID; }
        if (isGlacier (f1) && isGlacier (f2) && !isGlacier (f3) && isGlacier (f4))
        { drawrule [i] [i2] = 2; tex1 [i] [i2] = 0xFF; tex2 [i] [i2] = texrocks->textureID; }
      }

  }

void GLLandscape::subdivide (int x1, int y1, int x2, int y2)
  {
/*    int i, i2;
	int w = x2-x1+1;
	bool split = false;
	if (w == 2)
	{ rect [y1] [x1] = 1; return; }
    for (i = y1; i <= y2; i ++)
      for (i2 = x1; i2 <= x2; i2 ++)
      {
		float reqheight = (float) h[y1][x1]*(y2-i)*(x2-i2) + h[y2][x1]*(i-y1)*(x2-i2) +
			                      h[y1][x2]*(y2-i)*(i2-x1) + h[y2][x2]*(i-y1)*(i2-x1);
		reqheight /= (float) (y2-y1)*(x2-x1);
		if (abs (h[i][i2]-reqheight) > 100)
		{ split = true; goto fertig; }
	  }
fertig:
	if (split)
	{
	  subdivide (x1,y1,x1+w/2,y1+w/2);
	  subdivide (x1,y1+w/2,x1+w/2,y2);
	  subdivide (x1+w/2,y1,x2,y1+w/2);
	  subdivide (x1+w/2,y1+w/2,x2,y2);
	}
	else
	{
      for (i = y1; i <= y2; i ++)
        for (i2 = x1; i2 <= x2; i2 ++)
		{
		  rect [i] [i2] = w - 1;
		  float reqheight = (float) h[y1][x1]*(y2-i)*(x2-i2) + h[y2][x1]*(i-y1)*(x2-i2) +
		 	                        h[y1][x2]*(y2-i)*(i2-x1) + h[y2][x2]*(i-y1)*(i2-x1);
		  reqheight /= (float) (y2-y1)*(x2-x1);
		  h [i] [i2] = reqheight;
		}
	}*/
  }

int GLLandscape::getCoord (int a)
{
/*  if (a < 0) return -a;
  else if (a >= MAXX) return 2 * MAXX - a - 1;
  return a;*/
  while (a < 0) a += MAXX;
  while (a >= MAXX) a -= MAXX;
  return a;
}

float GLLandscape::getCoord (float a)
{
/*  if (a < 0) return -a;
  else if (a >= MAXX) return (float) 2 * MAXX - a - 1;
  return a;*/
  while (a < 0) a += MAXX;
  while (a >= MAXX) a -= MAXX;
  return a;
}

float GLLandscape::getHeight (float x, float z)
  {
    int mx = getCoord ((int)x+MAXX/2);
    int mz = getCoord (MAXX/2-(int)z);
    return (ZOOM * ((float)hw[mx][mz]*zoomz - zoomz2));
  }

float GLLandscape::getExactHeight (float x, float z)
  {
    float mx = getCoord (x+MAXX/2);
    float mz = getCoord ((float)MAXX/2-z);
	int mx1 = (int) mx;
	int mx2 = mx1 + 1;
	int mz1 = (int) mz;
	int mz2 = mz1 + 1;
	float h2 = (float)hw[mx1][mz1]*((float)mx2-mx)*((float)mz2-mz) + (float)hw[mx2][mz1]*(mx-mx1)*((float)mz2-mz) +
		       (float)hw[mx1][mz2]*((float)mx2-mx)*(mz-mz1) + (float)hw[mx2][mz2]*(mx-mx1)*(mz-mz1);
    return (ZOOM * (h2*zoomz - zoomz2));
  }

float GLLandscape::getExactLSHeight (float x, float z)
  {
    float mx = getCoord (x);
    float mz = getCoord (z);
	int mx1 = (int) mx;
	int mx2 = mx1 + 1;
	int mz1 = (int) mz;
	int mz2 = mz1 + 1;
	float h2 = (float)hw[mx1][mz1]*((float)mx2-mx)*((float)mz2-mz) + (float)hw[mx2][mz1]*(mx-mx1)*((float)mz2-mz) +
		       (float)hw[mx1][mz2]*((float)mx2-mx)*(mz-mz1) + (float)hw[mx2][mz2]*(mx-mx1)*(mz-mz1);
    return (h2*zoomz - zoomz2);
  }

float GLLandscape::getRayHeight (float x, float z)
  {
    int mx = getCoord ((int)x+MAXX/2);
    int mz = getCoord (MAXX/2-(int)z);
    return (ZOOM * ((float)hray[mx][mz]*zoomz - zoomz2));
  }

float GLLandscape::getExactRayHeight (float x, float z)
  {
    float mx = getCoord (x+MAXX/2);
    float mz = getCoord ((float)MAXX/2-z);
	int mx1 = (int) mx;
	int mx2 = mx1 + 1;
	int mz1 = (int) mz;
	int mz2 = mz1 + 1;
	float h2 = (float)hray[mx1][mz1]*((float)mx2-mx)*((float)mz2-mz) + (float)hray[mx2][mz1]*(mx-mx1)*((float)mz2-mz) +
		       (float)hray[mx1][mz2]*((float)mx2-mx)*(mz-mz1) + (float)hray[mx2][mz2]*(mx-mx1)*(mz-mz1);
    return (ZOOM * (h2*zoomz - zoomz2));
  }

void GLLandscape::drawRotatedTree (float x, float y, float htree, float wtree, int phi)
  {
    float ht = getExactLSHeight (x, y);
	float ex1 = cosi [phi] * wtree, ey1 = sine [phi] * wtree;
	float ex2 = -ex1, ey2 = -ey1;
  int myticker;
  float zy = 0;
  if (weather == 1)
  {
    myticker = (int) (0.05 / htree * lsticker + 1000 * wtree + (x + y) * 50);
    if (myticker != 0)
      myticker %= 360;
    zy = 0.2 * (2.0 + sine [myticker]);
  }
    glBegin (GL_QUADS);
    glColor3ub (treecolor.c [0], treecolor.c [1], treecolor.c [2]);
    glTexCoord2d (0, 1);
    glVertex3f (hh2*(ex1+x) - 1.0, ht + htree, hh2*(MAXX-(ey1+y+zy)) - 1.0);
    glTexCoord2d (1, 1);
    glVertex3f (hh2*(ex2+x) - 1.0, ht + htree, hh2*(MAXX-(ey2+y+zy)) - 1.0);
    glTexCoord2d (1, 0);
    glVertex3f (hh2*(ex2+x) - 1.0, ht, hh2*(MAXX-(ey2+y)) - 1.0);
    glTexCoord2d (0, 0);
    glVertex3f (hh2*(ex1+x) - 1.0, ht, hh2*(MAXX-(ey1+y)) - 1.0);
    glEnd ();
/*    glBegin (GL_QUADS);
    glTexCoord2d (0, 1);
    glVertex3f (hh2*(x) - 1.0, ht + htree, hh2*(MAXX-(-wtree+y)) - 1.0);
    glTexCoord2d (1, 1);
    glVertex3f (hh2*(x) - 1.0, ht + htree, hh2*(MAXX-(wtree+y)) - 1.0);
    glTexCoord2d (1, 0);
    glVertex3f (hh2*(x) - 1.0, ht, hh2*(MAXX-(wtree+y)) - 1.0);
    glTexCoord2d (0, 0);
    glVertex3f (hh2*(x) - 1.0, ht, hh2*(MAXX-(-wtree+y)) - 1.0);
    glEnd ();*/
  }

void GLLandscape::drawTree (float x, float y, float htree, float wtree, int phi)
  {
	if (quality < 4)
	{
	  drawRotatedTree (x, y, htree, wtree, phi);
	  return;
	}
    float ht = getExactLSHeight (x, y);
  int myticker;
  float zy = 0;
  if (weather == 1)
  {
    myticker = (int) (0.05 / htree * lsticker + 1000 * wtree + (x + y) * 50);
    if (myticker != 0)
      myticker %= 360;
    zy = 0.2 * (2.0 + sine [myticker]);
  }
    glBegin (GL_QUADS);
    glColor3ub (treecolor.c [0], treecolor.c [1], treecolor.c [2]);
    glTexCoord2d (0, 1);
    glVertex3f (hh2*(-wtree+x) - 1.0, ht + htree, hh2*(MAXX-(y+zy)) - 1.0);
    glTexCoord2d (1, 1);
    glVertex3f (hh2*(wtree+x) - 1.0, ht + htree, hh2*(MAXX-(y+zy)) - 1.0);
    glTexCoord2d (1, 0);
    glVertex3f (hh2*(wtree+x) - 1.0, ht, hh2*(MAXX-(y)) - 1.0);
    glTexCoord2d (0, 0);
    glVertex3f (hh2*(-wtree+x) - 1.0, ht, hh2*(MAXX-(y)) - 1.0);
    glEnd ();
    glBegin (GL_QUADS);
    glTexCoord2d (0, 1);
    glVertex3f (hh2*(x) - 1.0, ht + htree, hh2*(MAXX-(-wtree+y+zy)) - 1.0);
    glTexCoord2d (1, 1);
    glVertex3f (hh2*(x) - 1.0, ht + htree, hh2*(MAXX-(wtree+y+zy)) - 1.0);
    glTexCoord2d (1, 0);
    glVertex3f (hh2*(x) - 1.0, ht, hh2*(MAXX-(wtree+y)) - 1.0);
    glTexCoord2d (0, 0);
    glVertex3f (hh2*(x) - 1.0, ht, hh2*(MAXX-(-wtree+y)) - 1.0);
    glEnd ();
  }

int visibility = 0;

void GLLandscape::drawCloudQuadStrip (int x1, int y1, int x2, int y2, int step)
{
  int x, y, xs, ys;
  float cr;

  glDisable (GL_TEXTURE_2D);
  glPushMatrix ();
  glRotatef (-40, 1, 0, 0);
    
  for (xs = x1; xs < x2;)
  {
    glBegin (GL_QUAD_STRIP);
    x = getCoord (xs);
    for (ys = y2 - 1; ys >= y1;)
    {
      y = getCoord (ys);
//	    if (gl->isCubeInFrustum (hh2*(xs) - 1.0, (float)(60000)*zoomz - zoomz2, hh2*(MAXX-(ys)) - 1.0, hh2*2*step))
      {
		    int xstep = getCoord (x + step);
          cr = g [x] [y];
          float fac = 0.5 * sunlight / 256.0;
          cr = (float) cr * fac;
          if (cr >= 1.0) cr = 1.0;
          glColor3f (cr, cr, cr);
          glVertex3f (hh2*xs - 1.0, (float)(50000)*zoomz - zoomz2, hh2*(MAXX-ys) - 1.0);
          cr = g [x+step] [y];
          fac = 0.5 * sunlight / 256.0;
          cr = (float) cr * fac;
          if (cr >= 1.0) cr = 1.0;
          glColor3f (cr, cr, cr);
          glVertex3f (hh2*(xs+step) - 1.0, (float)(50000)*zoomz - zoomz2, hh2*(MAXX-ys) - 1.0);
      }
      ys -= step;
    }
    xs += step;
    glEnd ();
  }

  glPopMatrix ();
}

void GLLandscape::drawQuadStrip (int x1, int y1, int x2, int y2, int step)
{
  int x, y, xs, ys;
  float cr, cg, cb;
  bool water = false;
  float texlight = 1.0;
  bool last = false;

  glDisable (GL_TEXTURE_2D);
    
  for (xs = x1; xs < x2;)
  {
//    glBegin (GL_QUAD_STRIP);
	x = getCoord (xs);
    for (ys = y1; ys < y2;)
    {
      y = getCoord (ys);
	    if (gl->isCubeInFrustum (hh2*(xs) - 1.0, (float)hw[x][y]*zoomz - zoomz2, hh2*(MAXX-(ys)) - 1.0, hh2*3*step))
      {
		    int xstep = getCoord (x + step);
        int a = selectColor (x, y);
        if (a == 4 || a == 5 || a == 6 || a == 8 || a == 9)
          water = true;
        if (a != 6 && a != 9)
        {
          if (!last)
          {
            last = true;
            glBegin (GL_QUAD_STRIP);
          }
          texlight = 1.0;
          if (a == 0 || a == 1 || a == 10 || a == 12 || a == 13)
            texlight = texgrass->texlight;
          else if (a == 2 || a == 7)
            texlight = texrocks->texlight;
          else if (a == 4 || a == 5 || a == 6 || a == 8 || a == 9)
            texlight = texwater->texlight;
          else if (a == 11)
            texlight = texredstone->texlight;
          cr = r [x] [y];
          cg = g [x] [y];
          cb = b [x] [y];
          float fac = 0.001 * (nl [x] [y] + (short) dl [x] [y] * 16) * sunlight / 256.0 * texlight;
          cr = (float) cr * fac;
          cg = (float) cg * fac;
          cb = (float) cb * fac;
          if (cr >= texlight) cr = texlight;
          if (cg >= texlight) cg = texlight;
          if (cb >= texlight) cb = texlight;
          glColor3f (cr, cg, cb);
          glVertex3f (hh2*xs - 1.0, (float)h[x][y]*zoomz - zoomz2, hh2*(MAXX-ys) - 1.0);
          cr = r [x+step] [y];
          cg = g [x+step] [y];
          cb = b [x+step] [y];
          fac = 0.001 * (nl [xstep] [y] + (short) dl [xstep] [y] * 16) * sunlight / 256.0 * texlight;
          cr = (float) cr * fac;
          cg = (float) cg * fac;
          cb = (float) cb * fac;
          if (cr >= texlight) cr = texlight;
          if (cg >= texlight) cg = texlight;
          if (cb >= texlight) cb = texlight;
          glColor3f (cr, cg, cb);
          glVertex3f (hh2*(xs+step) - 1.0, (float)h[xstep][y]*zoomz - zoomz2, hh2*(MAXX-ys) - 1.0);
        }
        else
        {
          if (last)
            glEnd ();
          last = false;
        }
      }
      ys += step;
    }
    if (last)
    {
      glEnd ();
      last = false;
    }
    xs += step;
  }

  last = false;
  if (water)
  {
    for (xs = x1; xs < x2;)
    {
      x = getCoord (xs);
//      glBegin (GL_QUAD_STRIP);
      for (ys = y1; ys < y2;)
      {
        y = getCoord (ys);
		int xstep = getCoord (x + step);
		int ystep = getCoord (y + step);
		int ymstep = getCoord (y - step);
        if (isWater (f [x] [y]) || isWater (f [xstep] [y]) || isWater (f [xstep] [ystep]) || isWater (f [x] [ystep]) ||
            isWater (f [x] [ymstep]) || isWater (f [xstep] [ymstep]))
        {
          float h1 = hw [x] [y];
          if (hw [xstep] [ystep] < h1) h1 = hw [xstep] [ystep];
          if (hw [xstep] [y] < h1) h1 = hw [xstep] [y];
          if (hw [x] [ystep] < h1) h1 = hw [x] [ystep];
          if (hw [x] [ymstep] < h1) h1 = hw [x] [ymstep];
          if (hw [xstep] [ymstep] < h1) h1 = hw [xstep] [ymstep];
          if (gl->isCubeInFrustum (hh2*(xs) - 1.0, (float)h1*zoomz - zoomz2, hh2*(MAXX-(ys)) - 1.0, hh2*2))
          {
            if (!last)
            {
              last = true;
              glBegin (GL_QUAD_STRIP);
            }
            texlight = texwater->texlight;
            float d = 0.0005 * (h1 - h [x] [y]);
            if (d > 0.75) d = 0.75;
            if (type == 0)
            {
              cr = 0.1 * 256;
              cg = (0.85 - d) * 256;
              cb = (0.6 + d) * 256;
            }
            else if (type == 2)
            {
              cr = (0.55 - d/2) * 256;
              cg = (0.55 - d/2) * 256;
              cb = (0.6 + d) * 256;
            }
            float fac = 0.001 * (nl [x] [y] + (short) dl [x] [y] * 16) * sunlight / 256.0 * texlight;
            cr = (float) cr * fac;
            cg = (float) cg * fac;
            cb = (float) cb * fac;
            if (cr > texlight) cr = texlight;
            if (cg < 0.1 * texlight) cg = 0.1 * texlight;
            if (cg > texlight) cg = texlight;
            if (cb > texlight) cb = texlight;
            glColor3f (cr, cg, cb);
            glVertex3f (hh2*xs - 1.0, h1*zoomz - zoomz2, hh2*(MAXX-ys) - 1.0);

            d = 0.0005 * (h1 - h [xstep] [y]);
            if (d > 0.75) d = 0.75;
            if (type == 0)
            {
              cr = 0.1 * 256;
              cg = (0.85 - d) * 256;
              cb = (0.6 + d) * 256;
            }
            else if (type == 2)
            {
              cr = (0.55 - d/2) * 256;
              cg = (0.55 - d/2) * 256;
              cb = (0.6 + d) * 256;
            }
            fac = 0.001 * (nl [xstep] [y] + (short) dl [xstep] [y] * 16) * sunlight / 256.0 * texlight;
            cr = (float) cr * fac;
            cg = (float) cg * fac;
            cb = (float) cb * fac;
            if (cr > texlight) cr = texlight;
            if (cg < 0.1 * texlight) cg = 0.1 * texlight;
            if (cg > texlight) cg = texlight;
            if (cb > texlight) cb = texlight;
            glColor3f (cr, cg, cb);
            glVertex3f (hh2*(xs+step) - 1.0, h1*zoomz - zoomz2, hh2*(MAXX-ys) - 1.0);
          }
          else
          {
            if (last)
              glEnd ();
            last = false;
          }
        }
        ys += step;
      }
      if (last)
      {
        glEnd ();
        last = false;
      }
      xs += step;
    }
  }
}

void GLLandscape::drawTexturedQuad (int xs, int ys, int step)
{
  int j;
//    int tx, ty;
//    float tfx, tfy, tfinc;
  float texlight = 1.0;
  bool texture = false;
  float col [4] [3];
  float pos [4] [3];
  float tf [4] [2];
  float fac;
  float texzoom;
  int px [4], py [4];
  int x = getCoord (xs);
  int y = getCoord (ys);
  px [0] = xs; py [0] = ys;
  px [1] = xs + step; py [1] = ys;
  px [2] = xs + step; py [2] = ys + step;
  px [3] = xs; py [3] = ys + step;
  float minh = h[x][y];
  float maxh = minh;
  for (j = 1; j < 4; j ++)
  {
    int h1 = h [px [j]] [py [j]];
    if (h1 > maxh) maxh = h1;
    else if (h1 < minh) minh = h1;
  }
  float midh = (minh + maxh) / 2 * zoomz - zoomz2;
  float size = (maxh - minh) * zoomz; // exakt wre mal 0.5
  if (size < hh2 / 2)
    size = hh2 / 2;
  if (!gl->isCubeInFrustum (hh2*(0.5+xs) - 1.0, midh, hh2*(MAXX-(0.5+ys)) - 1.0, size * 2))
    return;
  if (tex1 [x] [y] == 0xFF)
  {
    texture = false;
    glDisable (GL_TEXTURE_2D);
  }
  else
  {
    texture = true;
    gl->enableTextures (tex1 [x] [y]);
  }
  int texcoord = 0;
  if (tex1 [x] [y] == texredstone->textureID)
  {
    texzoom = 0.5;
    texcoord = 1;
  }
  else if (tex1 [x] [y] != texgrass->textureID)
  {
    texzoom = 0.5;
  }
  else
  {
    texzoom = 0.25;
  }
  float fac2 = 0.001 * sunlight * texlight / 256;
  for (j = 0; j < 4; j ++)
  {
    int mx = getCoord (px [j]), my = getCoord (py [j]);
    fac = fac2 * (nl [mx] [my] + (short) dl [mx] [my] * 16);
    col [j] [0] = r [mx] [my] * fac;
    col [j] [1] = g [mx] [my] * fac;
    col [j] [2] = b [mx] [my] * fac;
    if (col [j] [0] >= 1.0) col [j] [0] = 1.0;
    if (col [j] [1] >= 1.0) col [j] [1] = 1.0;
    if (col [j] [2] >= 1.0) col [j] [2] = 1.0;
    pos [j] [0] = hh2*px[j] - 1.0;
    pos [j] [1] = (float)h[mx][my]*zoomz - zoomz2;
    pos [j] [2] = hh2*(MAXX-py[j]) - 1.0;
  }
  for (j = 0; j < 4; j ++)
  {
    if (texcoord == 0)
    {
      tf [j] [0] = (float) px [j] * texzoom;
      tf [j] [1] = (float) py [j] * texzoom;
    }
    else
    {
      tf [j] [0] = (float) px [j] * texzoom;
      tf [j] [1] = (float) h [getCoord (px [j])] [getCoord (py [j])] * texzoom / 400.0;
    }
  }
  glBegin (GL_QUADS);
  for (j = 0; j < 4; j ++)
  {
    if (texture)
      glTexCoord2fv (tf [j]);
    glColor3fv (col [j]);
    glVertex3fv (pos [j]);
  }
  glEnd();
}

void GLLandscape::drawWaterTexturedQuad (int xs, int ys, int step)
{
  int i, j;
//    int tx, ty;
//    float tfx, tfy, tfinc;
  float texlight = 1.0;
  bool texture = false;
  float col [4] [4];
  float pos [4] [3];
  float tf [4] [2];
  float li [4];
  float fac;
  float texzoom;
  int px [4], py [4];
  int x = getCoord (xs);
  int y = getCoord (ys);
  int xstep = getCoord (xs + step);
  int ystep = getCoord (ys + step);
  px [0] = xs; py [0] = ys; li [0] = (nl [x] [y] + (short) dl [x] [y] * 16);
  px [1] = xs + step; py [1] = ys; li [1] = (nl [xstep] [y] + (short) dl [xstep] [y] * 16);
  px [2] = xs + step; py [2] = ys + step; li [2] = (nl [xstep] [ystep] + (short) dl [xstep] [ystep] * 16);
  px [3] = xs; py [3] = ys + step; li [3] = (nl [x] [ystep] + (short) dl [x] [ystep] * 16);

  float h1 = hw [x] [y];
  for (i = 1; i <= 3; i ++)
  {
    int mx = getCoord (px [i]);
    int my = getCoord (py [i]);
    if (hw [mx] [my] < h1/* && isWater (f [px [i]] [py [i]])*/)
    {
      h1 = hw [mx] [my];
//      for (i2 = 0; i2 <= 3; i2 ++)
 //       li [i2] = li [i];
    }
  }

  if (!gl->isCubeInFrustum (hh2*(0.5+xs) - 1.0, h1*zoomz - zoomz2, hh2*(MAXX-(0.5+ys)) - 1.0, hh2 / 2))
    return;
  texture = true;
  gl->enableTextures (texwater->textureID);
  texlight = texwater->texlight;
  texzoom = 0.5;
  float fac2 = 0.001 * sunlight/* * texlight*/;
  for (j = 0; j < 4; j ++)
  {
    int mx = getCoord (px [j]), my = getCoord (py [j]);
    float d = 0.0005 * (h1 - h [mx] [my]);
    if (d > 0.75) d = 0.75;
    fac = fac2 * li [j];
    if (type == 0)
    {
      col [j] [0] = 0.1 * fac;
      col [j] [1] = (0.85 - d) * fac;
      col [j] [2] = (0.6 + d) * fac;
    }
    else if (type == 2)
    {
      col [j] [0] = (0.55 - d/2) * fac;
      col [j] [1] = (0.55 - d/2) * fac;
      col [j] [2] = (0.6 + d) * fac;
    }
//    col [j] [3] = (float) abs (h1 - h [px [j]] [py [j]]) / 200 + 0.5;
    if (col [j] [0] >= 1.0) col [j] [0] = 1.0;
    if (col [j] [1] <= 0.1) col [j] [1] = 0.1;
    if (col [j] [1] >= 1.0) col [j] [1] = 1.0;
    if (col [j] [2] >= 1.0) col [j] [2] = 1.0;
//    if (col [j] [3] >= 1.0) col [j] [3] = 1.0;
//    col [j] [3] = 0.5;
    pos [j] [0] = hh2*px[j] - 1.0;
    pos [j] [1] = (float)h1*zoomz - zoomz2;
    pos [j] [2] = hh2*(MAXX-py[j]) - 1.0;
  }
  for (j = 0; j < 4; j ++)
  {
    tf [j] [0] = (float) px [j] * texzoom;
    tf [j] [1] = (float) py [j] * texzoom;
  }
  glBegin (GL_QUADS);
  for (j = 0; j < 4; j ++)
  {
    if (texture)
      glTexCoord2fv (tf [j]);
    glColor4fv (col [j]);
    glVertex3fv (pos [j]);
  }
  glEnd();

/*  float h2 = h1;
  if (h [x] [y + 2*step] < h2) h2 = h [x] [y + 2*step];
  if (h [x + step] [y + 2*step] < h2) h2 = h [x + step] [y + 2*step];
  if (h2 < h1)
  {
  px [0] = x; py [0] = y+step; li [0] = nl [x] [y+step];
  px [1] = x + step; py [1] = y+step; li [1] = nl [x + step] [y+step];
  for (j = 0; j < 4; j ++)
  {
    int mx = px [j], my = py [j];
    float d = 0.0005 * (h1 - h [px [j]] [py [j]]);
    fac = fac2 * li [j];
    col [j] [0] = 0.1 * fac;
    col [j] [1] = (0.85 - d) * fac;
    col [j] [2] = (0.6 + d) * fac;
//    col [j] [3] = (float) abs (h1 - h [px [j]] [py [j]]) / 200 + 0.5;
    if (col [j] [0] >= 1.0) col [j] [0] = 1.0;
    if (col [j] [1] <= 0.1) col [j] [1] = 0.1;
    if (col [j] [1] >= 1.0) col [j] [1] = 1.0;
    if (col [j] [2] >= 1.0) col [j] [2] = 1.0;
//    if (col [j] [3] >= 1.0) col [j] [3] = 1.0;
//    col [j] [3] = 0.5;
    pos [j] [0] = hh2*mx - 1.0;
    if (j <= 1)
      pos [j] [1] = (float)h1*zoomz - zoomz2;
    else
      pos [j] [1] = (float)h2*zoomz - zoomz2;
    pos [j] [2] = hh2*(MAXX-my) - 1.0;
  }
  for (j = 0; j < 4; j ++)
  {
    tf [j] [0] = (float) px [j] * texzoom;
    tf [j] [1] = (float) py [j] * texzoom;
  }
  glBegin (GL_QUADS);
  for (j = 0; j < 4; j ++)
  {
    if (texture)
      glTexCoord2fv (tf [j]);
    glColor4fv (col [j]);
    glVertex3fv (pos [j]);
  }
  glEnd();
  }

  h2 = h1;
  if (h [x + 2*step] [y] < h2) h2 = h [x + 2*step] [y];
  if (h [x + 2*step] [y + step] < h2) h2 = h [x + 2*step] [y + step];
  if (h2 < h1)
  {
  px [0] = x + step; py [0] = y; li [0] = nl [x + step] [y];
  px [3] = x + step; py [3] = y + step; li [3] = nl [x + step] [y + step];
  for (j = 0; j < 4; j ++)
  {
    int mx = px [j], my = py [j];
    float d = 0.0005 * (h1 - h [px [j]] [py [j]]);
    fac = fac2 * li [j];
    col [j] [0] = 0.1 * fac;
    col [j] [1] = (0.85 - d) * fac;
    col [j] [2] = (0.6 + d) * fac;
//    col [j] [3] = (float) abs (h1 - h [px [j]] [py [j]]) / 200 + 0.5;
    if (col [j] [0] >= 1.0) col [j] [0] = 1.0;
    if (col [j] [1] <= 0.1) col [j] [1] = 0.1;
    if (col [j] [1] >= 1.0) col [j] [1] = 1.0;
    if (col [j] [2] >= 1.0) col [j] [2] = 1.0;
//    if (col [j] [3] >= 1.0) col [j] [3] = 1.0;
//    col [j] [3] = 0.5;
    pos [j] [0] = hh2*mx - 1.0;
    if (j == 0 || j == 3)
      pos [j] [1] = (float)h2*zoomz - zoomz2;
    else
      pos [j] [1] = (float)h1*zoomz - zoomz2;
    pos [j] [2] = hh2*(MAXX-my) - 1.0;
  }
  for (j = 0; j < 4; j ++)
  {
    tf [j] [0] = (float) px [j] * texzoom;
    tf [j] [1] = (float) py [j] * texzoom;
  }
  glBegin (GL_QUADS);
  for (j = 0; j < 4; j ++)
  {
    if (texture)
      glTexCoord2fv (tf [j]);
    glColor4fv (col [j]);
    glVertex3fv (pos [j]);
  }
  glEnd();
  }*/

}

void GLLandscape::drawTexturedTriangle1 (int xs, int ys, int step)
{
    int j;
//    int tx, ty;
//    float tfx, tfy, tfinc;
    float texlight = 1.0;
    bool texture = false;
    float col [4] [3];
    float pos [4] [3];
    float tf [4] [2];
    float fac;
    float texzoom;
    int px [4], py [4];
    int x = getCoord (xs);
    int y = getCoord (ys);
    px [0] = xs; py [0] = ys;
    px [1] = xs + step; py [1] = ys;
    px [2] = xs + step; py [2] = ys + step;
    px [3] = xs; py [3] = ys + step;

    if (!gl->isCubeInFrustum (hh2*(0.5+xs) - 1.0, (float)h[x][y]*zoomz - zoomz2, hh2*(MAXX-(0.5+ys)) - 1.0, hh2*2))
      return;

    if (tex1 [x] [y] == 0xFF)
    {
      texture = false;
      glDisable (GL_TEXTURE_2D);
    }
    else
    {
      texture = true;
      gl->enableTextures (tex1 [x] [y]);
    }
    if (tex1 [x] [y] != texgrass->textureID && tex1 [x] [y] != texgrass->textureID)
    {
      texzoom = 0.5;
    }
    else
    {
      texzoom = 0.25;
    }

    float fac2 = 0.001 * sunlight * texlight / 256;

    for (j = 0; j < 4; j ++)
    {
      int mx = getCoord (px [j]), my = getCoord (py [j]);
      fac = fac2 * (nl [mx] [my] + (short) dl [mx] [my] * 16);
      col [j] [0] = r [mx] [my] * fac;
      col [j] [1] = g [mx] [my] * fac;
      col [j] [2] = b [mx] [my] * fac;
      if (col [j] [0] >= 1.0) col [j] [0] = 1.0;
      if (col [j] [1] >= 1.0) col [j] [1] = 1.0;
      if (col [j] [2] >= 1.0) col [j] [2] = 1.0;
      pos [j] [0] = hh2*px[j] - 1.0;
      pos [j] [1] = (float)h[mx][my]*zoomz - zoomz2;
      pos [j] [2] = hh2*(MAXX-py[j]) - 1.0;
    }

    for (j = 0; j < 4; j ++)
    {
      tf [j] [0] = (float) px [j] * texzoom;
      tf [j] [1] = (float) py [j] * texzoom;
    }

    glBegin (GL_TRIANGLES);
	  for (j = 0; j < 3; j ++)
	  {
  	  if (texture)
        glTexCoord2fv (tf [j]);
      glColor3fv (col [j]);
      glVertex3fv (pos [j]);
    }
    glEnd();

/*              a = selectColor (x, y);
                texture = true;
                if (a == 0 || a == 1)
                  gl->enableTextures (texgrass);
                else if (a == 2 || a == 7)
                  gl->enableTextures (texrocks);
                else if (a == 4 || a == 5 || a == 6)
                {
                  gl->enableTextures (texwater);
                }
                else
                  glDisable (GL_TEXTURE_2D);
              if (a > 1)
              {
                texzoom = 0.5;
              }
              else
              {
                texzoom = 0.25;
              }*/

              if (tex2 [x] [y] == 0xFF)
              {
                texture = false;
                glDisable (GL_TEXTURE_2D);
              }
              else
              {
                texture = true;
                gl->enableTextures (tex2 [x] [y]);
              }

              if (tex2 [x] [y] != texgrass->textureID && tex2 [x] [y] != texredstone->textureID)
              {
                texzoom = 0.5;
              }
              else
              {
                texzoom = 0.25;
              }

        for (j = 0; j < 4; j ++)
        {
          tf [j] [0] = (float) px [j] * texzoom;
          tf [j] [1] = (float) py [j] * texzoom;
        }

		  glBegin (GL_TRIANGLES);
  		  if (texture)
          glTexCoord2fv (tf [0]);
        glColor3fv (col [0]);
        glVertex3fv (pos [0]);
		  for (j = 2; j < 4; j ++)
		  {
  		  if (texture)
          glTexCoord2fv (tf [j]);
        glColor3fv (col [j]);
        glVertex3fv (pos [j]);
      }
      glEnd();
}

void GLLandscape::drawTexturedTriangle2 (int xs, int ys, int step)
{
    int j;
//    int tx, ty;
//    float tfx, tfy, tfinc;
    float texlight = 1.0;
    bool texture = false;
    float col [4] [3];
    float pos [4] [3];
    float tf [4] [2];
    float fac;
    float texzoom;
    int px [4], py [4];
    int x = getCoord (xs);
    int y = getCoord (ys);
    px [0] = xs; py [0] = ys;
    px [1] = xs + step; py [1] = ys;
    px [2] = xs + step; py [2] = ys + step;
    px [3] = xs; py [3] = ys + step;

    if (!gl->isCubeInFrustum (hh2*(0.5+xs) - 1.0, (float)h[x][y]*zoomz - zoomz2, hh2*(MAXX-(0.5+ys)) - 1.0, hh2*2))
      return;

/*              int a = selectColor (x, y+step);
                texture = true;
                if (a == 0 || a == 1)
                  gl->enableTextures (texgrass);
                else if (a == 2 || a == 7)
                  gl->enableTextures (texrocks);
                else if (a == 4 || a == 5 || a == 6)
                {
//		    int a2 = selectColor (x+step, y);
//		    if (a2 < 4 || a2 > 6) gl->enableTextures (texgrass);
//		    else
                  {
                    gl->enableTextures (texwater);
                  }
                }
                else
                  glDisable (GL_TEXTURE_2D);
              if (a > 1)
              {
                texzoom = 0.5;
//                tx = x & 1; ty = y & 1; // modulo 2
//                tfx = 0.5 * tx; tfy = 0.5 * ty;
//                tfinc = 0.5;
              }
              else
              {
                texzoom = 0.25;
//                tx = x & 3; ty = y & 3; // modulo 4
//                tfx = 0.25 * tx; tfy = 0.25 * ty;
//                tfinc = 0.25;
              }*/

              if (tex1 [x] [y] == 0xFF)
              {
                texture = false;
                glDisable (GL_TEXTURE_2D);
              }
              else
              {
                texture = true;
                gl->enableTextures (tex1 [x] [y]);
              }

              if (tex1 [x] [y] != texgrass->textureID && tex1 [x] [y] != texredstone->textureID)
              {
                texzoom = 0.5;
              }
              else
              {
                texzoom = 0.25;
              }


        float fac2 = 0.001 * sunlight * texlight / 256;
        for (j = 0; j < 4; j ++)
        {
        int mx = getCoord (px [j]), my = getCoord (py [j]);
        fac = fac2 * (nl [mx] [my] + (short) dl [mx] [my]);
        col [j] [0] = r [mx] [my] * fac;
        col [j] [1] = g [mx] [my] * fac;
        col [j] [2] = b [mx] [my] * fac;
        if (col [j] [0] >= 1.0) col [j] [0] = 1.0;
        if (col [j] [1] >= 1.0) col [j] [1] = 1.0;
        if (col [j] [2] >= 1.0) col [j] [2] = 1.0;
        pos [j] [0] = hh2*px[j] - 1.0;
        pos [j] [1] = (float)h[mx][my]*zoomz - zoomz2;
        pos [j] [2] = hh2*(MAXX-py[j]) - 1.0;

        }

        for (j = 0; j < 4; j ++)
        {
          tf [j] [0] = (float) px [j] * texzoom;
          tf [j] [1] = (float) py [j] * texzoom;
        }

		  glBegin (GL_TRIANGLES);
		  for (j = 0; j < 2; j ++)
		  {
  		  if (texture)
          glTexCoord2fv (tf [j]);
        glColor3fv (col [j]);
        glVertex3fv (pos [j]);
      }
  		  if (texture)
          glTexCoord2fv (tf [3]);
        glColor3fv (col [3]);
        glVertex3fv (pos [3]);
      glEnd();

/*              a = selectColor (x, y + step);
                texture = true;
                if (a == 0 || a == 1)
                  gl->enableTextures (texgrass);
                else if (a == 2 || a == 7)
                  gl->enableTextures (texrocks);
                else if (a == 4 || a == 5 || a == 6)
                {
                  gl->enableTextures (texwater);
                }
                else
                  glDisable (GL_TEXTURE_2D);
              if (a > 1)
              {
                texzoom = 0.5;
              }
              else
              {
                texzoom = 0.25;
              }*/

              if (tex2 [x] [y] == 0xFF)
              {
                texture = false;
                glDisable (GL_TEXTURE_2D);
              }
              else
              {
                texture = true;
                gl->enableTextures (tex2 [x] [y]);
              }

              if (tex2 [x] [y] != texgrass->textureID && tex2 [x] [y] != texredstone->textureID)
              {
                texzoom = 0.5;
              }
              else
              {
                texzoom = 0.25;
              }


        for (j = 0; j < 4; j ++)
        {
          tf [j] [0] = (float) px [j] * texzoom;
          tf [j] [1] = (float) py [j] * texzoom;
        }

		  glBegin (GL_TRIANGLES);
		  for (j = 1; j < 4; j ++)
		  {
  		  if (texture)
          glTexCoord2fv (tf [j]);
        glColor3fv (col [j]);
        glVertex3fv (pos [j]);
      }
      glEnd();
}

    
void GLLandscape::draw (int phi, int gamma)
{
  int i, i2, x, y;
  int xs, ys;

  lsticker ++;
  if (lsticker >= 36000000)
    lsticker = 0;

  glPushMatrix ();
/*  GLfloat mat_ambient[]  = { 0.7,0.7,0.7,1 };
  GLfloat mat_diffuse[]  = { 0.3,0.3,0.3,1 };
  GLfloat mat_specular[] = { 0,0,0,0 };
  GLfloat mat_emission[] = { 0,0,0,0 };
  GLfloat mat_shininess[] = { 0 };

  if (lighting >= 10)
  {
    glMaterialfv( GL_FRONT, GL_AMBIENT, mat_ambient );
    glMaterialfv( GL_FRONT, GL_DIFFUSE, mat_diffuse );
    glMaterialfv( GL_FRONT, GL_SPECULAR, mat_specular );
    glMaterialfv( GL_FRONT, GL_EMISSION, mat_emission );
    glMaterialfv( GL_FRONT, GL_SHININESS, mat_shininess );
  }*/

//  glEnable (GL_NORMALIZE);

//  glutSolidSphere( 1.0, 30, 30);


  float z2 = ZOOM * MAXX / MAXX2;
//  float z2 = ZOOM;
  glScalef(z2, ZOOM, z2);

  gl->extractFrustum ();
    
//    glTranslatef(-0.5,-0.5,-0.5);
//  printf (">phi = %d, %d, %d: h = %f\n", (int) phi,(int)px+MAXX/2, (int)pz+MAXX/2, (float)h[(int)px+MAXX/2][(int)pz+MAXX/2]/65536.0-1.0); fflush (stdout);

  float pseudoview = getView ();
  float radius = pseudoview / cosi [45];

  int w = (int) phi;
  float qx [4], qy [4];
  int addw [4] = { 45, 90, 45, 0 };

  int minx = 10000, maxx = -10000, miny = 10000, maxy = -10000;
  if (gamma >= 90 && gamma < 270)
  {
    for (i = 0; i < 4; i ++)
    {
      if (w < 0) w += 360;
      if (w >= 360) w -= 360;
      qx [i] = radius * cosi [w] + camx + MAXX/2;
      qy [i] = radius * sine [w] + MAXX/2 - camz;
      w += addw [i];
    }
  }
  else
  {
    w += 180;
    for (i = 0; i < 4; i ++)
    {
      if (w >= 360) w -= 360;
      qx [i] = radius * cosi [w] + camx + MAXX/2;
      qy [i] = radius * sine [w] + MAXX/2 - camz;
      w += addw [i];
    }
  }
  for (i = 0; i < 4; i ++)
  {
    if ((int) qx [i] < minx) minx = (int) qx [i];
    if ((int) qx [i] > maxx) maxx = (int) qx [i];
    if ((int) qy [i] < miny) miny = (int) qy [i];
    if ((int) qy [i] > maxy) maxy = (int) qy [i];
  }
  minx -= 20; maxx += 20; miny -= 20; maxy += 20;

/*  int minx = camx + MAXX/2 - radius;
  int miny = MAXX/2 - camz - radius;
  int maxx = minx + radius * 2;
  int maxy = miny + radius * 2;*/

/*  if (minx < 0) minx = 0;
  if (maxx >= MAXX) maxx = MAXX;
  if (miny < 0) miny = 0;
  if (maxy >= MAXX) maxy = MAXX;*/

  space->z1->x = minx - MAXX/2;
  space->z1->y = -MAXX/2;
  space->z1->z = MAXX/2 - maxy;
  space->z2->x = maxx - MAXX/2;
  space->z2->y = MAXX/2;
  space->z2->z = MAXX/2 - miny;

  if (camera == 50)
  {
    minx = 0; maxx = MAXX;
    miny = 0; maxy = MAXX;
  }
//    printf ("\nx=%d, y=%d", minx, miny); fflush (stdout);

  float dx = (float) (maxx - minx + 1) / PARTS;
  float dy = (float) (maxy - miny + 1) / PARTS;
  float fx, fy;
  for (i = 0; i < PARTS; i ++)
    for (i2 = 0; i2 < PARTS; i2 ++)
    {
      fx = (float) minx + (float) (dx * (0.5 + (float) i2));
      fy = (float) miny + (float) (dy * (0.5 + (float) i));
      float d = dist (camx + MAXX/2 - fx, MAXX/2 - camz - fy);
      detail [i] [i2] = (int) (d / 10.0);
    }


/*    float zoomz2 = 32768.0 * zoomz;
    int step = 1;
    for (i = 0; i < 4; i ++)
      for (i2 = 0; i2 < 4; i2 ++)
      {
    step = detail [i] [i2];
    for (x = minx + (int) (dx * (float) i2); x < minx + (int) (dx * (float) (i2 + 1)); x += step)
    {
      glBegin (GL_QUAD_STRIP);
      for (y = miny + (int) (dy * (float) i); y <= miny + (int) (dy * (float) (i + 1)) + step; y += step)
      {
        int a;
        a = selectColor (x, y);
        glColor3f (mat [a] [0] * nl [x] [y], mat [a] [1] * nl [x] [y], mat [a] [2] * nl [x] [y]);
        glVertex3f (2*hh*x - 1.0, (float)h[x][y]*zoomz - zoomz2, 2*hh*(MAXX-y) - 1.0);
        a = selectColor (x+step, y);
        glColor3f (mat [a] [0] * nl [x+step] [y], mat [a] [1] * nl [x+step] [y], mat [a] [2] * nl [x+step] [y]);
        glVertex3f (2*hh*(x+step) - 1.0, (float)h[x+step][y]*zoomz - zoomz2, 2*hh*(MAXX-y) - 1.0);
      }
      glEnd();
    }
  }*/

//  float cr, cg, cb;
  int step = 1;
  int zz1 = 0, zz2 = 0, zz = 0;
  if (quality == 0)
  {
    step = 2;
    minx -= (minx & 1); // modulo 2
    miny -= (miny & 1);
  }

  if (camera == 50)
  {
    if (quality == 0)
      step = 8;
    else if (quality == 1)
      step = 4;
    else
      step = 2;
  }
/*  unsigned char done [400] [400];
  for (x = 0; x < 400; x ++)
	memset (&done [x], 0, 400*sizeof (unsigned char));*/

  if (quality <= 1 || camera == 50)
  {

    drawQuadStrip (minx, miny, maxx, maxy, step);

//gl->shadeFlat ();
/*
// Quadtrees
    for (x = minx; x < maxx;)
    {
//      y = miny + 20;
      zz = 0;
      for (y = miny; y < maxy;)
      {
		if (!done [x-minx] [y-miny])
//        if (isCubeInFrustum (hh2*(x) - 1.0, (float)h[x][y]*zoomz - zoomz2, hh2*(MAXX-(y)) - 1.0, hh2*2))
        {
        glBegin (GL_QUADS);
			int mystep = rect[x][y];
			int rx = x - (x % mystep);
			int ry = y - (y % mystep);
        zz1 ++;
        cr = r [rx] [ry];
        cg = g [rx] [ry];
        cb = b [rx] [ry];
        float fac = 0.001 * nl [rx] [ry] * sunlight / 256.0;
        cr = (float) cr * fac;
        cg = (float) cg * fac;
        cb = (float) cb * fac;
        if (cr >= 1.0) cr = 1.0;
        if (cg >= 1.0) cg = 1.0;
        if (cb >= 1.0) cb = 1.0;
//        printf ("r=%f, g=%f, b=%f\n", cr, cg, cb); fflush (stdout);
        glColor3f (cr, cg, cb);
        glVertex3f (hh2*rx - 1.0, (float)h[rx][ry]*zoomz - zoomz2, hh2*(MAXX-ry) - 1.0);
        cr = r [rx+mystep] [ry];
        cg = g [rx+mystep] [ry];
        cb = b [rx+mystep] [ry];
        fac = 0.001 * nl [rx+mystep] [ry] * sunlight / 256.0;
        cr = (float) cr * fac;
        cg = (float) cg * fac;
        cb = (float) cb * fac;
        if (cr >= 1.0) cr = 1.0;
        if (cg >= 1.0) cg = 1.0;
        if (cb >= 1.0) cb = 1.0;
        glColor3f (cr, cg, cb);
        glVertex3f (hh2*(rx+mystep) - 1.0, (float)h[rx+mystep][ry]*zoomz - zoomz2, hh2*(MAXX-ry) - 1.0);
        cr = r [rx+mystep] [ry+mystep];
        cg = g [rx+mystep] [ry+mystep];
        cb = b [rx+mystep] [ry+mystep];
        fac = 0.001 * nl [rx+mystep] [ry+mystep] * sunlight / 256.0;
        cr = (float) cr * fac;
        cg = (float) cg * fac;
        cb = (float) cb * fac;
        if (cr >= 1.0) cr = 1.0;
        if (cg >= 1.0) cg = 1.0;
        if (cb >= 1.0) cb = 1.0;
        glColor3f (cr, cg, cb);
        glVertex3f (hh2*(rx+mystep) - 1.0, (float)h[rx+mystep][ry+mystep]*zoomz - zoomz2, hh2*(MAXX-(ry+mystep)) - 1.0);
        cr = r [rx] [ry+mystep];
        cg = g [rx] [ry+mystep];
        cb = b [rx] [ry+mystep];
        fac = 0.001 * nl [rx] [ry+mystep] * sunlight / 256.0;
        cr = (float) cr * fac;
        cg = (float) cg * fac;
        cb = (float) cb * fac;
        if (cr >= 1.0) cr = 1.0;
        if (cg >= 1.0) cg = 1.0;
        if (cb >= 1.0) cb = 1.0;
        glColor3f (cr, cg, cb);
        glVertex3f (hh2*(rx) - 1.0, (float)h[rx][ry+mystep]*zoomz - zoomz2, hh2*(MAXX-(ry+mystep)) - 1.0);
        glEnd();
		for (i=(rx-minx>0?rx-minx:0);i<rx-minx+mystep;i++)
  		  for (i2=(ry-miny>0?ry-miny:0);i2<ry-miny+mystep;i2++)
			done [i] [i2] = 1;
        }
        else zz2 ++;
        y += step;
        zz ++;
      }
      x += step;
    }*/


/*
// ROAM
    glDisable (GL_CULL_FACE);
    int j, k;

    int trix [3], triy [3];
    float vert [3] [3];

    visibility ++;
    if (visibility == 0xFFFF)
      visibility = 1; // visibility auf 0 setzen !!!

    for (x = minx; x < maxx;)
    {
      zz = 0;
      for (y = miny; y < maxy;)
      {
        if (trimatrix->t [y] [x] != NULL)
        {
          for (j = 0; j < 8; j ++)
            if (trimatrix->t [y] [x] [j] != NULL)
              if (!trimatrix->t [y] [x] [j]->visibility != visibility)
              {
                trimatrix->t [y] [x] [j]->visibility = visibility;
                trix[0]=trimatrix->t [y] [x] [j]->xh;
                triy[0]=trimatrix->t [y] [x] [j]->yh;
                trix[1]=trimatrix->t [y] [x] [j]->x1;
                triy[1]=trimatrix->t [y] [x] [j]->y1;
                trix[2]=trimatrix->t [y] [x] [j]->x2;
                triy[2]=trimatrix->t [y] [x] [j]->y2;
                for (k = 0; k < 3; k ++)
                {
                  vert[k][0]=hh2*trix[k] - 1.0;
                  vert[k][1]=(float)h[trix[k]][triy[k]]*zoomz - zoomz2;
                  vert[k][2]=hh2*(MAXX-triy[k]) - 1.0;
                }

                if (isPointInFrustum (vert[0][0],vert[0][1],vert[0][2]) ||
                    isPointInFrustum (vert[1][0],vert[1][1],vert[1][2]) ||
                    isPointInFrustum (vert[2][0],vert[2][1],vert[2][2]))
                {
                  glBegin (GL_TRIANGLES);
                  zz1 ++;
                  for (k = 0; k < 3; k ++)
                  {
                    cr = r [trix[k]] [triy[k]];
                    cg = g [trix[k]] [triy[k]];
                    cb = b [trix[k]] [triy[k]];
                    float fac = 0.001 * nl [trix[k]] [triy[k]] * sunlight / 256.0;
                    cr = (float) cr * fac;
                    cg = (float) cg * fac;
                    cb = (float) cb * fac;
                    if (cr >= 1.0) cr = 1.0;
                    if (cg >= 1.0) cg = 1.0;
                    if (cb >= 1.0) cb = 1.0;
                    glColor3f (cr, cg, cb);
                    glVertex3f (vert[k][0],vert[k][1],vert[k][2]);
                  }
                  zz ++;
		    glEnd();
                }
                else
                  zz2 ++;
              }
        }
        y += step;
      }
      x += step;
    }
*/

  }
  else
  {
//    gl->enableTextures (texgrass);
/*    if (quality >= 5)
    {
      gl->enableLinearTexture (texgrass->textureID);
      gl->enableLinearTexture (texrocks->textureID);
      gl->enableLinearTexture (texwater->textureID);
    }
    else
    {
      gl->disableLinearTexture (texgrass->textureID);
      gl->disableLinearTexture (texrocks->textureID);
      gl->disableLinearTexture (texwater->textureID);
    }*/
//    glDisable (GL_DITHER);

    float fac;

  if (mode == 0)
  {    

    step = 1;
/*int j;

    for (x = minx; x < maxx; x += step)
    {
      for (y = miny; y < maxy; y += step)
      {
        if (trimatrix->t [y] [x] != NULL)
        for (j = 0; j < 8; j ++)
          if (trimatrix->t [y] [x] [j] != NULL)
          {
            trimatrix->t [y] [x] [j]->setDirty ();
          }
      }
    }*/


//    int stepmask = 0xFFFF - step + 1;
    glDisable (GL_CULL_FACE);

    for (i = 0; i < PARTS; i ++)
      for (i2 = 0; i2 < PARTS; i2 ++)
      {
        int ax = (minx + (int) (dx * (float) i2));
        int ay = (miny + (int) (dy * (float) i));
        int zx = (minx + (int) (dx * (float) (i2 + 1)));
        int zy = (miny + (int) (dy * (float) (i + 1)) + step);
        if (detail [i] [i2] > quality)
        {
          drawQuadStrip (ax, ay, zx, zy, step);
        }
        else
        {
          if (detail [i] [i2] <= quality - 3)
          {
            gl->enableLinearTexture (texgrass->textureID);
            gl->enableLinearTexture (texrocks->textureID);
            gl->enableLinearTexture (texwater->textureID);
            gl->enableLinearTexture (texredstone->textureID);
          }
          else
          {
            gl->disableLinearTexture (texgrass->textureID);
            gl->disableLinearTexture (texrocks->textureID);
            gl->disableLinearTexture (texwater->textureID);
            gl->disableLinearTexture (texredstone->textureID);
          }
        for (xs = ax; xs < zx;)
        {
          x = getCoord (xs);
          for (ys = ay; ys < zy;)
          {
            y = getCoord (ys);
              zz1 ++;
              int a;
              a = selectColor (x, y);
              if (a != 6 && a != 9)
              {
//                drawTexturedQuad (x, y, step);
                if (drawrule [x] [y] == 0)
                  drawTexturedQuad (xs, ys, step);
                else if (drawrule [x] [y] == 2)
                  drawTexturedTriangle1 (xs, ys, step);
                else
                  drawTexturedTriangle2 (xs, ys, step);
              }

        ys += step;
        zz ++;
      }
//glEnd ();
      xs += step;
    }
//		gl->enableAlphaBlending ();
    for (xs = ax; xs < zx;)
    {
      x = getCoord (xs);
      for (ys = ay; ys < zy;)
      {
        y = getCoord (ys);
        zz1 ++;
        int xstep = getCoord (xs + step);
        int ystep = getCoord (ys + step);
//        int a = 0;
        if (isWater (f [x] [y]) || isWater (f [xstep] [y]) || isWater (f [xstep] [ystep]) || isWater (f [x] [ystep]))
//          a = selectColor (x, y);
//        if (a == 4 || a == 5 || a == 6 || a == 8 || a == 9)
        {
          drawWaterTexturedQuad (xs, ys, step);
        }
        ys += step;
        zz ++;
      }
//glEnd ();
      xs += step;
    }
//	gl->disableAlphaBlending ();
}

  }

  }
  if (mode == 1)
  {




    int j, k;

    int trix [3], triy [3];
    float vert [3] [3];

//  glEnable (GL_NORMALIZE);
//  glDisable (GL_CULL_FACE);

    visibility ++;
    if (visibility == 0xFFFF)
      visibility = 1; // visibility auf 0 setzen !!!

//    int tx, ty;
    float tfx, tfy; //, tfinc;
    float texlight = 1.0;
    bool texture = false;
    float col [4] [3];
    float pos [4] [3];
    float tf [4] [2];
    for (i = 0; i < PARTS; i ++)
      for (i2 = 0; i2 < PARTS; i2 ++)
      {
        for (x = minx + (int) (dx * (float) i2); x < minx + (int) (dx * (float) (i2 + 1));)
        {
          for (y = miny + (int) (dy * (float) i); y <= miny + (int) (dy * (float) (i + 1)) + step;)
          {
            if (trimatrix->t [y] [x] != NULL)
            {
              for (j = 0; j < 8; j ++)
                if (trimatrix->t [y] [x] [j] != NULL)
                  if (!trimatrix->t [y] [x] [j]->visibility != visibility)
                  {
                    trimatrix->t [y] [x] [j]->visibility = visibility;
                    trix[0]=trimatrix->t [y] [x] [j]->xh;
                    triy[0]=trimatrix->t [y] [x] [j]->yh;
                    trix[1]=trimatrix->t [y] [x] [j]->x1;
                    triy[1]=trimatrix->t [y] [x] [j]->y1;
                    trix[2]=trimatrix->t [y] [x] [j]->x2;
                    triy[2]=trimatrix->t [y] [x] [j]->y2;
                    for (k = 0; k < 3; k ++)
                    {
                      vert[k][0]=hh2*trix[k] - 1.0;
                      vert[k][1]=(float)h[trix[k]][triy[k]]*zoomz - zoomz2;
                      vert[k][2]=hh2*(MAXX-triy[k]) - 1.0;
                    }

                    if (gl->isPointInFrustum (vert[0][0],vert[0][1],vert[0][2]) ||
                        gl->isPointInFrustum (vert[1][0],vert[1][1],vert[1][2]) ||
                        gl->isPointInFrustum (vert[2][0],vert[2][1],vert[2][2]))
                    {
//                      trimatrix->t [y] [x] [j]->setClean ();
//	    glBegin (GL_TRIANGLES);
                      int mx, my;
                      mx = trimatrix->t [y] [x] [j]->xh; my = trimatrix->t [y] [x] [j]->yh;
                      zz1 ++;
                      int a;
                      a = selectColor (mx, my);
                      if (detail [i] [i2] <= quality + 1)
                      {
                        texture = true;
                        texlight = 1.0;
                        if (a == 0 || a == 1)
                          gl->enableTextures (texgrass->textureID);
                        else if (a == 2 || a == 7)
                          gl->enableTextures (texrocks->textureID);
                        else if (a == 4 || a == 5 || a == 6)
                        {
                          int a2 = selectColor (mx, my);
                          if (a2 < 4 || a2 > 6) gl->enableTextures (texgrass->textureID);
                          else
                          {
                            gl->enableTextures (texwater->textureID);
//	else glDisable (GL_TEXTURE_2D);
                          }
                        }
                        else if (a == 11)
                          gl->enableTextures (texredstone->textureID);
                        else
                          glDisable (GL_TEXTURE_2D);
                      }
                      else
                      {
                        texlight = 0.9;
                        texture = false;
                        glDisable (GL_TEXTURE_2D);
                      }
                      
                      for (k = 0; k < 3; k ++)
                      {
                        if (a > 1)
                        {
                          tfx = 0.5 * trix[k]; tfy = 0.5 * triy[k];
                        }
                        else
                        {
                          tfx = 0.25 * trix[k]; tfy = 0.25 * triy[k];
                        }
                        float fac2 = 0.001 * sunlight / 256.0 * texlight;
                        col [k] [0] = r [trix[k]] [triy[k]];
                        col [k] [1] = g [trix[k]] [triy[k]];
                        col [k] [2] = b [trix[k]] [triy[k]];
                        fac = fac2 * (nl [trix[k]] [triy[k]] + (short) dl [trix[k]] [triy[k]]);
                        col [k] [0] *= fac;
                        col [k] [1] *= fac;
                        col [k] [2] *= fac;
                        if (col [k] [0] >= 1.0) col [k] [0] = 1.0;
                        if (col [k] [1] >= 1.0) col [k] [1] = 1.0;
                        if (col [k] [2] >= 1.0) col [k] [2] = 1.0;
                        pos [k] [0] = hh2*trix[k] - 1.0;
                        pos [k] [1] = (float)h[trix[k]][triy[k]]*zoomz - zoomz2;
                        pos [k] [2] = hh2*(MAXX-triy[k]) - 1.0;
                        tf [k] [0] = tfx;
                        tf [k] [1] = tfy;
                      }
                    
                      glBegin (GL_TRIANGLES);
                      for (int j = 0; j < 3; j ++)
                      {
                        if (texture)
                          glTexCoord2fv (tf [j]);
                        glColor3fv (col [j]);
                        glVertex3fv (pos [j]);
                      }
                      glEnd();

                    }
                    else
                      zz2 ++;
                  } // if infrustum
              zz ++;
            } // if trimatrix
            y += step;
          }
//glEnd ();
          x += step;
        }
      }

  }
    
  if (quality >= 3)
    {
      glPushMatrix ();
//	glRotatef (camphi, 0, 1, 0);
      glDisable (GL_CULL_FACE);
      if (quality >= 6)
      {
        gl->enableAlphaBlending ();
        glEnable (GL_ALPHA_TEST);
        glAlphaFunc (GL_GEQUAL, 0.1);
      }
      else
      {
        glEnable (GL_ALPHA_TEST);
        glAlphaFunc (GL_GEQUAL, 0.5);
      }
/*      if (quality >= 5)
      {
        gl->enableLinearTexture (textree->textureID);
        gl->enableLinearTexture (textree2->textureID);
      }
      else
      {
        gl->disableLinearTexture (textree->textureID);
        gl->disableLinearTexture (textree2->textureID);
      }*/
      gl->enableTextures (textree->textureID);
      glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      gl->enableTextures (textree2->textureID);
      glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      gl->enableTextures (textree3->textureID);
      glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      gl->enableTextures (textree4->textureID);
      glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      float x21 = 0.3, y21 = -0.32;
      float x22 = -0.21, y22 = 0.22;
      float x31 = 0.32, y31 = -0.08;
      float x32 = -0.31, y32 = -0.33;
      float x33 = -0.11, y33 = 0.28;
      float x41 = 0.22, y41 = -0.3;
      float x42 = -0.28, y42 = -0.18;
      float x43 = 0.31, y43 = 0.17;
      float x44 = -0.21, y44 = 0.32;
      for (i = 0; i < PARTS; i ++)
        for (i2 = 0; i2 < PARTS; i2 ++)
        {
          if (detail [i] [i2] <= quality - 4)
          {
            gl->enableLinearTexture (textree->textureID);
            gl->enableLinearTexture (textree2->textureID);
            gl->enableLinearTexture (textree3->textureID);
            gl->enableLinearTexture (textree4->textureID);
          }
          else
          {
            gl->disableLinearTexture (textree->textureID);
            gl->disableLinearTexture (textree2->textureID);
            gl->disableLinearTexture (textree3->textureID);
            gl->disableLinearTexture (textree4->textureID);
          }
          for (xs = minx + (int) (dx * (float) i2); xs < minx + (int) (dx * (float) (i2 + 1));)
//    for (x = maxx; x >= minx;)
          {
            x = getCoord (xs);
      zz = 0;
      for (ys = miny + (int) (dy * (float) i); ys <= miny + (int) (dy * (float) (i + 1)) + step;)
//      for (y = maxy; y >= miny;)
      {
        y = getCoord (ys);
        if (detail [i] [i2] <= quality + 1)
		if (isWoods (f [x] [y]) || isType (f [x] [y], REDTREE0))
		if (gl->isCubeInFrustum (hh2*(xs) - 1.0, (float)h[x][y]*zoomz - zoomz2, hh2*(MAXX-(ys)) - 1.0, hh2*2))
        {
        float cg = g [x] [y];
        fac = 0.0007 * (nl [x] [y] + (short) dl [x] [y] * 16) * sunlight;
        cg = (float) cg * fac;
        if (cg >= 256.0) cg = 255.0;
        treecolor.c [0] = treecolor.c [1] = treecolor.c [2] = (int) cg;
		if (f [x] [y] == CONIFEROUSWOODS0 || f [x] [y] == BUSHES0)
		{
		  gl->enableTextures (textree2->textureID);
		  drawTree (xs + x41, ys + y41, 0.0036, 0.23, phi);
		  drawTree (xs + x42, ys + y42, 0.0040, 0.25, phi);
		  drawTree (xs + x43, ys + y43, 0.0041, 0.26, phi);
		  drawTree (xs + x44, ys + y44, 0.0034, 0.22, phi);
		}
		else if (f [x] [y] == CONIFEROUSWOODS1 || f [x] [y] == BUSHES1)
		{
		  gl->enableTextures (textree2->textureID);
		  drawTree (xs + x31, ys + y31, 0.0036, 0.23, phi);
		  drawTree (xs + x32, ys + y32, 0.0041, 0.25, phi);
		  drawTree (xs + x33, ys + y33, 0.003, 0.18, phi);
		}
		else if (f [x] [y] == CONIFEROUSWOODS2 || f [x] [y] == BUSHES2)
		{
		  gl->enableTextures (textree2->textureID);
		  drawTree (xs + x21, ys + y21, 0.0032, 0.22, phi);
		  drawTree (xs + x22, ys + y22, 0.0045, 0.27, phi);
		}
		else if (f [x] [y] == CONIFEROUSWOODS3 || f [x] [y] == BUSHES3)
		{
		  gl->enableTextures (textree2->textureID);
		  drawTree (xs, ys, 0.0047, 0.3, phi);
		}
		else if (f [x] [y] == DECIDUOUSWOODS0)
		{
		  gl->enableTextures (textree->textureID);
		  drawTree (xs + x41, ys + y41, 0.004, 0.23, phi);
		  drawTree (xs + x42, ys + y42, 0.0044, 0.27, phi);
		  drawTree (xs + x43, ys + y43, 0.0045, 0.25, phi);
		  drawTree (xs + x44, ys + y44, 0.0038, 0.22, phi);
		}
		else if (f [x] [y] == DECIDUOUSWOODS1)
		{
		  gl->enableTextures (textree->textureID);
		  drawTree (xs + x31, ys + y31, 0.004, 0.23, phi);
		  drawTree (xs + x32, ys + y32, 0.0045, 0.25, phi);
		  drawTree (xs + x33, ys + y33, 0.003, 0.18, phi);
		}
		else if (f [x] [y] == DECIDUOUSWOODS2)
		{
		  gl->enableTextures (textree->textureID);
		  drawTree (xs + x21, ys + y21, 0.0035, 0.22, phi);
		  drawTree (xs + x22, ys + y22, 0.0048, 0.27, phi);
		}
		else if (f [x] [y] == DECIDUOUSWOODS3)
		{
		  gl->enableTextures (textree->textureID);
		  drawTree (xs, ys, 0.005, 0.3, phi);
		}
		else if (f [x] [y] == DWARFPINES0)
		{
		  gl->enableTextures (textree3->textureID);
		  drawTree (xs + x41, ys + y41, 0.002, 0.28, phi);
		  drawTree (xs + x42, ys + y42, 0.0023, 0.34, phi);
		  drawTree (xs + x43, ys + y43, 0.0025, 0.37, phi);
		  drawTree (xs + x44, ys + y44, 0.0018, 0.26, phi);
		}
		else if (f [x] [y] == DWARFPINES1)
		{
		  gl->enableTextures (textree3->textureID);
		  drawTree (xs + x31, ys + y31, 0.002, 0.28, phi);
		  drawTree (xs + x32, ys + y32, 0.0025, 0.35, phi);
		  drawTree (xs + x33, ys + y33, 0.0015, 0.2, phi);
		}
		else if (f [x] [y] == DWARFPINES2)
		{
		  gl->enableTextures (textree3->textureID);
		  drawTree (xs + x21, ys + y21, 0.0018, 0.26, phi);
		  drawTree (xs + x22, ys + y22, 0.0024, 0.37, phi);
		}
		else if (f [x] [y] == DWARFPINES3)
		{
		  gl->enableTextures (textree3->textureID);
		  drawTree (xs, ys, 0.0027, 0.38, phi);
		}
		else if (f [x] [y] == MIXEDWOODS0)
		{
		  gl->enableTextures (textree2->textureID);
		  drawTree (xs + x41, ys + y41, 0.004, 0.26, phi);
		  drawTree (xs + x42, ys + y42, 0.0041, 0.29, phi);
		  gl->enableTextures (textree->textureID);
		  drawTree (xs + x43, ys + y43, 0.0045, 0.26, phi);
		  drawTree (xs + x44, ys + y44, 0.0038, 0.24, phi);
		}
		else if (f [x] [y] == MIXEDWOODS1)
		{
		  gl->enableTextures (textree2->textureID);
		  drawTree (xs + x31, ys + y31, 0.004, 0.27, phi);
		  gl->enableTextures (textree->textureID);
		  drawTree (xs + x32, ys + y32, 0.0045, 0.25, phi);
		  drawTree (xs + x33, ys + y33, 0.003, 0.18, phi);
		}
		else if (f [x] [y] == MIXEDWOODS2)
		{
		  gl->enableTextures (textree2->textureID);
		  drawTree (xs + x21, ys + y21, 0.0035, 0.25, phi);
		  gl->enableTextures (textree->textureID);
		  drawTree (xs + x22, ys + y22, 0.0048, 0.27, phi);
		}
		else if (f [x] [y] == MIXEDWOODS3)
		{
		  gl->enableTextures (textree->textureID);
		  drawTree (xs, ys, 0.005, 0.3, phi);
		}
		else if (f [x] [y] == REDTREE0)
		{
		  gl->enableTextures (textree4->textureID);
		  drawTree (xs, ys, 0.004, 0.35, phi);
		}
		}
        ys += step;
	  }
      xs += step;
	}
	}
	glDisable (GL_ALPHA_TEST);

    glPopMatrix ();

    gl->disableAlphaBlending ();
	}

    glDisable (GL_TEXTURE_2D);


//    } // mode

    

    }
    
    glPopMatrix ();
//    printf ("\n%d, %d + %d", zz, zz1, zz2);
  }

#define LANDSCAPE_ALPINE 0
#define LANDSCAPE_ALPINE_NOLAKE 1
#define LANDSCAPE_SEA 10
#define LANDSCAPE_MOON 20
#define LANDSCAPE_CANYON 30

GLLandscape::GLLandscape (Space *space2, int type, int *heightmask)
{
  int i, i2;
  lsticker = 0;
  space = space2;
  if (!multiplayer || isserver)
  {
  if (type == 0 || type == 1)
  {
    genSurface (60, heightmask);
    genRocks (30, 40);
    if (type == 0)
    {
      int lakes = myrandom (20) + 20;
      genLake (lakes);
      genLake (lakes / 3);
      genLake (lakes / 4);
      genLake (lakes / 4);
      genLake (2);
      genLake (2);
      genLake (2);
      genLake (2);
      genLake (2);
    }
    calcWoods (150);
  }
  else if (type == 10)
  {
    for (i = 0; i <= MAXX; i ++)
      for (i2 = 0; i2 <= MAXX; i2 ++)
      {
        f [i] [i2] = DEEPWATER;
        h [i] [i2] = 10000;
        hw [i] [i2] = 30000;
      }
  }
  else if (type == 20)
  {
    genMoonSurface ();
    for (i = 0; i <= MAXX; i ++)
      for (i2 = 0; i2 <= MAXX; i2 ++)
      {
        f [i] [i2] = MOONSAND;
      }
  }
  else if (type == 30)
  {
    genCanyonSurface (120);
  }
  }
#ifdef HAVE_SDL_NET
  if (isserver)
  {
// Send map data to all clients
    char buf [10];
    for (i = 0; i <= MAXX; i ++)
    {
    printf (" %d ", i);
      server->sendMessage (1, (char *) h [i], (MAXX + 1) * 2);
      server->sendMessage (1, (char *) hw [i], (MAXX + 1) * 2);
      server->sendMessage (1, (char *) f [i], (MAXX + 1) * 1);
      while (!server->getMessage (1, buf)) ;
    }
  }
  if (multiplayer && !isserver)
  {
//    for (;;)
//    {
    for (i = 0; i <= MAXX; i ++)
    {
//    printf (" %d ", i);
      while (!client->getMessage ((char *) h [i])) ;
      while (!client->getMessage ((char *) hw [i])) ;
      while (!client->getMessage ((char *) f [i])) ;
      client->sendMessage (".", 1);
    }
  
  }
#endif
    hh = (float) 1 / (float) MAXX;
    zoomz2 = 32768.0 * zoomz;
    hh2 = 2.0*hh;
    lv [0] = 0.0; lv [1] = 1.0; lv [2] = 1.0;
    mat [0] [0] = 0.3; mat [0] [1] = 1.0; mat [0] [2] = 0.3; mat [0] [3] = 1.0;
    mat [1] [0] = 0.5; mat [1] [1] = 0.85; mat [1] [2] = 0.2; mat [1] [3] = 1.0;
    mat [2] [0] = 0.7; mat [2] [1] = 0.7; mat [2] [2] = 0.7; mat [2] [3] = 1.0;
    mat [3] [0] = 1.0; mat [3] [1] = 1.0; mat [3] [2] = 1.0; mat [3] [3] = 1.0;
    mat [4] [0] = 0.25; mat [4] [1] = 1.0; mat [4] [2] = 0.25; mat [4] [3] = 1.0;
    mat [5] [0] = 0.2; mat [5] [1] = 1.0; mat [5] [2] = 0.2; mat [5] [3] = 1.0;
    mat [6] [0] = 0.1; mat [6] [1] = 0.25; mat [6] [2] = 1.0; mat [6] [3] = 1.0;
    mat [7] [0] = 0.5; mat [7] [1] = 0.5; mat [7] [2] = 0.5; mat [7] [3] = 1.0;
    mat [8] [0] = 0.3; mat [8] [1] = 1.0; mat [8] [2] = 0.3; mat [8] [3] = 1.0;
    mat [9] [0] = 0.1; mat [9] [1] = 0.15; mat [9] [2] = 1.0; mat [9] [3] = 1.0;
    mat [10] [0] = 0.8; mat [10] [1] = 0.8; mat [10] [2] = 0.8; mat [10] [3] = 1.0;
    mat [11] [0] = 0.95; mat [11] [1] = 0.6; mat [11] [2] = 0.4; mat [11] [3] = 1.0;
    mat [12] [0] = 0.9; mat [12] [1] = 0.75; mat [12] [2] = 0.55; mat [12] [3] = 1.0;
    for (i = 0; i < 7; i ++)
      for (i2 = 0; i2 < 4; i2 ++)
        mata [i] [i2] = mat [i] [i2] / 2.0;
    for (i = 0; i <= MAXX; i ++)
      for (i2 = 0; i2 <= MAXX; i2 ++)
        if (hw [i] [i2] == 0)
        {
          hw [i] [i2] = h [i] [i2];
        }
    precalculate ();
  }

void GLLandscape::calcDynamicLight (CExplosion **explo)
{
  int i, x, y;
  memset (dl, 0, (MAXX + 1) * (MAXX + 1));
  for (i = 0; i < maxexplosion; i ++)
  {
    if (explo [i]->ttl > 0)
    {
      int mx = MAXX / 2 + (int) explo [i]->tl->x;
      int mz = MAXX / 2 - (int) explo [i]->tl->z;
      float h = explo [i]->tl->y - getHeight (explo [i]->tl->x, explo [i]->tl->z);
      if (h < 0) h = 0;
      float radius = h / 2 + 3;
      if (h < 50)
      {
        float intens = 100.0 - 2 * h;
        for (x = mx - (int) radius; x <= mx + (int) radius; x ++)
          for (y = mz - (int) radius; y <= mz + (int) radius; y ++)
          {
            int xn = getCoord (x);
            int yn = getCoord (y);
            int dx = x - mx, dy = y - mz;
            float dist = sqrt (dx*dx + dy*dy);
            if (dist < radius)
            {
              int light = (int) ((radius - dist) * intens / radius * explo [i]->zoom) + dl [xn] [yn];
              if (light > 255) light = 255;
              dl [xn] [yn] = light;
            }
          }
      }
    }
  }
}



CExplosion *explosion [maxexplosion];
GLLandscape *l = NULL;

#define CANNON1 0
#define CANNON2 99
#define MISSILE1 100
#define MISSILE2 199
#define FIGHTER1 200
#define FIGHTER2 299
#define SHIP1 800
#define SHIP2 899
#define FLAK1 1000
#define FLAK2 1099
#define STATIC 10000

class DynamicObj : public CSpaceObj
{
  public:
  int id;
  bool controls;
  bool active;
  bool easymodel;
  int ttl, immunity;
  int impact;
  float phi, theta, gamma, speed, acceleration, realspeed; //, height;
  float forcex, forcez, forcey;
  float braking, manoeverability, maxspeed;
  float rectheta, recspeed, recheight, maxtheta, maxgamma;
  float recgamma;
  float rolleffect, ruddereffect;
  int party;
  int points;
  int sink;
  Space *space;
  DynamicObj *source;
  char net [100];
//  GLLandscape *l;
  
  int shield, maxshield;

  int net_write ()
  {
    net [0] = '.';
    int z = 1;
    memcpy (&net [z], &tl->x, sizeof (&tl->x));
    z += sizeof (&tl->x);
    memcpy (&net [z], &tl->y, sizeof (&tl->y));
    z += sizeof (&tl->y);
    memcpy (&net [z], &tl->z, sizeof (&tl->z));
    z += sizeof (&tl->z);
    memcpy (&net [z], &phi, sizeof (&phi));
    z += sizeof (&phi);
    memcpy (&net [z], &theta, sizeof (&theta));
    z += sizeof (&theta);
    memcpy (&net [z], &gamma, sizeof (&gamma));
    z += sizeof (&gamma);
    return z;
  }

  void net_read ()
  {
    int z = 1;
    memcpy (&tl->x, &net [z], sizeof (&tl->x));
    z += sizeof (&tl->x);
    memcpy (&tl->y, &net [z], sizeof (&tl->y));
    z += sizeof (&tl->y);
    memcpy (&tl->z, &net [z], sizeof (&tl->z));
    z += sizeof (&tl->z);
    memcpy (&phi, &net [z], sizeof (&phi));
    z += sizeof (&phi);
    memcpy (&theta, &net [z], sizeof (&theta));
    z += sizeof (&theta);
    memcpy (&gamma, &net [z], sizeof (&gamma));
    z += sizeof (&gamma);
  }

  void activate ()
  {
    active = true;
    draw = true;
  }
  
  void deactivate ()
  {
    active = false;
    draw = false;
  }

  void dinit ()
  {
    rot->a = 90;
    phi = 0; theta = 0; gamma = 180;
    rectheta = 0;
    tl->z = 0; tl->x = 0;
    forcex = 0; forcez = 0; forcey = 0;
    maxspeed = 0.4; braking = 0.5; manoeverability = 0.5;
    acceleration = maxspeed / 10;
    speed = maxspeed; recspeed = speed; recheight = 5.0;// height = 5.0;
    ttl = -1;
    shield = 1; maxshield = 1;
    immunity = 0;
    controls = false;
    recgamma = 180;
    id = CANNON1;
    impact = 10;
    source = NULL;
    points = 0;
    party = 0;
    easymodel = true;
    rolleffect = 0;
    ruddereffect = 0;
    maxgamma = 80;
    maxtheta = 90;
    gamma = 180;
    theta = 0;
    explode = 0;
    sink = 0;
  }

  DynamicObj ()
  {
    dinit ();
  }

  DynamicObj (Space *space2, CModel *o2, float zoom2)
  {
    this->space = space2;
    o = o2;
    zoom = zoom2;
    dinit ();
    space->addObject (this);
  }

  void toLeft ()
  {
    rectheta += manoeverability * 4;
//  if (theta > 360.0) theta -= 360.0;
  }

  void toRight ()
  {
    rectheta -= manoeverability * 4;
//    if (theta < -360.0) theta += 360.0;
  }

  void speedUp ()
  {
    recspeed += acceleration;
    if (recspeed > maxspeed) recspeed = maxspeed;
  }

  void speedDown ()
  {
    recspeed -= acceleration;
    if (recspeed < maxspeed / 2) recspeed = maxspeed / 2;
  }

  float distance (DynamicObj *target)
  {
    float dx = target->tl->x - tl->x;
    float dz = target->tl->z - tl->z;
    return sqrt (dx * dx + dz * dz);
  }

  void checkExplosion ()
  {
    if (explode > 0)
    {
      explode ++;
      if (explode == 3)
        setExplosion (0.6, 30);
      if (explode >= 35)
      {
        deactivate (); ttl = -1;
      }
    }
    if (sink)
    {
      sink ++;
      if (sink > 100)
      {
        deactivate (); ttl = -1;
      }
    }
  }

  void checkShield ()
  {
    if (shield < 0)
    {
      shield = 0;
      if (id >= MISSILE1 && id <= MISSILE2)
      { explode = 1; active = false; }
      if (id >= FIGHTER1 && id <= FIGHTER2)
      { explode = 1; active = false; }
      if (id >= SHIP1 && id <= SHIP2)
      { sink = 1; }
      if (id >= FLAK1 && id <= FLAK2)
      { explode = 1; active = false; }
      if (id == STATIC)
      { explode = 1; active = false; }
    }
//    printf ("\nshield=%d", shield); fflush (stdout);
  }
  
  void crashGround ()
  {
    if ((id >= SHIP1 && id <= SHIP1) || (id >= FLAK1 && id <= FLAK2) || id == STATIC)
      return;
    float height = tl->y - l->getExactHeight (tl->x, tl->z);
    if (height < zoom)
    {
      tl->y -= (height - zoom);
      gamma += 10;
      if (shield > 0)
      {
        if (id >= MISSILE1 && id <= MISSILE2)
          setExplosion (1.2, 25);
        if (id >= FIGHTER1 && id <= FIGHTER2)
          setExplosion (0.2, 20);
      }
      if (id >= CANNON1 && id <= CANNON2)
        deactivate ();
      shield -= 1;
//      shield += (int) height - 2;
    }
    if (height > 50) tl->y = l->getHeight (tl->x, tl->z) + 50;
  }
  
  void collide (DynamicObj *d) // d must be the medium (laser, missile)
  {
    if (immunity > 0 || d->immunity > 0) return;
    float z = d->zoom > zoom ? d->zoom : zoom;
    if ((id >= MISSILE1 && id <= MISSILE2) || (d->id >= MISSILE1 && d->id <= MISSILE2))
    {
      z *= 2;
    }
    if (id == SHIP1 || d->id == SHIP1)
      z *= 0.3;
/*    else if ((id >= CANNON1 && id <= CANNON2) || (d->id >= CANNON1 && d->id <= CANNON2))
      z *= 1.0;
    else if (id >= FLAK1 && id <= FLAK2)
      z *= 1.0;*/
    if (tl->x >= d->tl->x - z && tl->x <= d->tl->x + z &&
        tl->y >= d->tl->y - z && tl->y <= d->tl->y + z &&
        tl->z >= d->tl->z - z && tl->z <= d->tl->z + z)
    {
      shield -= d->impact;
      d->shield -= impact;
//      printf (" c(%d,%d)=>s(%d,%d)\n", id, d->id, shield, d->shield);
      if (d->source != NULL)
      {
        if (d->source->party != party)
          d->source->points += impact;
        else
          d->source->points -= impact;
      }
      setExplosion (0.2, 20);
//      printf ("collision"); fflush (stdout);
    }
  }

  void setExplosion (float maxzoom, int len)
  {
    int i;
    for (i = 0; i < maxexplosion; i ++)
      if (explosion [i]->ttl <= 0)
        break;
    if (i >= maxexplosion) i = 0;
    explosion [i]->setExplosion (tl->x, tl->y, tl->z, maxzoom, len);
  }

  int getAngle (DynamicObj *o)
  {
    float dx2 = o->tl->x - tl->x, dz2 = o->tl->z - tl->z;
	  int a, w = (int) phi;
    if (dz2 > -0.0001 && dz2 < 0.0001) dz2 = 0.0001;

    a = (int) (atan (dx2 / dz2) * 180 / mypi);
    if (dz2 > 0)
    {
      if (dx2 > 0) a -= 180;
      else a += 180;
    }
    int aw = a - w;
    if (aw < -180) aw += 360;
    if (aw > 180) aw -= 360;
    return aw;
  }
  
  void move ()
  {
    if (id == STATIC) return;
    checkExplosion ();
    if (sink) // only ships
    {
      tl->y -= 0.02;
      gamma = recgamma = 180.0 + 0.5 * (float) sink;
      return;
    }
    if (!active) return;
    int theta0 = (int) theta;
    while (theta0 < 0) theta0 += 360;
    while (theta0 > 360) theta0 -= 360;
    if (easymodel)
    {
      if (id >= FLAK1 && id <= FLAK2)
      {
        phi += sine [(int) theta0] * manoeverability * 10.0;
      }
      else
      {
        float div = maxspeed + speed;
        if (div == 0) div = 1;
        phi += sine [(int) theta0] * manoeverability * 10.0 * maxspeed / div;
      }
    }
    else
    {
      int vz = 1;
      if (gamma < 90 || gamma > 270)
        vz = -1;
      phi += vz * sine [(int) theta0] * rolleffect * manoeverability * 10.0 * maxspeed / (maxspeed + speed);
      gamma += cosi [(int) theta0] * rolleffect * manoeverability * 10.0 * maxspeed / (maxspeed + speed);
      phi += -vz * cosi [(int) theta0] * ruddereffect * manoeverability * 1.0 * maxspeed / (maxspeed + speed);
      gamma += sine [(int) theta0] * ruddereffect * manoeverability * 1.0 * maxspeed / (maxspeed + speed);
    }
    if (phi < 0) phi += 360.0;
    else if (phi >= 360.0) phi -= 360.0;

    if (easymodel)
    {
      if (rectheta > maxtheta) rectheta = maxtheta;
      else if (rectheta < -maxtheta) rectheta = -maxtheta;
    if (recgamma > 180 + maxgamma) recgamma = 180 + maxgamma;
    else if (recgamma < 180 - maxgamma) recgamma = 180 - maxgamma;

    }

  	if (controls)
    {
	  }

    if (recspeed > speed) speed += acceleration / 5;
    else if (recspeed < speed) speed -= acceleration / 5;
    forcez += speed * cosi [(int) gamma] * cosi [(int) phi];
    forcex += speed * cosi [(int) gamma] * sine [(int) phi];
//	if (!controls)
      forcey -= speed * sine [(int) gamma];
//	else
//	  forcey -= speed * sine [(int) recgamma];
    forcex *= braking; forcez *= braking; forcey *= braking;
    tl->x += forcex;
    tl->z += forcez;
    tl->y += forcey;
//	tl->y = l->getHeight (tl->x, tl->z)+5;
//	gamma = 180;
    rot->setAngles ((short) (90 + gamma - 180), (short) theta + 180, (short) -phi);
    realspeed = sqrt (forcex * forcex + forcez * forcez);
    if (ttl > 0) ttl --;
    if (ttl == 0)
    {
	    if (id >= MISSILE1 && id <= MISSILE2) recheight = -10;
	    else deactivate ();
    }
    checkShield ();
    if (id >= FLAK1 && id <= FLAK1)
    {
    }
    else
    {
      crashGround ();
    }
    if (immunity > 0) immunity --;
  }

};

class AIObj : public DynamicObj
{
  protected:
  public:
  bool ai;
  DynamicObj *target;
  int acttype;
  int intelligence;
  int manoevertheta, manoeverheight;
  int idle;
  int missiles, firemissilettl;
  int aw; // aktueller Winkel zum Ziel
  float dtheta, dgamma;
  float disttarget; // aktuelle Distanz zum Ziel
  CSmoke *smoke;

  void aiinit ()
  {
    acttype = 0;
    intelligence = 100;
    ai = true;
    active = true;
    draw = true;
    target = NULL;
	  controls = true;
	  dtheta = 0;
	  dgamma = 0;
	  id = MISSILE1;
    impact = 30;
    manoevertheta = 0;
    manoeverheight = 0;
    idle = 0;
    firemissilettl = 0;
    aw = 0;
    source = NULL;
    points = 0;
    easymodel = true;
    rolleffect = 0;
    ruddereffect = 0;
    gamma = 180;
    theta = 0;
    maxgamma = 80;
    maxtheta = 90;
  }

  AIObj ()
  {
    o = NULL;
    zoom = 1.0;
    aiinit ();
    smoke = new CSmoke (0);
  }

  AIObj (Space *space2, CModel *o2, float zoom2)
  {
    this->space = space2;
    o = o2;
    zoom = zoom2;
    aiinit ();
    smoke = new CSmoke (0);
    space->addObject (this);
  }
  
  void initValues (DynamicObj *dobj, float phi)
  {
    // Hier bitte exakte Kugelkoordinaten auf Grund von gamma und theta verwenden!
    dobj->tl->x = tl->x + cosi [(int) gamma] * sine [(int) phi] * zoom / 2;
    dobj->tl->y = tl->y - sine [(int) gamma] * zoom / 2;
    if (id >= FLAK1 && id <= FLAK2)
      dobj->tl->y += zoom;
    dobj->tl->z = tl->z + cosi [(int) gamma] * cosi [(int) phi] * zoom / 2;
    dobj->phi = phi;
    dobj->theta = 0;
    dobj->rectheta = dobj->theta;
    dobj->forcex = forcex;
    dobj->forcey = forcey;
    dobj->forcez = forcez;
  }

  void fireCannon (DynamicObj *laser, float phi)
  {
    laser->speed = speed + 0.4;
    laser->realspeed = realspeed + 0.4;
    laser->recspeed = laser->speed;
    laser->manoeverability = 0.0;
    laser->maxspeed = 1.0;
	  if (target != NULL && ai)
    {
	    if (target->active)
	    {
	      float timelaser = distance (target) / (laser->realspeed - target->realspeed); // urks, should be target->speed*(norm2(v_target||v_laser))
	      laser->gamma = 180.0 + atan ((target->tl->y - tl->y) / timelaser / laser->realspeed) * 180.0 / pitab;
	    }
	  }
	  else
      laser->gamma = gamma; // + 90.0;
	  laser->party = party;
    laser->ttl = 50;
    laser->shield = 1;
    laser->immunity = (int) (zoom * 10);
    laser->source = this;
    initValues (laser, phi);
    laser->activate ();
    laser->phi = phi;
  }

  void fireCannon (DynamicObj **laser, float phi)
  {
    int i;
    for (i = 0; i < maxlaser; i ++)
    {
      if (!laser [i]->active) break;
    }
//    printf ("i=%d, ", i); fflush (stdout);
    if (i < maxlaser)
    {
//      printf ("e%d ", i); fflush (stdout);
      fireCannon (laser [i], phi);
//      printf ("l%d ", i); fflush (stdout);
    }
  }

  void fireCannon (DynamicObj **laser)
  {
    fireCannon (laser, phi);
  }

  void fireMissile2 (AIObj *missile, AIObj *target)
  {
    missile->dinit ();
    missile->aiinit ();
    initValues (missile, phi);
    missile->id = MISSILE1;
    missile->explode = 0;
    missile->speed = speed + 0.0005;
    missile->recspeed = 0.5;
    missile->manoeverability = 3.0;
    missile->maxspeed = 0.5;
//    missile->gamma = gamma / 2.0 + 90.0;
    missile->gamma = gamma;
    missile->target = target;
    missile->recgamma = gamma;
    missile->ai = true;
    missile->ttl = 200;
	  missile->recheight = 5;
	  missile->party = party;
    missile->shield = 1;
    missile->immunity = 15 + (int) (zoom * 5.0);
	  missile->dtheta = 0;
	  missile->dgamma = 0;
    missile->source = this;
    missile->activate ();
  }

  void fireMissile (AIObj **missile, AIObj *target)
  {
    int i;
    if (missiles <= 0) return;
    for (i = 0; i < maxmissile; i ++)
    {
      if (missile [i]->ttl <= 0) break;
    }
    if (i < maxmissile)
    {
      fireMissile2 (missile [i], target);
      missiles --;
      firemissilettl = 100;
    }
  }

  void fireMissile (AIObj **missile)
  {
    fireMissile (missile, (AIObj *) target);
  }
  
  void targetNearestEnemy (AIObj **f)
  {
    int i;
    float d = 10000;
    for (i = 0; i < maxfighter; i ++)
    {
      if (this != f [i] && party != f [i]->party && f [i]->active)
      {
        float d2 = distance (f [i]);
        if (d2 < d)
        {
          d = d2;
          target = f [i];
        }
      }
    }
  }

  void targetNext (AIObj **f)
  {
    int i;
//    float d = 10000;
    if (target == NULL) target = f [0];
    for (i = 0; i < maxfighter; i ++)
      if (target == f [i])
        break;
    i ++;
    if (i >= maxfighter) i = 0;
    if (target == this) i ++;
    if (i >= maxfighter) i = 0;
    target = f [i];
  }

  void targetPrevious (AIObj **f)
  {
    int i, lastfighter = 0;
//    float d = 10000;
    if (target == NULL) target = f [0];
    for (i = maxfighter - 1; i >= 0; i --)
      if (f [i]->active)
      {
        lastfighter = i;
        break;
      }
    for (i = 0; i < maxfighter; i ++)
      if (target == f [i])
        break;
    i --;
    if (i >= 0) i = lastfighter;
    if (target == this) i --;
    if (i >= 0) i = lastfighter;
    target = f [i];
  }

  void aiAction (AIObj **f, AIObj **m, DynamicObj **c)
  {
    if (!active && !draw) return;

    if (firemissilettl > 0) firemissilettl --;

    // Set smoke
    if (ai) // at the moment no smoke for player's fighter
    if ((id >= MISSILE1 && id <= MISSILE2) || (id >= FIGHTER1 && id <= FIGHTER2))
    {
      float sz = cosi [(int) gamma] * cosi [(int) phi] * zoom * 0.5;
      float sy = 0; //-sine [(int) gamma] * zoom * 0.5;
      float sx = cosi [(int) gamma] * sine [(int) phi] * zoom * 0.5;
      smoke->move ();
      smoke->setSmoke (tl->x - sx - forcex * 0.67, tl->y - sy - forcey * 0.67, tl->z - sz - forcez * 0.67, (int) phi, 8);
      smoke->setSmoke (tl->x - sx - forcex * 0.33, tl->y - sy - forcey * 0.33, tl->z - sz - forcez * 0.33, (int) phi, 9);
      smoke->setSmoke (tl->x - sx, tl->y - sy, tl->z - sz, (int) phi, 10);
    }

    // Move object according to our physics
    move ();

    if (!active) return;
    if (explode || sink) return;

    // Do expensive calculations only once
    float myheight = l->getExactHeight (tl->x, tl->z);
    float targetheight = tl->y;
    if (target != NULL)
      targetheight = l->getExactHeight (target->tl->x, target->tl->z);

    // Which height???
    float recheight2; // this is the height, the object wants to achieve
    float flyx = tl->x + forcex * 6, flyz = tl->z + forcez * 6;
    if (ttl != 0)
    {
       // missiles and non intelligent objects will not change their height due to the surface
      if ((id >= MISSILE1 && id <= MISSILE2 && target != NULL) ||
          (tl->y - myheight > 6 && target != NULL && tl->y - myheight < 50 && !manoeverheight))
      {
        recheight2 = target->tl->y - 8 * target->speed * sine [(int) target->gamma];
      }
      else
      {
        // precalculated height
        recheight2 = l->getExactHeight (flyx, flyz) + recheight;
      }
	  }
    else recheight2 = -100;

    if (manoeverheight > 0) manoeverheight --;
    if (!manoeverheight)
    {
      if (!(id >= FIGHTER1 && id <= FIGHTER2) && target != NULL)
      {
        recheight = target->tl->y - targetheight;
      }
      else if (id >= FIGHTER1 && id <= FIGHTER2 && target != NULL)
	    {
  	    recheight = target->tl->y - targetheight;
        if (!l->isWater (l->f [(int) flyx] [(int) flyz]))
        {
	        if (recheight < 4) recheight = 4;
          if (maxgamma < 40)
            if (recheight < 8) recheight = 8;
        }
        float minh = 2.0;
        if (l->type == 2) minh = 5.0;
        if (fabs (l->getHeight (flyx, flyz) - myheight) < minh)
        {
          recheight = 10;
          manoeverheight = 30;
        }
/*        if (myrandom (intelligence + 50) == 0)
        {
          recheight = 10.0 * fabs (l->getHeight (flyx, flyz) - myheight);
          manoeverheight = 15;
        }*/
	    }
    }

    if (ai)
      recgamma = (int) ((recheight2 - tl->y) * 10 - gamma + 360);

//	recgamma = 180 + atan ((recheight2 - tl->y) / speed) * 180 / pitab;
//	if (recgamma < -80) recgamma = -80;
//	if (recgamma > 80) recgamma = 80;
/*  if (recgamma > gamma + 4) gamma += (recgamma - gamma) / 8 + 1;
    else if (recgamma < gamma - 4) gamma += (recgamma - gamma) / 8 - 1;
    if (gamma > 250) gamma = 250;
    if (gamma < 110) gamma = 110;*/

  float nimbility;

	float deltatheta = rectheta - theta;
	nimbility = 1;
	if (deltatheta > 0 && dtheta < 0) dtheta += nimbility;
	else if (deltatheta < 0 && dtheta > 0) dtheta -= nimbility;
	else if (deltatheta > 0)
	{
	  float estimatedtheta = dtheta * (dtheta + nimbility) / 2 / nimbility;
	  if (deltatheta > estimatedtheta + 2) dtheta += nimbility;
	  else if (deltatheta < estimatedtheta - 2) dtheta -= nimbility;
	}
	else
	{
	  float estimatedtheta = -dtheta * (dtheta - nimbility) / 2 / nimbility;
	  if (deltatheta < estimatedtheta - 2) dtheta -= nimbility;
	  else if (deltatheta > estimatedtheta + 2) dtheta += nimbility;
	}
	theta += dtheta;

  if (easymodel)
  {
	if (theta > maxtheta) theta = maxtheta;
	else if (theta < -maxtheta) theta = -maxtheta;

	float deltagamma = recgamma - gamma;
	nimbility = maxspeed * 2;
	if (deltagamma > 0 && dgamma < 0) dgamma += nimbility;
	else if (deltagamma < 0 && dgamma > 0) dgamma -= nimbility;
	else if (deltagamma > 0)
	{
	  float estimatedgamma = dgamma * (dgamma + nimbility) / nimbility;
	  if (deltagamma > estimatedgamma + 2) dgamma += nimbility;
	  else if (deltagamma < estimatedgamma - 2) dgamma -= nimbility;
	}
	else if (deltagamma < 0)
	{
	  float estimatedgamma = -dgamma * (dgamma - nimbility) / nimbility;
	  if (deltagamma < estimatedgamma - 2) dgamma -= nimbility;
	  else if (deltagamma > estimatedgamma + 2) dgamma += nimbility;
	}
	gamma += dgamma;

  }
  
  if (easymodel)
  {
	  if (gamma > 180 + maxgamma) gamma = 180 + maxgamma;
	  else if (gamma < 180 - maxgamma) gamma = 180 - maxgamma;
  }
  else
  {
    if (gamma > 270)
    {
      gamma = 540 - gamma;
      theta += 180;
      phi += 180;
      rectheta += 180;
      if (theta >= 360) theta -= 360;
      if (rectheta >= 360) rectheta -= 360;
      if (phi >= 360) phi -= 360;
    }
    else if (gamma < 90)
    {
      gamma = 180 - gamma;
      theta += 180;
      phi += 180;
      rectheta += 180;
      if (theta >= 360) theta -= 360;
      if (rectheta >= 360) rectheta -= 360;
      if (phi >= 360) phi -= 360;
    }
  }

/*	  if (gamma > 180 + maxgamma) gamma = 180 + maxgamma;
	  else if (gamma < 180 - maxgamma) gamma = 180 - maxgamma;*/

    if (target == NULL)
      targetNearestEnemy (f);
    if (target != NULL)
      if (!target->active)
        targetNearestEnemy (f);

    if (!ai) return;

    if (target == NULL) return;

  disttarget = distance (target); // distance to target

	float dx2, dz2, ex, ez;
  float dx = target->tl->x - tl->x, dz = target->tl->z - tl->z; // actual distances
	if ((id >= FIGHTER1 && id <= FIGHTER2) || (id >= MISSILE1 && id <= MISSILE2) || (id >= FLAK1 && id <= FLAK2))
	{
	  float t = 10.0 * disttarget; // generous time to new position
	  if (t > 60) t = 60; // higher values will not make sense
    int tt = (int) target->theta;
    if (tt < 0) tt += 360;
	  float newphi = t * sine [tt] * 5.0 * target->manoeverability; // new angle of target after time t
    if (newphi > 90) newphi = 90;
    else if (newphi < -90) newphi = -90;
    newphi += (float) target->phi;
	  if (newphi >= 360) newphi -= 360;
	  if (newphi < 0) newphi += 360;
    if ((id >= FIGHTER1 && id <= FIGHTER2) || (id >= FLAK1 && id <= FLAK2))
    {
      ex = target->tl->x - sine [(int) newphi] * t * target->realspeed * 0.25; // estimated target position x
      ez = target->tl->z - cosi [(int) newphi] * t * target->realspeed * 0.25; // estimated target position z
    }
    else
    {
      ex = target->tl->x - sine [(int) newphi] * t * target->realspeed * 0.05; // estimated target position x
      ez = target->tl->z - cosi [(int) newphi] * t * target->realspeed * 0.05; // estimated target position z
    }
    dx2 = ex - tl->x; dz2 = ez - tl->z; // estimated distances
	}
	else
	{
	  dx2 = dx; dz2 = dz;
	}
    int a, w = (int) phi;
    if (dz2 > -0.0001 && dz2 < 0.0001) dz2 = 0.0001;

/*  if (intelligence == 0)
  {
	m [0]->tl->x = ex; //tl->x + dx2; // visualize estimated point by a missile
	m [0]->tl->z = ez; //tl->z + dz2;
	m [0]->active = false;
	m [0]->draw = true;
	m [0]->tl->y = target->tl->y;
  }*/

    a = (int) (atan (dx2 / dz2) * 180 / mypi);
    if (dz2 > 0)
    {
      if (dx2 > 0) a -= 180;
      else a += 180;
    }
//    this->aw = a;
    aw = a - w;
    if (aw < -180) aw += 360;
    if (aw > 180) aw -= 360;


    if (manoevertheta > 0) manoevertheta --;
    if (id >= FIGHTER1 && id <= FIGHTER2)
    {
    if (!acttype && disttarget <= 1000 && !manoevertheta)
    {
      if (aw > 0)
      {
        if (aw > 180 - intelligence / 20 && disttarget < 15)
        {
          rectheta = -90;
          manoevertheta = 10 + myrandom ((400 - intelligence) / 4);
          recspeed = maxspeed - myrandom (intelligence) * 0.0003;
          if (!manoeverheight)
          { recheight = 5; manoeverheight = 8 - intelligence / 50; }
        }
        else
        {
          int maw = aw > 90 ? 90 : aw;
          maw = 90 - maw;
          rectheta = 90 - maw * intelligence / 100;
        }
      }
      else
      {
        if (aw < -180 + intelligence / 20 && disttarget < 15)
        {
          rectheta = 90;
          manoevertheta = 10 + myrandom ((400 - intelligence) / 4);
          recspeed = maxspeed - myrandom (intelligence) * 0.0003;
          if (!manoeverheight)
          { recheight = 5; manoeverheight = 8 - intelligence / 50; }
        }
        else
        {
          int maw = aw < -90 ? -90 : aw;
          maw = -90 - maw;
          rectheta = -90 - maw * intelligence / 100;
        }
//        rectheta = -90;
      }
//      if (rectheta > theta + 5.0) toLeft ();
//      else if (rectheta < theta - 5.0) toRight ();
    }
    }
    else if (id >= MISSILE1 && id <= MISSILE2)
    {
      if (aw > 0)
      {
        rectheta = aw > 90 ? 90 : aw;
      }
      else
      {
        rectheta = aw < -90 ? -90 : aw;
      }
    }
    else if (id >= FLAK1 && id <= FLAK2)
    {
      recspeed = 0; speed = 0;
      if (aw > 0)
      {
        rectheta = aw > 90 ? 90 : aw;
      }
      else
      {
        rectheta = aw < -90 ? -90 : aw;
      }
    }
    if (id >= FIGHTER1 && id <= FIGHTER2)
    {
      if (disttarget > 3) // + aggressivity
  	  {
        if (disttarget < 50 && abs (aw) > 30)
          recspeed = maxspeed / 2;
        else speedUp ();
	    }
      else
      {
        if (recspeed > target->speed)
		    {
          speedDown ();
		    }
        else
    		{
          speedUp ();
		    }
      }
      if (disttarget > 60 && abs (aw) < 20)
        rectheta = 0; // fly straight
      if (fabs (rectheta - theta) < 3 && fabs (aw) < 35 && disttarget < 30) // + aggressive
  	    fireCannon (c);
      else if (disttarget < 3 && fabs (aw) < 35) // + aggressive
  	    fireCannon (c);
      if (!firemissilettl)
        if (fabs (rectheta - theta) < 3 && fabs (aw) < 35 && disttarget < 30 && target->theta < 20) // + aggressive
  	      fireMissile (m);
      if (!manoevertheta)
      {
        rectheta += myrandom (intelligence) - intelligence / 2;
        if (rectheta > 90 - intelligence / 5) rectheta = 90 - intelligence / 5;
        else if (rectheta < -90 + intelligence / 5) rectheta = -90 + intelligence / 5;
      }
//      if (recspeed > maxspeed - 0.001 * intelligence)
//        recspeed = maxspeed - 0.001 * intelligence;
      idle ++;
      if (idle > 400)
      {
        idle = 0;
        if (rectheta < 0)
        { rectheta = 90; manoevertheta = 50 + myrandom (100); }
        if (rectheta > 0)
        { rectheta = -90; manoevertheta = 50 + myrandom (100); }
      }
    }

    if ((id >= FLAK1 && id <= FLAK2) || id == SHIP1)
    {
      if (!(l->lsticker & 4))
      for (int i = 0; i < maxfighter; i ++)
      if (party != f [i]->party)
      {
        disttarget = distance (f [i]); // distance to target
        ex = f [i]->tl->x; // estimated target position x
        ez = f [i]->tl->z; // estimated target position z
        dx2 = ex - tl->x; dz2 = ez - tl->z; // estimated distances
        w = (int) phi;
        if (dz2 > -0.0001 && dz2 < 0.0001) dz2 = 0.0001;
        a = (int) (atan (dx2 / dz2) * 180 / mypi);
        if (dz2 > 0)
        {
          if (dx2 > 0) a -= 180;
          else a += 180;
        }
        aw = a - w;
        if (aw < -180) aw += 360;
        if (aw > 180) aw -= 360;
        if (id >= FLAK1 && id <= FLAK2)
          if (fabs (aw) < 35 && disttarget < 40) // + aggressive
    	      fireCannon (c);
        if (id == SHIP1)
        {
          if (!(l->lsticker & 31))
          if (fabs (aw) >= -10 && fabs (aw) < 10 && disttarget < 40) // + aggressive
          {
    	      fireMissile (m, f [i]);
            missiles ++;
          }
          if (fabs (aw) >= 0 && fabs (aw) < 40 && disttarget < 40) // + aggressive
    	      fireCannon (c, aw);
          if (fabs (aw) >= -40 && fabs (aw) < 0 && disttarget < 40) // + aggressive
    	      fireCannon (c, aw + 360);
          if (fabs (aw) >= 120 && fabs (aw) < 160 && disttarget < 40) // + aggressive
    	      fireCannon (c, aw);
          if (fabs (aw) >= -160 && fabs (aw) < -120 && disttarget < 40) // + aggressive
    	      fireCannon (c, aw + 360);
        }
      }
      rectheta += myrandom (intelligence) - intelligence / 2;
      if (rectheta > 90 - intelligence / 5) rectheta = 90 - intelligence / 5;
      else if (rectheta < -90 + intelligence / 5) rectheta = -90 + intelligence / 5;
    }
  }
};

class Fighter : public AIObj
{
  public:
  void fighterinit ()
  {
    shield = 100; maxshield = 100;
    id = FIGHTER1;
    speed = 0.3;
    recspeed = 0.3;
    smoke->type = 1;
    impact = 2;
    missiles = 10;
    ttl = -1;
    easymodel = true;
    rolleffect = 0;
    ruddereffect = 0;
  }
  Fighter ()
  {
    o = NULL;
    zoom = 1.0;
    fighterinit ();
  }
  Fighter (Space *space2, CModel *o2, float zoom2)
  {
    o = o2;
    zoom = zoom2;
    this->space = space2;
    fighterinit ();
    space->addObject (this);
  }
};

class Star
{
  public:
  int phi, gamma;
  float size;
  Star (int phi, int gamma, float size)
  {
    this->phi = phi;
    this->gamma = gamma;
    this->size = size;
  }
  void draw ()
  {
    glPointSize (size);
//    gl->enableAntiAliasing ();
    glBegin (GL_POINTS);
    glColor3ub (255, 255, 255);
    glVertex3f (0, 0, 0);
    glEnd ();
//    gl->disableAntiAliasing ();
  }
};






CLoad3DS g_Load3ds;
CModel model_fig;
CModel model_figa;
CModel model_figt;
CModel model_cannon1;
CModel model_cannon2;
CModel model_missile;
CModel model_wall1;
CModel model_flak1;
CModel model_tent1;
CModel model_ship1;




/*void RenderScene() 
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();									// Reset The matrix
    glShadeModel (GL_SMOOTH);
	glRotatef (-50, 1, 1, 1);

//////////// *** NEW *** ////////// *** NEW *** ///////////// *** NEW *** ////////////////////

	// Give OpenGL our position,	then view,		then up vector
//	gluLookAt(		0, 1.5f, 8,		0, 0.5f, 0,			0, 1, 0);
	
	// We want the model to rotate around the axis so we give it a rotation
	// value, then increase/decrease it. You can rotate right of left with the arrow keys.


	// Since we know how many objects our model has, go through each of them.
//model.draw ();

//////////// *** NEW *** ////////// *** NEW *** ///////////// *** NEW *** ////////////////////

	glutSwapBuffers ();
}
*/

void drawText (float x, float y, float z, char *str, CColor *c)
{
  int len = strlen (str);
  float zoom = 0.1;
  glDisable (GL_LIGHTING);
  glDisable (GL_DEPTH_TEST);
  gl->enableTextures (texfont1->textureID);
  gl->enableAlphaBlending ();
  glEnable (GL_ALPHA_TEST);
  glAlphaFunc (GL_GEQUAL, 0.1);
  glBegin (GL_QUADS);
  glColor4ub (c->c [0], c->c [1], c->c [2], c->c [3]);
  for (int i = 0; i < len; i ++)
  if (str [i] >= '-' && str [i] <= 'Z')
  {
    int c = (int) (str [i] - '-');
    if (c >= 14) c = (int) (str [i] - 'A') + 14;
    float dx = 34.0 / 256.0;
    float dy = 42.0 / 256.0, dy2 = dy;
    float tx = dx * (c % 7);
    float ty = 1.0 - dy * (c / 7);
    glTexCoord2f (tx, ty - dy2);
    glVertex3f ((x + i) * zoom, y * zoom, z);
    glTexCoord2f (tx, ty);
    glVertex3f ((x + i) * zoom, (y + 1) * zoom, z);
    glTexCoord2f (tx + dx, ty);
    glVertex3f ((x + i + 1) * zoom, (y + 1) * zoom, z);
    glTexCoord2f (tx + dx, ty - dy2);
    glVertex3f ((x + i + 1) * zoom, y * zoom, z);
  }
  glEnd ();
  glDisable (GL_ALPHA_TEST);
  gl->disableAlphaBlending ();
  glDisable (GL_TEXTURE_2D);
}

void drawText (float x, float y, float z, char *str)
{
  CColor stdcol (255, 255, 255, 190);
  drawText (x, y, z, str, &stdcol);
}

void drawTextRotated (float x, float y, float z, char *str, CColor *col, int timer)
{
  int len = strlen (str);
  float zoom = 0.1;
  glDisable (GL_LIGHTING);
  glDisable (GL_DEPTH_TEST);
  gl->enableTextures (texfont1->textureID);
  gl->enableAlphaBlending ();
  glEnable (GL_ALPHA_TEST);
  glAlphaFunc (GL_GEQUAL, 0.1);
  for (int i = 0; i < len; i ++)
  if (str [i] >= '-' && str [i] <= 'Z')
  {
    int c = (int) (str [i] - '-');
    if (c >= 14) c = (int) (str [i] - 'A') + 14;
    float dx = 34.0 / 256.0;
    float dy = 42.0 / 256.0, dy2 = dy;
    float tx = dx * (c % 7);
    float ty = 1.0 - dy * (c / 7);
    glPushMatrix ();
    glTranslatef ((0.5 + x + i) * zoom, (0.5 + y) * zoom, z);
    gl->rotate (timer + i * 20, 0, 0);
    glBegin (GL_QUADS);
    glColor4ub (col->c [0], col->c [1], col->c [2], col->c [3]);
    glTexCoord2f (tx, ty - dy2);
    glVertex3f (-0.5 * zoom, -0.5 * zoom, 0);
    glTexCoord2f (tx, ty);
    glVertex3f (-0.5 * zoom, 0.5 * zoom, 0);
    glTexCoord2f (tx + dx, ty);
    glVertex3f (0.5 * zoom, 0.5 * zoom, 0);
    glTexCoord2f (tx + dx, ty - dy2);
    glVertex3f (0.5 * zoom, -0.5 * zoom, 0);
    glEnd ();
    glPopMatrix ();
  }
  gl->disableAlphaBlending ();
  glDisable (GL_ALPHA_TEST);
  glDisable (GL_TEXTURE_2D);
}










AIObj *missile [maxmissile];
DynamicObj *laser [maxlaser];
Fighter *fighter [maxfighter];
Star *star [maxstar];
DynamicObj *groundobj [maxgroundobj];
Flash *flash1;

Space *space;

AIObj *fplayer;
CSpaceObj *sphere;
CSphere *objsphere;

//GLLandscape *l;
CModel *obj, *objlaser, *objmissile;
CVector3 *clip1, *clip2, *tlnull, *tlinf, *tlminf;

GLenum polygonMode = GL_FILL;

GLfloat light_position0[] = { 0.0, 0.5, -1.0, 0 };

#define max(x,y) ((x)>(y)?(x):(y))

int NX, NY;

int joystick;

class Mission
{
  public:
  int timer;
  Mission ()
  {
    timer = 0;
  }
  void init ()
  {
  }
  virtual int processtimer ()
  {
    return 0;
  }
  virtual void draw ()
  {
  }
  int getScore (int missionstate)
  {
    double score = fplayer->points;
    if (missionstate == 2)
    {
      score /= 2;
      score += 10;
    }
    score *= pow (2, -(double)timer/1000);
    score += 10;
    return (int) score;
  }
};

class MissionDemo1 : public Mission
{
  public:
  MissionDemo1 ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_ALPINE, NULL);
    day = 0;
    weather = 0;
    camera = 5;
    sungamma = 45;
    for (i = 0; i <= 8; i ++)
      fighter [i]->activate ();
  fplayer = fighter [0];
  fplayer->ai = true;
  fplayer->party = 1;
  fplayer->tl->x = 220;
  fplayer->tl->z = -30;
  fplayer->target = fighter [2];
  fplayer->intelligence = 0;
  fighter [1]->intelligence = 200;
  fighter [1]->party = 0;
  fighter [1]->target = fighter [0];
  fighter [1]->o = &model_figa;
  fighter [2]->intelligence = 390;
  fighter [2]->party = 0;
  fighter [2]->target = fighter [0];
  fighter [2]->o = &model_figa;
  fighter [3]->intelligence = 360;
  fighter [3]->party = 0;
  fighter [3]->target = fighter [0];
  fighter [3]->o = &model_figa;
  fighter [4]->intelligence = 330;
  fighter [4]->party = 0;
  fighter [4]->target = fighter [7];
  fighter [4]->o = &model_figa;
  fighter [5]->intelligence = 300;
  fighter [5]->party = 0;
  fighter [5]->target = fighter [7];
  fighter [5]->o = &model_figa;
  fighter [6]->intelligence = 150;
  fighter [6]->party = 0;
  fighter [6]->target = fighter [0];
  fighter [6]->o = &model_figa;
  fighter [7]->intelligence = 0;
  fighter [7]->party = 1;
  fighter [7]->target = fighter [1];
  fighter [7]->o = &model_fig;
  fighter [7]->tl->x = 49;
  fighter [7]->tl->z = -30;
  fighter [7]->tl->y = l->getHeight (49, -30) + 15;
  fighter [8]->intelligence = 200;
  fighter [8]->party = 0;
  fighter [8]->target = fighter [0];
  fighter [8]->o = &model_figa;
  }
  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 8; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }
  virtual void draw ()
  {
  }
};

class MissionTutorial1 : public Mission
{
  public:
  MissionTutorial1 ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_ALPINE, NULL);
//    l = new GLLandscape (space, LANDSCAPE_CANYON, NULL);
    day = 1;
    weather = 0;
    camera = 0;
    sungamma = 50;
//    sungamma = 20;
    for (i = 0; i <= 0; i ++)
      fighter [i]->activate ();
    fplayer = fighter [0];
    fplayer->ai = false;
    if (joystick > 0)
      fplayer->easymodel = false;
    fplayer->party = 1;
    fplayer->tl->x = 220;
    fplayer->tl->z = -30;
    fplayer->target = NULL;
    fplayer->intelligence = 0;
    fplayer->recspeed = fplayer->maxspeed / 4;
  }
  virtual int processtimer ()
  {
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
      return 2;
    if (!fighter [1]->active && fighter [1]->explode >= 35)
      return 1;
    return 0;
  }
  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      drawText (-4, 0, -1, "TUTORIAL");
    }
    else if (timer > 80 && timer <= 230)
    {
      drawText (-10, 1, -2, "FIRST FLY AROUND AND");
      drawText (-10, 0, -2, "GAIN CONTROL OF YOUR");
      drawText (-10, -1, -2, "FIGHTER");
    }
    else if (timer > 300 && timer <= 450)
    {
      if (joystick)
      {
      }
      else
      {
        drawText (-10, 1, -2, "NO JOYSTICK AVAILABLE");
        drawText (-10, 0, -2, "PLEASE USE THE MOUSE");
      }
    }
    else if (timer > 500 && timer <= 700)
    {
      drawText (-10, 1, -2, "AN ENEMY TRANSPORT");
      drawText (-10, 0, -2, "IS IN THE AREA");
      drawText (-10, -1, -2, "TAKE IT OUT");
    }
    else if (timer > 750 && timer <= 900)
    {
      drawText (-10, 1, -2, "TARGETED TRANSPORT!");
      drawText (-10, 0, -2, "WATCH RED ARROWS ON");
      drawText (-10, -1, -2, "THE TOP OF THE HUD");
    }
    if (timer == 500)
    {
      fighter [1]->activate ();
      fighter [1]->intelligence = 400;
      fighter [1]->party = 0;
      fighter [1]->target = fighter [0];
      fighter [1]->o = &model_figt;
      
      fighter [1]->maxspeed = 0.2;
      fighter [1]->acceleration = fighter [1]->maxspeed / 10;
      fighter [1]->maxshield = 45;
      fighter [1]->missiles = 0;
      fighter [1]->manoeverability = 0.1;
      fighter [1]->impact = 5;
      fighter [1]->zoom = 1.5;
      fighter [1]->maxgamma = 20;
      fighter [1]->maxtheta = 40;
      fighter [1]->tl->x = fplayer->tl->x - 80;
      fighter [1]->tl->z = fplayer->tl->z - 80;

    }
  }
};

class MissionDogfight1 : public Mission
{
  public:
  MissionDogfight1 ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_ALPINE, NULL);
    day = 1;
    weather = 0;
    camera = 0;
    sungamma = 25;
    for (i = 0; i <= 0; i ++)
      fighter [i]->activate ();
    fplayer = fighter [0];
    fplayer->ai = false;
    if (joystick > 0)
      fplayer->easymodel = false;
    fplayer->party = 1;
    fplayer->tl->x = 50;
    fplayer->tl->z = 100;
    fplayer->target = NULL;
    fplayer->intelligence = 0;
    fplayer->recspeed = fplayer->maxspeed / 4;
      fighter [1]->activate ();
      fighter [1]->intelligence = 400;
      fighter [1]->party = 0;
      fighter [1]->target = fighter [0];
      fighter [1]->o = &model_figa;
      fighter [2]->activate ();
      fighter [2]->intelligence = 300;
      fighter [2]->party = 0;
      fighter [2]->target = fighter [0];
      fighter [2]->o = &model_figa;
      fighter [3]->activate ();
      fighter [3]->intelligence = 150;
      fighter [3]->party = 0;
      fighter [3]->target = fighter [0];
      fighter [3]->o = &model_figa;
      fighter [4]->activate ();
      fighter [4]->intelligence = 280;
      fighter [4]->party = 0;
      fighter [4]->target = fighter [5];
      fighter [4]->o = &model_figa;
      fighter [5]->activate ();
      fighter [5]->intelligence = 100;
      fighter [5]->party = 1;
      fighter [5]->target = fighter [4];
      fighter [5]->o = &model_fig;
      fighter [5]->tl->x = 55;
      fighter [5]->tl->z = 110;
  }
  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }
  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      drawText (-4, 0, -1, "DOGFIGHT");
    }
  }
};

class MissionGround1 : public Mission
{
  public:
  MissionGround1 ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_ALPINE_NOLAKE, NULL);
    day = 0;
    weather = 1;
    camera = 0;
    sungamma = 60;
    for (i = 0; i <= 0; i ++)
      fighter [i]->activate ();
    fplayer = fighter [0];
    fplayer->ai = false;
    if (joystick > 0)
      fplayer->easymodel = false;
    int px, py;
    l->searchPlain (1, 1, &px, &py);
    l->gauss (px, py);
    px = px - MAXX / 2;
    py = MAXX / 2 - py;
    groundobj [0]->activate ();
    groundobj [0]->tl->x = px - 1;
    groundobj [0]->tl->z = py - 1;
    groundobj [0]->tl->y = l->getHeight (px - 1, py - 1);
    groundobj [0]->o = &model_tent1;
    groundobj [0]->shield = 100;
    groundobj [0]->zoom = 0.5;
    groundobj [1]->activate ();
    groundobj [1]->tl->x = px + 1;
    groundobj [1]->tl->z = py - 1;
    groundobj [1]->tl->y = l->getHeight (px + 1, py - 1);
    groundobj [1]->o = &model_tent1;
    groundobj [1]->shield = 100;
    groundobj [1]->zoom = 0.5;
    fplayer->party = 1;
    fplayer->tl->x = px + 50;
    fplayer->tl->z = py + 50;
    fplayer->tl->y = l->getHeight (fplayer->tl->x, fplayer->tl->z) + 15;
    fplayer->target = NULL;
    fplayer->intelligence = 0;
    fplayer->recspeed = fplayer->maxspeed / 4;
    for (i = 1; i <= 3; i ++)
    {
      fighter [i]->tl->x = px - 3 + i * 3;
      fighter [i]->tl->z = py + 2;
      fighter [i]->activate ();
      fighter [i]->intelligence = 400;
      fighter [i]->party = 0;
      fighter [i]->target = fighter [0];
      fighter [i]->o = &model_flak1;
      fighter [i]->maxspeed = 0;
      fighter [i]->speed = 0;
      fighter [i]->maxgamma = 0;
      fighter [i]->maxtheta = 3;
      fighter [i]->manoeverability = 20.0;
      fighter [i]->id = 1000;
    }
/*      fighter [2]->activate ();
      fighter [2]->intelligence = 300;
      fighter [2]->party = 0;
      fighter [2]->target = fighter [0];
      fighter [2]->o = &model_figa;
      fighter [3]->activate ();
      fighter [3]->intelligence = 150;
      fighter [3]->party = 0;
      fighter [3]->target = fighter [0];
      fighter [3]->o = &model_figa;*/
  }
  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }
  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      drawText (-5, 0, -1, "SA DEFENSE");
    }
  }
};

class MissionShip1 : public Mission
{
  public:
  MissionShip1 ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_SEA, NULL);
    day = 0;
    weather = 0;
    camera = 0;
    sungamma = 60;
    for (i = 0; i <= 0; i ++)
      fighter [i]->activate ();
    fplayer = fighter [0];
    fplayer->ai = false;
    if (joystick > 0)
      fplayer->easymodel = false;
    fplayer->party = 1;
    fplayer->tl->x = 50;
    fplayer->tl->z = 50;
    fplayer->tl->y = l->getHeight (fplayer->tl->x, fplayer->tl->z) + 15;
    fplayer->target = NULL;
    fplayer->intelligence = 0;
    fplayer->recspeed = fplayer->maxspeed / 4;
      fighter [2]->tl->x = 0;
      fighter [2]->tl->z = 0;
      fighter [2]->activate ();
      fighter [2]->intelligence = 400;
      fighter [2]->party = 0;
      fighter [2]->target = fighter [0];
      fighter [2]->o = &model_ship1;
      fighter [2]->zoom = 3.5;
      fighter [2]->acceleration = 0;
      fighter [2]->maxspeed = 0;
      fighter [2]->speed = 0;
      fighter [2]->maxgamma = 0;
      fighter [2]->maxtheta = 3;
      fighter [2]->manoeverability = 5.0;
      fighter [2]->id = 800;
      fighter [2]->impact = 20;
      fighter [2]->shield = 500;
    fighter [3]->activate ();
    fighter [3]->intelligence = 150;
    fighter [3]->party = 1;
    fighter [3]->target = fighter [2];
    fighter [3]->o = &model_fig;
    fighter [3]->tl->x = 60;
    fighter [3]->tl->z = 60;
  }
  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }
  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      drawText (-3.5, 0, -1, "CRUISER");
    }
  }
};

class MissionMoon1 : public Mission
{
  public:
  MissionMoon1 ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_MOON, NULL);
    day = 0;
    weather = 2;
    camera = 0;
    sungamma = 50;
    for (i = 0; i <= 0; i ++)
      fighter [i]->activate ();
    fplayer = fighter [0];
    fplayer->ai = false;
    if (joystick > 0)
      fplayer->easymodel = false;
    fplayer->party = 1;
    fplayer->tl->x = 50;
    fplayer->tl->z = 50;
    fplayer->tl->y = l->getHeight (fplayer->tl->x, fplayer->tl->z) + 15;
    fplayer->target = NULL;
    fplayer->intelligence = 0;
    fplayer->recspeed = fplayer->maxspeed / 4;
      fighter [1]->activate ();
      fighter [1]->intelligence = 400;
      fighter [1]->party = 0;
      fighter [1]->target = fighter [0];
      fighter [1]->o = &model_figa;
      fighter [2]->activate ();
      fighter [2]->intelligence = 300;
      fighter [2]->party = 0;
      fighter [2]->target = fighter [0];
      fighter [2]->o = &model_figa;
  }
  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }
  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      drawText (-2, 0, -1, "MOON");
    }
  }
};

class MissionCanyon1 : public Mission
{
  public:
  MissionCanyon1 ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_CANYON, NULL);
    day = 1;
    weather = 0;
    camera = 0;
    sungamma = 15;
    for (i = 0; i <= 0; i ++)
      fighter [i]->activate ();
    fplayer = fighter [0];
    fplayer->ai = false;
    if (joystick > 0)
      fplayer->easymodel = false;
    fplayer->party = 1;
    fplayer->tl->x = 50;
    fplayer->tl->z = 100;
    fplayer->target = NULL;
    fplayer->intelligence = 0;
    fplayer->recspeed = fplayer->maxspeed / 4;
      fighter [1]->activate ();
      fighter [1]->intelligence = 400;
      fighter [1]->party = 0;
      fighter [1]->target = fighter [0];
      fighter [1]->o = &model_figa;
      fighter [2]->activate ();
      fighter [2]->intelligence = 300;
      fighter [2]->party = 0;
      fighter [2]->target = fighter [0];
      fighter [2]->o = &model_figa;
      fighter [3]->activate ();
      fighter [3]->intelligence = 150;
      fighter [3]->party = 0;
      fighter [3]->target = fighter [0];
      fighter [3]->o = &model_figa;
      fighter [4]->activate ();
      fighter [4]->intelligence = 280;
      fighter [4]->party = 0;
      fighter [4]->target = fighter [5];
      fighter [4]->o = &model_figa;
      fighter [5]->activate ();
      fighter [5]->intelligence = 100;
      fighter [5]->party = 1;
      fighter [5]->target = fighter [4];
      fighter [5]->o = &model_fig;
      fighter [5]->tl->x = 55;
      fighter [5]->tl->z = 110;
      fighter [6]->activate ();
      fighter [6]->intelligence = 220;
      fighter [6]->party = 0;
      fighter [6]->target = fighter [0];
      fighter [6]->o = &model_figa;
  }
  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }
  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      drawText (-3, 0, -1, "CANYON");
    }
  }
};

class MissionMultiDogfight1 : public Mission
{
  public:
  MissionMultiDogfight1 ()
  {
    int i;
    if (l != NULL) delete l;
    l = new GLLandscape (space, LANDSCAPE_ALPINE, NULL);
    day = 1;
    weather = 0;
    camera = 0;
    sungamma = 25;
    for (i = 0; i <= 1; i ++)
    {
      fighter [i]->activate ();
      fighter [i]->ai = false;
      fighter [i]->party = i;
      fighter [i]->target = fighter [0];
      fighter [i]->o = &model_fig;
      fighter [i]->tl->x = 50 + i * 30;
      fighter [i]->tl->z = 100;
    }
    if (isserver)
      fplayer = fighter [0];
    else
      fplayer = fighter [1];
    if (joystick > 0)
      fplayer->easymodel = false;
  }
  virtual int processtimer ()
  {
    bool b = false;
    int i;
    timer ++;
    if (!fplayer->active && fplayer->explode >= 35)
    {
      return 2;
    }
    for (i = 0; i <= 4; i ++)
    {
      if (fighter [i]->active)
        if (fighter [i]->party == 0)
          b = true;
    }
    if (b) return 0;
    return 1;
  }
  virtual void draw ()
  {
    if (timer >= 0 && timer <= 50)
    {
      drawText (-4, 0, -1, "DOGFIGHT");
    }
  }
};

Mission *mission = NULL;

class Cockpit
{
  public:

/*  float getGamma (DynamicObj *obj)
  {
    float dy = obj->tl->y - fplayer->tl->y;
    float dx = fplayer->distance (obj);
    if (dx == 0) dx = 1E-5;
    return atan (dy / dx) * 180.0 / mypi;
  }

  float getPhi (DynamicObj *obj)
  {
    float dx2 = obj->tl->x - fplayer->tl->x, dz2 = obj->tl->z - fplayer->tl->z; // actual distances
    float a, aw, w = fplayer->phi;
    if (dz2 > -0.0001 && dz2 < 0.0001) dz2 = 0.0001;
    a = atan (dx2 / dz2) * 180 / mypi;
    if (dz2 > 0)
    {
      if (dx2 > 0) a -= 180;
      else a += 180;
    }
    aw = a - w;
    if (aw < -180) aw += 360;
    if (aw > 180) aw -= 360;
    return aw;
  }*/

  void drawTargeter ()
  {
    if (fplayer->target)
    if (fplayer->target->active)
    {
/*      float gamma = getGamma (fplayer->target);
      float phi = getPhi (fplayer->target);
      float mx = width / 2, my = height / 2;
      float x = mx + phi / 90.0 * width;
      float y = my + gamma / 90.0 * height;
      float dx = x - mx, dy = my - y;
      int t = (int) fplayer->theta;
      if (t < 0) t += 360;
      float rx = dx * cosi [t] - dy * sine [t];
      float ry = dx * sine [t] + dy * cosi [t];
      rx += mx;
      ry = my - ry;*/
/*      DynamicObj *o = fplayer->target;
      glBegin (GL_LINE_STRIP);
      glColor4ub (255, 255, 0, 150);
      glVertex3f (o->tl->x - o->zoom, o->tl->y - o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y - o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y - o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y - o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y - o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y + o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y + o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y + o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y + o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y + o->zoom, o->tl->z - o->zoom);
      glEnd ();
      glBegin (GL_LINES);
      glVertex3f (o->tl->x + o->zoom, o->tl->y - o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y + o->zoom, o->tl->z - o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y - o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x + o->zoom, o->tl->y + o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y - o->zoom, o->tl->z + o->zoom);
      glVertex3f (o->tl->x - o->zoom, o->tl->y + o->zoom, o->tl->z + o->zoom);
      glEnd ();*/
      DynamicObj *o = fplayer->target;
      float myphi = fplayer->phi;
      if (myphi < 0) myphi += 360;
      float ex1 = cosi [(int) myphi] * o->zoom, ey1 = -sine [(int) myphi] * o->zoom;
      float ex2 = -ex1, ey2 = -ey1;
      float ez = o->zoom;
      gl->enableAlphaBlending ();
      glBegin (GL_LINE_STRIP);
      if (((AIObj *) fplayer->target)->party != fplayer->party)
        glColor4ub (255, 0, 0, 255);
      else
        glColor4ub (0, 0, 255, 255);
      glVertex3f (o->tl->x + ex1, o->tl->y + ez, o->tl->z + ey1);
      glVertex3f (o->tl->x + ex2, o->tl->y + ez, o->tl->z + ey2);
      glVertex3f (o->tl->x + ex2, o->tl->y - ez, o->tl->z + ey2);
      glVertex3f (o->tl->x + ex1, o->tl->y - ez, o->tl->z + ey1);
      glVertex3f (o->tl->x + ex1, o->tl->y + ez, o->tl->z + ey1);
      glEnd ();
      gl->disableAlphaBlending ();
    }

  }

  void drawCross ()
  {
    glDisable (GL_LIGHTING);
/*    gl->enableAlphaBlending ();
    glDisable (GL_DEPTH_TEST);
    glLineWidth (2.0);
    glDisable (GL_DEPTH_TEST);
    glBegin (GL_LINES);
    glColor4f (1.0, 1.0, 0.0, 0.5);
    float zf = -18.0, g = 2.0, g2 = 0.8;
    glVertex3f (-g, 0.0, zf);
    glVertex3f (g, 0.0, zf);
    glVertex3f (0.0, -g, zf);
    glVertex3f (0.0, g, zf);
    glVertex3f (-g2, -g, zf);
    glVertex3f (g2, -g, zf);
    glVertex3f (-g2, g, zf);
    glVertex3f (g2, g, zf);
    glVertex3f (-g, -g2, zf);
    glVertex3f (-g, g2, zf);
    glVertex3f (g, -g2, zf);
    glVertex3f (g, g2, zf);
    glEnd ();
    gl->disableAlphaBlending ();*/

  gl->enableAlphaBlending ();
  glEnable (GL_ALPHA_TEST);
  glAlphaFunc (GL_GEQUAL, 0.1);
//  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  gl->enableTextures (texcross->textureID);

  float xf = 0.1, yf = 0.1, zf = 1.0;
  glBegin (GL_QUADS);
  glColor4ub (255, 255, 0, 255);
  glTexCoord2d (0, 0);
  glVertex3f (-xf, -yf, -zf);
  glTexCoord2d (0, 1);
  glVertex3f (-xf, yf, -zf);
  glTexCoord2d (1, 1);
  glVertex3f (xf, yf, -zf);
  glTexCoord2d (1, 0);
  glVertex3f (xf, -yf, -zf);
  glEnd ();
  glDisable (GL_ALPHA_TEST);
  glDisable (GL_TEXTURE_2D);
  gl->disableAlphaBlending ();
//  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  }

  void drawHeading ()
  {
    CColor color;
    int i = 0;
    int alpha = 175;
    color.setColor (255, 255, 0);
    color.c [3] = alpha;
    glDisable (GL_LIGHTING);
    glLineWidth (2.0);
    glDisable (GL_DEPTH_TEST);
    float xf;
    float yf = 17.5;
    float zf = -2.5;
    float g = 0.5;
//    float p1 = fplayer->phi - 40.0;
//    float p2 = fplayer->phi + 40.0;
    for (i = 0; i < 360; i += 5)
    {
      float p = (float) i - fplayer->phi;
      if (p < -180) p += 360;
      if (p > 180) p -= 360;
      if (p >= -40 && p <= 40)
      {
        if (i == 0 || i == 90 || i == 180 || i == 270)
          g = 0.7;
        else if (!(i % 10))
          g = 0.4;
        else
          g = 0.2;
        xf = p / 6.0;
        gl->enableAlphaBlending ();
        glBegin (GL_LINES);
        glColor4ub (255, 255, 0, alpha);
        glVertex3f (xf * 0.1, (yf - g) * 0.1, zf);
        glVertex3f (xf * 0.1, (yf + g) * 0.1, zf);
        glEnd ();
        if (i == 0)
          drawText (xf - 0.5, yf - 2.0, zf, "N", &color);
        else if (i == 90)
          drawText (xf - 0.5, yf - 2.0, zf, "W", &color);
        else if (i == 180)
          drawText (xf - 0.5, yf - 2.0, zf, "S", &color);
        else if (i == 270)
          drawText (xf - 0.5, yf - 2.0, zf, "E", &color);
      }
    }

    if (fplayer->target != NULL)
      if (fplayer->target->active)
      {
        int aw = fplayer->getAngle (fplayer->target);
//        printf ("aw = %d\n", aw);
        if (aw < -50)
        {
          glBegin (GL_LINE_STRIP);
          if (((AIObj *) fplayer->target)->party != fplayer->party)
            glColor4ub (255, 0, 0, alpha);
          else
            glColor4ub (0, 0, 255, alpha);
          glVertex3f (0.6, 0.1 * (yf - 1), zf);
          glVertex3f (0.65, 0.1 * yf, zf);
          glVertex3f (0.6, 0.1 * (yf + 1), zf);
          glEnd ();
        }
        else if (aw > 50)
        {
          glBegin (GL_LINE_STRIP);
          if (((AIObj *) fplayer->target)->party != fplayer->party)
            glColor4ub (255, 0, 0, alpha);
          else
            glColor4ub (0, 0, 255, alpha);
          glVertex3f (-0.6, 0.1 * (yf - 1), zf);
          glVertex3f (-0.65, 0.1 * yf, zf);
          glVertex3f (-0.6, 0.1 * (yf + 1), zf);
          glEnd ();
        }
      }

    zf = -3.5;
    for (i = 0; i < 360; i += 5)
    {
      float p = (float) i - fplayer->gamma;
      if (p < -180) p += 360;
      if (p > 180) p -= 360;
      if (p >= -30 && p <= 30)
      {
        if (i == 0 || i == 90 || i == 180 || i == 270)
          g = 0.7;
        else if (!(i % 10))
          g = 0.4;
        else
          g = 0.2;
        xf = p / 6.0;
        gl->enableAlphaBlending ();
        yf = -7;
        glBegin (GL_LINES);
        glColor4ub (255, 255, 0, alpha);
        glVertex3f ((yf - g) * 0.1, xf * 0.1, zf);
        glVertex3f ((yf + g) * 0.1, xf * 0.1, zf);
        glEnd ();
        yf = -8.5;
        if (i == 120)
          drawText (yf - 2.0, xf - 0.5, zf, "-60", &color);
        else if (i == 150)
          drawText (yf - 2.0, xf - 0.5, zf, "-30", &color);
        else if (i == 180)
          drawText (yf - 2.0, xf - 0.5, zf, "0", &color);
        else if (i == 210)
          drawText (yf - 2.0, xf - 0.5, zf, "30", &color);
        else if (i == 240)
          drawText (yf - 2.0, xf - 0.5, zf, "60", &color);
      }
    }

    gl->enableAlphaBlending ();
    int t1 = (int) (fplayer->theta - 135.0);
    int t2 = t1 + 90, t3 = t1 + 180, t4 = t1 + 270;
    if (t1 != 0) t1 %= 360;
    if (t2 != 0) t2 %= 360;
    if (t3 != 0) t3 %= 360;
    if (t4 != 0) t4 %= 360;
    if (t1 < 0) t1 += 360;
    if (t2 < 0) t2 += 360;
    if (t3 < 0) t3 += 360;
    if (t4 < 0) t4 += 360;
    xf = 0.6; yf = 0.6;
    glBegin (GL_LINES);
    glColor4ub (255, 255, 0, 130);
    glVertex3f (xf * cosi [t1], yf * sine [t1], zf);
    glVertex3f (xf * cosi [t2], yf * sine [t2], zf);
    glVertex3f (xf * cosi [t3], yf * sine [t3], zf);
    glVertex3f (xf * cosi [t4], yf * sine [t4], zf);
    glEnd ();
    gl->disableAlphaBlending ();
  }

  void drawTargetedElement ()
  {
    char str [20];
    CColor color;
    CVector3 tl, n;
    CRotation r;
    color.setColor (255, 0, 0);
    color.c [3] = 255;
    tl.x = -0.35; tl.y = -0.3; tl.z = -0.5;
    gl->disableAlphaBlending ();
    glEnable (GL_DEPTH_TEST);
    if (fplayer->target != NULL)
      if (fplayer->target->active)
      {
        fplayer->target->o->draw3 (&n, &tl, fplayer->target->rot, 0.05, 0);
        if (((AIObj *) fplayer->target)->party == fplayer->party)
          color.setColor (0, 0, 255);
        drawText (-24.0, -23.0, -4.0, fplayer->target->o->name, &color);
        sprintf (str, "%d", (int) (15.0 * fplayer->distance (fplayer->target)));
        drawText (-24.0, -25.0, -4.0, str, &color);
      }
    color.setColor (255, 255, 255);
    sprintf (str, "MISSILES: %d", fplayer->missiles);
    drawText (20.0, -25.0, -4.0, str, &color);
    glDisable (GL_DEPTH_TEST);
//    drawText (0, 0, -5.0, "ABCDEFG", &color);
  }

  void drawRadar ()
  {
    int i;
    float yf = -4.5, zf = -7.0;
    gl->enableAlphaBlending ();
    glDisable (GL_DEPTH_TEST);
    glBegin (GL_QUADS);
    glColor4ub (255, 255, 0, 100);
    glVertex3f (-1.2, yf - 1.0, zf);
    glVertex3f (1.2, yf - 1.0, zf);
    glVertex3f (1.2, yf + 1.0, zf);
    glVertex3f (-1.2, yf + 1.0, zf);
    glEnd ();
    glPointSize (2.0);
    glBegin (GL_POINTS);
    glColor4ub (255, 255, 255, 255);
    glVertex3f (0.0, yf, zf);
    for (i = 0; i < maxfighter; i ++)
      if (fighter [i] != fplayer && fighter [i]->active)
      {
        int aw = fplayer->getAngle (fighter [i]);
        if (aw < 0) aw += 360;
        float d = fplayer->distance (fighter [i]) / 100.0;
        float px = - d * sine [aw];
        float py = yf + d * cosi [aw];
        if (px >= -1.2 && px <= 1.2 && py >= yf - 1.0 && py <= yf + 1.0)
        {
          if (fighter [i]->party != fplayer->party)
            glColor4ub (255, 0, 0, 255);
          else
            glColor4ub (0, 0, 255, 255);
          glVertex3f (px, py, zf);
        }
      }
    glEnd ();
    gl->disableAlphaBlending ();
  }

};




class ConfigFile
{
  public:
  char buf [32000];
  int length;
  FILE *out;
  ConfigFile () {}
  ConfigFile (char *fname)
  {
//    int z;
    bool commentmode = false;
    FILE *in;
    length = 0;
    in = fopen (fname, "rb");
    if (in != NULL)
    {
      length = fread (buf, 1, 32000, in);
      fclose (in);
    }
    else buf [0] = 0;
    for (int i = 0; i < length; i ++)
    {
      if (buf [i] == '#') commentmode = true;
      if (buf [i] == '\n') commentmode = false;
      if (commentmode) buf [i] = ' ';
      else buf [i] = tolower (buf [i]);
    }
  }
  char *skipwhite (char *str)
  {
    while (*str == ' ' || *str == '\t')
      str ++;
    return str;
  }
  char *skipnum (char *str)
  {
    while (*str >= '0' && *str <= '9')
      str ++;
    return str;
  }
  char *getString (char *dest, char *str)
  {
    char *strf, *stre;
    char cmpstr [256];
    int i;
    if (strlen (str) >= 256) { return NULL; }
    strcpy (cmpstr, str);
    if (buf [0] == 0) { return NULL; }
    for (i = 0; i < (int) strlen (cmpstr); i ++)
    {
      cmpstr [i] = tolower (cmpstr [i]);
    }
    strf = strstr (buf, cmpstr);
    if (strf == NULL) { return NULL; }
    strf += strlen (cmpstr);
    strf = skipwhite (strf);
    if (*strf == 0) { return NULL; }
    strf ++;
    if (*strf == 0) { return NULL; }
    strf = skipwhite (strf);
    if (*strf == 0) { return NULL; }
    stre = skipnum (strf);
    if (stre - strf >= 256) { return NULL; }
    if (*strf == 0) { return NULL; }
    for (i = 0; i < (int) (stre - strf); i ++)
      dest [i] = *(strf+i);
    dest [i] = 0;
    return dest;
  }
  int getValue (char *str)
  {
    char res [256];
    getString (res, str);
    if (res == NULL) return -1;
    return atoi (res);
  }
  int openOutput (char *fname)
  {
    out = fopen (fname, "wb");
    if (out == NULL) return 0;
    return 1;
  }
  int write (char *str1, int n)
  {
    char str [256];
    if (strlen (str1) + 8 > 256) return 0;
    sprintf (str, "%s = %d\n", str1, n);
    fwrite (str, 1, strlen (str), out);
    return 1;
  }
  void writeText (char *str)
  {
    fwrite (str, 1, strlen (str), out);
    fwrite ("\n", 1, 1, out);
  }
  void close ()
  {
    fclose (out);
  }
};

void save_config ()
{
  ConfigFile *cf = new ConfigFile ();
  int ret1 = cf->openOutput ("conf");
  if (ret1 == 0) return;
  cf->writeText ("# Configuration\n");
  cf->writeText ("# Some possible width x height values for fullscreen mode:");
  cf->writeText ("#  640x480, 800x600, 1024x768");
  cf->write (" width", width);
  cf->write (" height", height);
  cf->writeText ("# Possible bits per pixel values (color depth):");
  cf->writeText ("#  8 (not recommended), 16, 24, 32");
  cf->write (" bpp", bpp);
  cf->writeText ("# Try to go fullscreen = 1, game in window = 0");
  cf->write (" fullscreen", fullscreen);
  cf->writeText ("# Quality: 0=software rendered up to 5=best (default=3)");
  cf->write (" quality", quality);
  cf->writeText ("# Far clipping plane: 20..100 (default=50)");
  cf->write (" view", (int) view);
#ifdef HAVE_SDL_MIXER
  cf->writeText ("# Sound volume: 0..100 (default=100) per cent");
  cf->write (" sound", (int) volumesound);
  cf->writeText ("# Music volume: 0..100 (default=100) per cent");
  cf->write (" music", (int) volumemusic);
#endif
  cf->writeText ("\n# This file is meant to give sensible startup settings");
  cf->writeText ("# as graphic cards and drivers may differ some 100 times in speed");
  cf->writeText ("\n# To get back to default settings, just delete this file!");
  cf->close ();
}

void load_config ()
{
  char ret [256];
  char *str;
  ConfigFile *cf = new ConfigFile ("conf");
  
  str = cf->getString (ret, "width");
  if (str == NULL)
  { width = 800; }
  else
  { width = atoi (str); }
  if (width < 100) width = 100;
  else if (width > 3000) width = 3000;

  cf->getString (ret, "height");
  if (str == NULL)
  { height = 600; }
  else
  { height = atoi (str); }
  if (height < 100) height = 100;
  else if (height > 2000) height = 2000;

  cf->getString (str, "bpp");
  if (str == NULL)
  { bpp = 32; }
  else
  { bpp = atoi (str); }
  if (bpp != 8 && bpp != 16 && bpp != 24 && bpp != 32)
    bpp = 32;

  cf->getString (str, "fullscreen");
  if (str == NULL)
  { fullscreen = 1; }
  else
  { fullscreen = atoi (str); }
  if (fullscreen) fullscreen = 1;

  cf->getString (str, "quality");
  if (str == NULL)
  { quality = 3; }
  else
  { quality = atoi (str); }
  if (quality < 0) quality = 0;
  else if (quality > 5) quality = 5;

  cf->getString (str, "view");
  if (str == NULL)
  { view = 50; }
  else
  { view = atoi (str); }
  if (view < 20) view = 20;
  else if (view > 100) view = 100;

#ifdef HAVE_SDL_MIXER
  cf->getString (str, "sound");
  if (str == NULL)
  { volumesound = 100; }
  else
  { volumesound = atoi (str); }
  if (volumesound < 0) volumesound = 0;
  else if (volumesound > 100) volumesound = 100;

  cf->getString (str, "music");
  if (str == NULL)
  { volumemusic = 100; }
  else
  { volumemusic = atoi (str); }
  if (volumemusic < 0) volumemusic = 0;
  else if (volumemusic > 100) volumemusic = 100;
#endif

}




#ifndef USE_GLUT
SDL_Joystick *sdljoystick;
#endif
int sdldisplay = true;
int sdlreshape = true;
Cockpit *cockpit;

/*void drawTexture (float r, float p1, float t1, float p2, float t2)
{
  gl->enableTextures ();
  gl->enableAlphaBlending ();
  glDisable (GL_DITHER);
  glBegin (GL_QUADS);
  float f = atan(1.0)*4.0 / 180.0;
  float sinp1 = sin (p1*f), sinp2 = sin (p2*f), sint1 = sin (t1*f), sint2 = sin (t2*f);
  float cosp1 = cos (p1*f), cosp2 = cos (p2*f), cost1 = cos (t1*f), cost2 = cos (t2*f);
  float x = r * cosp1 * sint2, y = r * sinp1 * sint2, z = r * cost2;
  printf ("(%f,%f,%f)\n", x,y,z); fflush (stdout);
  glColor4f (1.0, 1.0, 1.0, 1.0);
  glTexCoord2d (0, 1);
  glVertex3f (x, y, z);
  x = r * cosp2 * sint2, y = r * sinp2 * sint2, z = r * cost2;
  glTexCoord2d (1, 1);
  glVertex3f (x, y, z);
  x = r * cosp2 * sint1, y = r * sinp2 * sint1, z = r * cost1;
  glTexCoord2d (1, 0);
  glVertex3f (x, y, z);
  x = r * cosp1 * sint1, y = r * sinp1 * sint1, z = r * cost1;
  glTexCoord2d (0, 0);
  glVertex3f (x, y, z);
  glEnd ();
  glDisable (GL_TEXTURE_2D);
}*/

bool initing = true;
int flash = 0;

void setPlaneVolume ()
{
  if (game == GAME_PLAY)
  {
    int lev = (int) ((float) 128 * fplayer->speed / fplayer->maxspeed) - 32;
    sound->setVolume (SOUND_PLANE1, lev);
  }
  else
    sound->setVolume (SOUND_PLANE1, 0);
}

void game_levelInit (int missionid)
{
  int i;

  if (missionid >= 1000)
    multiplayer = true;
  else
  {
    multiplayer = false;
    isserver = false;
  }

  initing = true;
  flash = 0;

  for (i = 0; i < maxfighter; i ++)
  {
    fighter [i]->dinit ();
    fighter [i]->aiinit ();
    fighter [i]->fighterinit ();
    fighter [i]->explode = 0;
    fighter [i]->tl->x = 0;
    fighter [i]->tl->z = -i * 10;
    fighter [i]->party = 0;
    fighter [i]->zoom = 0.35;
    fighter [i]->deactivate ();
    fighter [i]->recheight = 15;
    fighter [i]->recspeed = 0.2;
    fighter [i]->rectheta = 0;
    fighter [i]->o = &model_fig;
  }

  for (i = 0; i < maxgroundobj; i ++)
  {
    groundobj [i]->dinit ();
    groundobj [i]->zoom = 1;
    groundobj [i]->id = STATIC;
    groundobj [i]->deactivate ();
  }

//  if (l != NULL) delete l;
  if (!multiplayer || isserver || !isserver) // clients do not need the mission
  {
    if (mission != NULL) delete mission;
    if (missionid == 0) mission = new MissionDemo1 ();
    else if (missionid == 1) mission = new MissionTutorial1 ();
    else if (missionid == 10) mission = new MissionDogfight1 ();
    else if (missionid == 20) mission = new MissionGround1 ();
    else if (missionid == 30) mission = new MissionShip1 ();
    else if (missionid == 40) mission = new MissionMoon1 ();
    else if (missionid == 50) mission = new MissionCanyon1 ();
    else if (missionid == 1000) mission = new MissionMultiDogfight1 ();
  }
  else
  {
// Receive map data


  }

  for (i = 0; i < maxfighter; i ++)
  {
    if (fighter [i]->id >= FLAK1 && fighter [i]->id <= FLAK2)
    {
      fighter [i]->tl->y = l->getExactHeight (fighter [i]->tl->x, fighter [i]->tl->z) + fighter [i]->zoom;
    }
    else if (fighter [i]->id >= SHIP1 && fighter [i]->id <= SHIP2)
    {
      fighter [i]->tl->y = l->getExactHeight (fighter [i]->tl->x, fighter [i]->tl->z) + fighter [i]->zoom / 4;
    }
    else
    {
      fighter [i]->tl->y = l->getHeight (fighter [i]->tl->x, fighter [i]->tl->z) + 15;
    }
  }

  for (i = 0; i < maxlaser; i ++)
  {
    laser [i]->deactivate ();
    if (day)
    {
      laser [i]->o = &model_cannon1;
      laser [i]->zoom = 0.07;
    }
    else
    {
      laser [i]->o = &model_cannon2;
      laser [i]->zoom = 0.1;
    }
  }

  for (i = 0; i < maxmissile; i ++)
  {
    missile [i]->aiinit ();
    missile [i]->deactivate ();
  }

  for (i = 0; i < maxstar; i ++)
  {
    star [i]->phi = myrandom (360);
    star [i]->gamma = myrandom (85);
    star [i]->size = 0.6 + 0.15 * myrandom (8);
  }

  if (day && weather == 0)
  {
    if (sungamma < 35)
      objsphere->setColor (new CColor ((unsigned short) (127 + 70 - 2 * sungamma), 127, 127));
    else
      objsphere->setColor (new CColor (127, 127, 127));
    if (sungamma < 35)
      gl->fogcolor [0] = (float) (127 + 70 - 2 * sungamma) / 256.0;
    else
      gl->fogcolor [0] = 0.5;
    gl->fogcolor [1] = 0.5;
    gl->fogcolor [2] = 0.5;
    objsphere->setNorthPoleColor (new CColor (50, 200, 255), 1.8);
    objsphere->setPoleColor (90, (int) (90 - sungamma), new CColor (200, 200, 200), 0.3);
  }
  else if (!day && weather == 0)
  {
    objsphere->setColor (new CColor (64, 64, 64));
    gl->fogcolor [0] = 0.25;
    gl->fogcolor [1] = 0.25;
    gl->fogcolor [2] = 0.25;
    objsphere->setNorthPoleColor (new CColor (0, 0, 170), 1.8);
    objsphere->setPoleColor (90, (int) (90 - sungamma), new CColor (64, 64, 64), 0.3);
  }
  else if (day && weather == 1)
  {
    objsphere->setColor (new CColor (102, 102, 102));
    gl->fogcolor [0] = 0.4;
    gl->fogcolor [1] = 0.4;
    gl->fogcolor [2] = 0.4;
    objsphere->setNorthPoleColor (new CColor (102, 102, 102), 1.8);
  }
  else if (!day && weather == 1)
  {
    objsphere->setColor (new CColor (40, 40, 40));
    gl->fogcolor [0] = 0.16;
    gl->fogcolor [1] = 0.16;
    gl->fogcolor [2] = 0.16;
    objsphere->setNorthPoleColor (new CColor (40, 40, 40), 1.8);
  }
  else if (weather == 2)
  {
    objsphere->setColor (new CColor (20, 20, 20));
    gl->fogcolor [0] = 0.08;
    gl->fogcolor [1] = 0.08;
    gl->fogcolor [2] = 0.08;
  }
  glDeleteLists (objsphere->list1, 1);
  glDeleteLists (objsphere->list2, 1);
  glDeleteLists (objsphere->list3, 1);
  objsphere->list1 = -1;
  objsphere->list2 = -1;
  objsphere->list3 = -1;

  light_position0 [0] = -cosi [(int) sungamma];
  light_position0 [1] = sine [(int) sungamma];
  light_position0 [2] = 0;

//  glLightfv( GL_LIGHT0, GL_AMBIENT, light_ambient );
/*  float light_specular [3] = {0.5, 0.5, 0.5};
  glLightfv( GL_LIGHT0, GL_SPECULAR, light_specular );*/
  glLightfv( GL_LIGHT0, GL_POSITION, light_position0 );
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);
	glEnable(GL_LIGHT0);								// Turn on a light with defaults set
	glEnable(GL_LIGHTING);								// Turn on lighting
	glEnable(GL_COLOR_MATERIAL);						// Allow color

  glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
  glDisable (GL_DITHER);

//  mission = new MissionDemo1 (space);
  initing = false;

#ifdef HAVE_SDL_NET
  if (multiplayer)
  {
    if (threadnet != NULL)
      SDL_KillThread (threadnet);
    threadnet = SDL_CreateThread (net_thread_main, NULL);
  }
#endif

}

void game_reshape ()
{
  /* Darstellung auf gesamten Clientbereich des Fensters zulassen */
  glViewport(0, 0, (GLint) width, (GLint) height);

  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  /* angle, aspect, near Clip, far Clip */
  float v = getView ();
  if (camera == 50) v = 100000.0;
  gluPerspective (80.0, (float) width / height, 0.20, v); // should be sqrt(2) or 1.5
  glPolygonMode (GL_FRONT_AND_BACK, polygonMode);

#ifndef USE_GLUT
  if (!joystick)
    SDL_ShowCursor (1);
  else
    SDL_ShowCursor (0);
#endif
}

void menu_reshape ()
{
  /* Darstellung auf gesamten Clientbereich des Fensters zulassen */
  glViewport(0, 0, (GLint) width, (GLint) height);

  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  /* angle, aspect, near Clip, far Clip */
  float v = getView ();
  if (camera == 50) v = 100000.0;
  gluPerspective (80.0, 1.0, 0.20, v); // should be sqrt(2) or 1.5
  glPolygonMode (GL_FRONT_AND_BACK, polygonMode);

#ifndef USE_GLUT
  SDL_ShowCursor (0);
#endif
}

void credits_reshape ()
{
  /* Darstellung auf gesamten Clientbereich des Fensters zulassen */
  glViewport(0, 0, (GLint) width, (GLint) height);

  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  /* angle, aspect, near Clip, far Clip */
  float v = getView ();
  if (camera == 50) v = 100000.0;
  gluPerspective (80.0, 1.0, 0.20, v); // should be sqrt(2) or 1.5
  glPolygonMode (GL_FRONT_AND_BACK, polygonMode);

#ifndef USE_GLUT
  SDL_ShowCursor (0);
#endif
}

void game_quit ()
{
  int i;
  volumesound = sound->volumesound;
  volumemusic = sound->volumemusic;
  save_config ();
  for (i = 0; i < maxfighter; i ++)
    delete (fighter [i]);
// free allocated memory (optional)
#ifndef USE_GLUT
/*	SDL_CloseAudio();
	SDL_FreeWAV(wave.sound);*/
  SDL_Quit ();
#endif
  exit (0);
}

void switch_menu ()
{
  game = GAME_MENU;
  menu_reshape ();
  if (!sound->musicplaying)
    sound->playMusic (MUSIC_DARK1);
  sound->stop (SOUND_PLANE1);
}

void switch_create ()
{
  game = GAME_CREATE;
  isserver = true;
  if (server != NULL) delete server;
  server = new Server ();
  menu_reshape ();
  if (!sound->musicplaying)
    sound->playMusic (MUSIC_DARK1);
  sound->stop (SOUND_PLANE1);
}

void switch_join ()
{
  game = GAME_JOIN;
  isserver = false;
  if (client != NULL) delete client;
  client = new Client ();
  menu_reshape ();
  if (!sound->musicplaying)
    sound->playMusic (MUSIC_DARK1);
  sound->stop (SOUND_PLANE1);
}

int creditstimer;

void switch_credits ()
{
  game = GAME_CREDITS;
  creditstimer = 50;
  credits_reshape ();
  if (sound->musicplaying)
    sound->haltMusic ();
  sound->playMusic (MUSIC_WINNER1);
  sound->stop (SOUND_PLANE1);
}

void switch_game ()
{
  game = GAME_PLAY;
  game_reshape ();
  if (sound->musicplaying)
    sound->haltMusic ();
  sound->playLoop (SOUND_PLANE1);
  setPlaneVolume ();
}

void game_key (unsigned char key, int x, int y)
{
  if (camera == 50 && game == GAME_PAUSE)
  {
    camera = 0;
    game = GAME_PLAY;
    return;
  }
  if (key == 27)
  {
    switch_menu ();
  }
  else
  {
    if (key == 'c' || key == ' ')
    {
      fplayer->fireCannon (laser);
      sound->play (SOUND_CANNON1);
    }
    else if (key == 'm')
    {
      if (fplayer->missiles > 0)
        fplayer->fireMissile (missile);
      sound->play (SOUND_MISSILE1);
//      printf ("%d missiles left\n", fplayer->missiles);
    }
/*    else if (key == 'l')
    {
      if (lighting == 0) lighting = 1;
      else lighting = 0;
    }
    else if (key == 'm')
    {
      if (mode == 0) mode = 1;
      else mode = 0;
    }*/
    else if (key == '1')
    {
      view = 30.0;
      game_reshape ();
      sound->play (SOUND_CLICK1);
    }
    else if (key == '2')
    {
      view = 40.0;
      game_reshape ();
      sound->play (SOUND_CLICK1);
    }
    else if (key == '3')
    {
      view = 50.0;
      game_reshape ();
      sound->play (SOUND_CLICK1);
    }
    else if (key == '4')
    {
      view = 60.0;
      game_reshape ();
      sound->play (SOUND_CLICK1);
    }
    else if (key == '5')
    {
      view = 70.0;
      game_reshape ();
      sound->play (SOUND_CLICK1);
    }
    else if (key == '6')
    {
      view = 80.0;
      game_reshape ();
      sound->play (SOUND_CLICK1);
    }
    else if (key == '7')
    {
      view = 90.0;
      game_reshape ();
      sound->play (SOUND_CLICK1);
    }
    else if (key == '8')
    {
      view = 100.0;
      game_reshape ();
      sound->play (SOUND_CLICK1);
    }
    else if (key == '9')
    {
      view = 110.0;
      game_reshape ();
      sound->play (SOUND_CLICK1);
    }
    else if (key == 'q')
    {
      quality ++;
      if (quality > 5) quality = 0;
      if (quality <= 1) space->drawlight = false;
      else space->drawlight = true;
      sound->play (SOUND_CLICK1);
//      printf ("\nQuality = %d", quality); fflush (stdout);
    }
    else if (key == 'a')
    {
      fplayer->ai = !fplayer->ai;
      fplayer->easymodel = fplayer->ai;
      if (joystick == 0)
        fplayer->easymodel = true;
    }
    else if (key == 'p')
    {
      printf ("pos: x=%f, z=%f\n", fplayer->tl->x, fplayer->tl->z);
      printf ("mouse: x=%d, y=%d\n", mousex, mousey);
      printf ("gamma: f=%d, cam=%d\n", (int) fplayer->gamma, (int) camgamma);
	    fflush (stdout);
      if (game == GAME_PLAY) game = GAME_PAUSE;
      else game = GAME_PLAY;
    }
    else if (key == 'w')
    {
      fplayer->speedUp ();
      sound->play (SOUND_CLICK1);
      setPlaneVolume ();
    }
    else if (key == 's')
    {
      fplayer->speedDown ();
      sound->play (SOUND_CLICK1);
      setPlaneVolume ();
    }
/*    else if (key == 'n')
    {
      game_levelInit (0);
    }*/
/*    else if (key == '-')
    {
      width -= 50; height -= 50;
      if (width < 50) width = 50;
      if (height < 50) height = 50;
#ifdef USE_GLUT
      glutReshapeWindow (width, height);
#else
      sdlreshape = true;
#endif
    }
    else if (key == '+')
    {
      width += 50; height += 50;
      if (width > 1000) width = 1000;
      if (height > 1000) height = 1000;
#ifdef USE_GLUT
      glutReshapeWindow (width, height);
#else
      sdlreshape = true;
#endif
    }*/
    else if (key == 'e')
    {
      fplayer->targetNearestEnemy ((AIObj **) fighter);
//      explosion [0]->setExplosion (fplayer->tl->x, fplayer->tl->y, fplayer->tl->z, 1.0);
//      fplayer->explode ++;
      sound->play (SOUND_CLICK1);
    }
    else if (key == 't')
    {
      fplayer->targetNext ((AIObj **) fighter);
      sound->play (SOUND_CLICK1);
    }
/*    else if (key == 'g')
    {
      if (polygonMode==GL_FILL)
        polygonMode=GL_LINE;
      else
        polygonMode=GL_FILL;
      glPolygonMode (GL_FRONT_AND_BACK, polygonMode);
    }*/
#ifdef USE_GLUT
    glutPostRedisplay();
#else
    sdldisplay = true;
#endif
  }
}

int aktcam = 0;

#ifdef USE_GLUT
  #define MOUSE_BUTTON_LEFT GLUT_LEFT_BUTTON
  #define MOUSE_BUTTON_MIDDLE GLUT_MIDDLE_BUTTON
  #define MOUSE_BUTTON_RIGHT GLUT_RIGHT_BUTTON
  #define MOUSE_UP GLUT_UP
  #define MOUSE_DOWN GLUT_DOWN
  #define KEY_F1 GLUT_KEY_F1
  #define KEY_F2 GLUT_KEY_F2
  #define KEY_F3 GLUT_KEY_F3
  #define KEY_F4 GLUT_KEY_F4
  #define KEY_F5 GLUT_KEY_F5
  #define KEY_F6 GLUT_KEY_F6
  #define KEY_F7 GLUT_KEY_F7
  #define KEY_F8 GLUT_KEY_F8
  #define KEY_F9 GLUT_KEY_F9
  #define KEY_UP GLUT_KEY_UP
  #define KEY_DOWN GLUT_KEY_DOWN
  #define KEY_LEFT GLUT_KEY_LEFT
  #define KEY_RIGHT GLUT_KEY_RIGHT
#else
  #define MOUSE_BUTTON_LEFT SDL_BUTTON_LEFT
  #define MOUSE_BUTTON_MIDDLE SDL_BUTTON_MIDDLE
  #define MOUSE_BUTTON_RIGHT SDL_BUTTON_RIGHT
  #define MOUSE_UP SDL_RELEASED
  #define MOUSE_DOWN SDL_PRESSED
  #define KEY_F1 SDLK_F1
  #define KEY_F2 SDLK_F2
  #define KEY_F3 SDLK_F3
  #define KEY_F4 SDLK_F4
  #define KEY_F5 SDLK_F5
  #define KEY_F6 SDLK_F6
  #define KEY_F7 SDLK_F7
  #define KEY_F8 SDLK_F8
  #define KEY_F9 SDLK_F9
  #define KEY_UP SDLK_UP
  #define KEY_DOWN SDLK_DOWN
  #define KEY_LEFT SDLK_LEFT
  #define KEY_RIGHT SDLK_RIGHT
#endif

void game_keyspecial (int key, int x, int y)
{
  if (camera == 50 && game == GAME_PAUSE)
  {
    camera = 0;
    game = GAME_PLAY;
  }
  switch (key) {
  case KEY_UP:
    fplayer->speedUp ();
    sound->play (SOUND_CLICK1);
    break;
  case KEY_DOWN:
    fplayer->speedDown ();
    sound->play (SOUND_CLICK1);
    break;
  case KEY_LEFT:
    fplayer->toLeft ();
    break;
  case KEY_RIGHT:
    fplayer->toRight ();
    break;
  case KEY_F1:
    camera = 0;
    game_reshape ();
    break;
  case KEY_F2:
    camera = 1;
    game_reshape ();
    break;
  case KEY_F3:
    camera = 2;
    game_reshape ();
    break;
  case KEY_F4:
    camera = 6;
//    aktcam ++;
//    if (aktcam > 7) aktcam = 0;
    game_reshape ();
    break;
  case KEY_F5:
    camera = 7;
    game_reshape ();
    break;
  case KEY_F6:
    camera = 4;
    game_reshape ();
    break;
  case KEY_F7:
    camera = 5;
    game_reshape ();
    break;
  case KEY_F8:
    camera = 50;
    game_reshape ();
    break;
  case KEY_F9:
    aktcam ++;
    if (aktcam > 7) aktcam = 0;
    camera = 3;
    break;
  default:
    return;
  }
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}

void game_mouse (int button, int state, int x, int y)
{
  if (state == MOUSE_DOWN)
  {
    if (button == MOUSE_BUTTON_LEFT)
    {
      fplayer->fireCannon (laser);
      sound->play (SOUND_CANNON1);
    }
    else if (button == MOUSE_BUTTON_RIGHT)
    {
      if (fplayer->missiles > 0)
        sound->play (SOUND_MISSILE1);
      fplayer->fireMissile (missile);
    }
  }
}

float dtheta = 0, dgamma = 0;

void game_mousemotion (int x, int y)
{
  if (joystick) return;
  float f = (float) width / 240.0;
  float mx = width / 2, my = height / 2;
  float dx = x - mx, dy = my - y;
  int t = (int) fplayer->theta;
  if (t < 0) t += 360;
  float rx = dx * cosi [t] - dy * sine [t];
  float ry = dx * sine [t] + dy * cosi [t];
  rx += mx;
  ry = my - ry;
  fplayer->rectheta = (float) (width / 2 - rx) / f;
  fplayer->recgamma = 135.0 + (float) (height - ry) / height * 90.0;

#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}

void game_joystickaxis (int x, int y, int throttle, int rudder)
{
  if (fplayer->ai) return;
/*  int t = (int) fplayer->theta;
  if (t < 0) t += 360;
  float rx = x * cosi [t] - y * sine [t];
  float ry = x * sine [t] + y * cosi [t];*/
  fplayer->rectheta -= (float) x / 5000;
/*  fplayer->recgamma += (float) ry / 5000;
  if (fplayer->recgamma > 225) fplayer->recgamma = 225;
  if (fplayer->recgamma < 135) fplayer->recgamma = 135;*/
  fplayer->rolleffect = (float) y / 30000;
  if (fplayer->rolleffect > 1.0) fplayer->rolleffect = 1.0;
  else if (fplayer->rolleffect < -1.0) fplayer->rolleffect = -1.0;
  if (fplayer->rolleffect < 0) fplayer->rolleffect /= 2;
  fplayer->ruddereffect = (float) rudder / 30000;
  if (fplayer->ruddereffect > 1.0) fplayer->ruddereffect = 1.0;
  else if (fplayer->ruddereffect < -1.0) fplayer->ruddereffect = -1.0;
//  fplayer->rolleffect = 0;
  fplayer->recspeed = fplayer->maxspeed * 0.75 - fplayer->maxspeed / 4 * throttle / 32638;
}

void game_joystickbutton (int button)
{
  if (button == 0)
  {
    fplayer->fireCannon (laser);
    sound->play (SOUND_CANNON1);
  }
  else if (button == 1)
  {
    fplayer->targetNearestEnemy ((AIObj **) fighter);
    sound->play (SOUND_CLICK1);
  }
  else if (button == 2)
  {
    if (fplayer->missiles > 0)
      fplayer->fireMissile (missile);
    sound->play (SOUND_MISSILE1);
  }
  else if (button == 3)
  {
    if (fplayer->missiles > 0)
      fplayer->fireMissile (missile);
    sound->play (SOUND_MISSILE1);
  }
}

void game_joystickhat (int hat)
{
#ifndef USE_GLUT
  if (hat == SDL_HAT_LEFT)
  {
    fplayer->targetPrevious ((AIObj **) fighter);
    sound->play (SOUND_CLICK1);
  }
  else if (hat == SDL_HAT_RIGHT)
  {
    fplayer->targetNext ((AIObj **) fighter);
    sound->play (SOUND_CLICK1);
  }
#endif
}

static void myDisplayFunc2 ()
{
//  RenderScene ();
//  glutSwapBuffers();
}

float fps;
int frames = 0, time2 = 0, time1 = 0;

void frame ()
{
  frames ++;
#ifndef USE_GLUT
  time2 = SDL_GetTicks ();
#else
  time2 = glutGet (GLUT_ELAPSED_TIME);
#endif
  if (time2 - time1 > 1000)
  {
    fps = (float) frames * 1000.0 / (time2 - time1);
    time1 = time2;
    frames = 0;
//    printf ("\nFrames=%f ", fps); fflush (stdout);
  }
}

void game_view ()
{
  frame ();
#ifdef USE_GLUT
  glutSwapBuffers();
#else
  SDL_GL_SwapBuffers ();
#endif
}

int missionending = 0;
int missionstate = 0;

bool missionactive = false;
int menuitem = 0, menutimer = 0, menuitemselected = -1;

void menu_key (unsigned char key, int x, int y)
{
  if (key == 27)
  {
    if (missionactive)
    {
      switch_game ();
    }
  }
}

void credits_key (unsigned char key, int x, int y)
{
  if (key)
  {
    sound->haltMusic ();
    switch_menu ();
  }
}

void menu_mouse (int button, int state, int x, int y)
{
  float rx = (float) x / width;
  float ry = (float) y / height;
  int lastitemselected = menuitemselected;
  int lastitem = menuitem;
  menuitemselected = -1;

  if (rx >= 0.1 && rx <= 0.35)
  {
    if (ry >= 0.15 && ry <= 0.2)
    {
      menuitemselected = 0;
      if (state == MOUSE_DOWN)
        menuitem = 0;
    }
    else if (ry >= 0.22 && ry <= 0.27)
    {
      menuitemselected = 1;
      if (state == MOUSE_DOWN)
        menuitem = 1;
    }
#ifdef HAVE_SDL_NET
    else if (ry >= 0.28 && ry <= 0.33)
    {
      menuitemselected = 2;
      if (state == MOUSE_DOWN)
        menuitem = 2;
    }
#endif
    else if (ry >= 0.34 && ry <= 0.39)
    {
      menuitemselected = 3;
      if (state == MOUSE_DOWN)
        menuitem = 3;
    }
    else if (ry >= 0.40 && ry <= 0.45)
    {
      menuitemselected = 4;
      if (state == MOUSE_DOWN)
      {
        menuitem = 4;
        switch_credits ();
      }
    }
    else if (ry >= 0.46 && ry <= 0.51)
    {
      menuitemselected = 5;
      if (state == MOUSE_DOWN)
      {
        menuitem = 5;
        game_quit ();
      }
    }
    else if (ry >= 0.64 && ry <= 0.69)
    {
      menuitemselected = 9;
      if (state == MOUSE_DOWN)
      {
        // no new menuitem!
        switch_game ();
      }
    }
  }

  if (menuitem == 0)
  {
    if (rx >= 0.5 && rx <= 0.75)
    {
      if (ry >= 0.15 && ry <= 0.2)
      {
        menuitemselected = 10;
        if (state == MOUSE_DOWN)
        {
          game_levelInit (1);
          switch_game ();
          missionactive = true;
        }
      }
      if (ry >= 0.22 && ry <= 0.27)
      {
        menuitemselected = 11;
        if (state == MOUSE_DOWN)
        {
          game_levelInit (10);
          switch_game ();
          missionactive = true;
        }
      }
      if (ry >= 0.28 && ry <= 0.33)
      {
        menuitemselected = 12;
        if (state == MOUSE_DOWN)
        {
          game_levelInit (20);
          switch_game ();
          missionactive = true;
        }
      }
      if (ry >= 0.34 && ry <= 0.39)
      {
        menuitemselected = 13;
        if (state == MOUSE_DOWN)
        {
          game_levelInit (30);
          switch_game ();
          missionactive = true;
        }
      }
      if (ry >= 0.40 && ry <= 0.45)
      {
        menuitemselected = 14;
        if (state == MOUSE_DOWN)
        {
          game_levelInit (40);
          switch_game ();
          missionactive = true;
        }
      }
      if (ry >= 0.46 && ry <= 0.51)
      {
        menuitemselected = 15;
        if (state == MOUSE_DOWN)
        {
          game_levelInit (50);
          switch_game ();
          missionactive = true;
        }
      }
    }
  }

  if (menuitem == 1)
  {
    if (rx >= 0.5 && rx <= 0.8)
    {
      if (ry >= 0.15 && ry <= 0.2)
      {
        menuitemselected = 10;
        if (state == MOUSE_DOWN)
        {
          if (button == MOUSE_BUTTON_LEFT)
          {
            quality ++;
            if (quality > 5) quality = 0;
          }
          else
          {
            quality --;
            if (quality < 0) quality = 5;
          }
        }
      }
      else if (ry >= 0.22 && ry <= 0.27)
      {
        menuitemselected = 11;
        if (state == MOUSE_DOWN)
        {
          if (button == MOUSE_BUTTON_LEFT)
          {
            view += 10;
            if (view > 110) view = 30;
            menu_reshape ();
          }
          else
          {
            view -= 10;
            if (view < 30) view = 110;
            menu_reshape ();
          }
        }
      }
#ifdef HAVE_SDL_MIXER
      else if (ry >= 0.28 && ry <= 0.33)
      {
        menuitemselected = 12;
        if (state == MOUSE_DOWN)
        {
          if (button == MOUSE_BUTTON_LEFT)
          {
            sound->volumesound += 10;
            if (sound->volumesound > 100)
              sound->volumesound = 0;
            sound->setVolume ();
            setPlaneVolume ();
            sound->play (SOUND_CLICK1);
            menu_reshape ();
          }
          else
          {
            sound->volumesound -= 10;
            if (sound->volumesound < 0)
              sound->volumesound = 100;
            sound->setVolume ();
            setPlaneVolume ();
            sound->play (SOUND_CLICK1);
            menu_reshape ();
          }
        }
      }
      else if (ry >= 0.34 && ry <= 0.39)
      {
        menuitemselected = 13;
        if (state == MOUSE_DOWN)
        {
          if (button == MOUSE_BUTTON_LEFT)
          {
            sound->volumemusic += 10;
            if (sound->volumemusic > 100)
              sound->volumemusic = 0;
            sound->setVolumeMusic ();
            menu_reshape ();
          }
          else
          {
            sound->volumemusic -= 10;
            if (sound->volumemusic < 0)
              sound->volumemusic = 100;
            sound->setVolumeMusic ();
            menu_reshape ();
          }
        }
      }
#endif
    }
  }

#ifdef HAVE_SDL_NET
  if (menuitem == 2)
  {
    if (rx >= 0.5 && rx <= 0.75)
    {
      if (ry >= 0.15 && ry <= 0.2)
      {
        menuitemselected = 10;
        if (state == MOUSE_DOWN)
        {
          switch_create ();
        }
      }
      else if (ry >= 0.22 && ry <= 0.27)
      {
        menuitemselected = 11;
        if (state == MOUSE_DOWN)
        {
          switch_join ();
        }
      }
    }
  }
#endif

  if (lastitemselected != menuitemselected)
  {
    menutimer = 0;
  }

  if (lastitem != menuitem)
  {
    sound->play (SOUND_CLICK1);
  }

#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}

void menu_display ()
{
  char buf [100];

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity ();
  glPushMatrix ();

/*  if (quality >= 2)
    gl->enableAntiAliasing ();*/

  CColor color2 ((int) (255.0 * cosi [menutimer * 5 % 360]), 255, (int) (255.0 * cosi [menutimer * 10 % 360]), 255);

  int textx = -14, textx2 = 0;

  if (menuitemselected == 0)
    drawTextRotated (textx, 10, -2, "MISSION", &color2, -menutimer * 5);
  else
    drawText (textx, 10, -2, "MISSION");
  if (menuitemselected == 1)
    drawTextRotated (textx, 8, -2, "OPTIONS", &color2, -menutimer * 5);
  else
    drawText (textx, 8, -2, "OPTIONS");
#ifdef HAVE_SDL_NET
  if (menuitemselected == 2)
    drawTextRotated (textx, 6, -2, "MULTIPLAYER", &color2, -menutimer * 5);
  else
    drawText (textx, 6, -2, "MULTIPLAYER");
#endif
  if (menuitemselected == 3)
    drawTextRotated (textx, 4, -2, "HELP", &color2, -menutimer * 5);
  else
    drawText (textx, 4, -2, "HELP");
  if (menuitemselected == 4)
    drawTextRotated (textx, 2, -2, "CREDITS", &color2, -menutimer * 5);
  else
    drawText (textx, 2, -2, "CREDITS");
  if (menuitemselected == 5)
    drawTextRotated (textx, 0, -2, "QUIT", &color2, -menutimer * 5);
  else
    drawText (textx, 0, -2, "QUIT");
  if (missionactive)
  {
    if (menuitemselected == 9)
      drawTextRotated (textx, -6, -2, "RETURN", &color2, -menutimer * 5);
    else
      drawText (textx, -6, -2, "RETURN");
  }

  if (menuitem == 0)
  {
    if (menuitemselected == 10)
      drawTextRotated (textx2, 10, -2, "TUTORIAL", &color2, -menutimer * 5);
    else
      drawText (textx2, 10, -2, "TUTORIAL");
    if (menuitemselected == 11)
      drawTextRotated (textx2, 8, -2, "DOGFIGHT", &color2, -menutimer * 5);
    else
      drawText (textx2, 8, -2, "DOGFIGHT");
    if (menuitemselected == 12)
      drawTextRotated (textx2, 6, -2, "SA DEFENSE", &color2, -menutimer * 5);
    else
      drawText (textx2, 6, -2, "SA DEFENSE");
    if (menuitemselected == 13)
      drawTextRotated (textx2, 4, -2, "CRUISER", &color2, -menutimer * 5);
    else
      drawText (textx2, 4, -2, "CRUISER");
    if (menuitemselected == 14)
      drawTextRotated (textx2, 2, -2, "MOON", &color2, -menutimer * 5);
    else
      drawText (textx2, 2, -2, "MOON");
    if (menuitemselected == 15)
      drawTextRotated (textx2, 0, -2, "CANYON", &color2, -menutimer * 5);
    else
      drawText (textx2, 0, -2, "CANYON");
    drawText (-20, -15, -3, "MORE MISSIONS WITH THE NEXT RELEASE");
  }
  else if (menuitem == 1)
  {
    sprintf (buf, "QUALITY: %d", quality);
    if (menuitemselected == 10)
      drawTextRotated (textx2, 10, -2, buf, &color2, -menutimer * 5);
    else
      drawText (textx2, 10, -2, buf);
    sprintf (buf, "VIEW: %d", (int) view);
    if (menuitemselected == 11)
      drawTextRotated (textx2, 8, -2, buf, &color2, -menutimer * 5);
    else
      drawText (textx2, 8, -2, buf);
#ifdef HAVE_SDL_MIXER
    sprintf (buf, "SOUND: %d", (int) sound->volumesound);
    if (menuitemselected == 12)
      drawTextRotated (textx2, 6, -2, buf, &color2, -menutimer * 5);
    else
      drawText (textx2, 6, -2, buf);
    sprintf (buf, "MUSIC: %d", (int) sound->volumemusic);
    if (menuitemselected == 13)
      drawTextRotated (textx2, 4, -2, buf, &color2, -menutimer * 5);
    else
      drawText (textx2, 4, -2, buf);
#endif
  }
  else if (menuitem == 2)
  {
#ifdef HAVE_SDL_NET
    if (menuitemselected == 10)
      drawTextRotated (textx2, 10, -2, "CREATE GAME", &color2, -menutimer * 5);
    else
      drawText (textx2, 10, -2, "CREATE GAME");
    if (menuitemselected == 11)
      drawTextRotated (textx2, 8, -2, "JOIN GAME", &color2, -menutimer * 5);
    else
      drawText (textx2, 8, -2, "JOIN GAME");
#endif
  }
  else if (menuitem == 3)
  {
    drawText (0, 15, -3, "SHORTCUTS:");
    drawText (0, 14, -3, "T   NEXT TARGET");
    drawText (0, 13, -3, "E   TARGET NEAREST ENEMY");
    drawText (0, 12, -3, "C   FIRE CANNON");
    drawText (0, 11, -3, "M   FIRE MISSILE");
    drawText (0, 10, -3, "UP  ACCELERATE");
    drawText (0, 9, -3, "DN  DECELERATE");
    drawText (0, 8, -3, "F1  COCKPIT CAMERA");
    drawText (0, 7, -3, "F2  CHASE CAMERA");
    drawText (0, 6, -3, "F3  FRONT CAMERA");
    drawText (0, 5, -3, "F7  TOP CAMERA");
    drawText (0, 4, -3, "F8  SHOW MAP");
    drawText (0, 3, -3, "ESC MAIN MENU");
  }

  glPushMatrix ();
  glMatrixMode (GL_PROJECTION);
  glPushMatrix ();
  glLoadIdentity ();
  gluOrtho2D (0, width, 0, height);
  glScalef (1, -1, 1);
  glTranslatef (0, -height, 0);
  glMatrixMode (GL_MODELVIEW);
  glLoadIdentity ();
  gl->enableAlphaBlending ();
  glEnable (GL_ALPHA_TEST);
  glAlphaFunc (GL_GEQUAL, 0.1);
  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  gl->enableTextures (texcross2->textureID);
  int crossradius = width / 35;

  glBegin (GL_QUADS);
  glColor4ub (255, 255, 255, 255);
  glTexCoord2d (0, 0);
  glVertex2d (mousex - crossradius, mousey - crossradius);
  glTexCoord2d (0, 1);
  glVertex2d (mousex - crossradius, mousey + crossradius);
  glTexCoord2d (1, 1);
  glVertex2d (mousex + crossradius, mousey + crossradius);
  glTexCoord2d (1, 0);
  glVertex2d (mousex + crossradius, mousey - crossradius);
  glEnd ();
  glDisable (GL_ALPHA_TEST);
  glDisable (GL_TEXTURE_2D);
  gl->disableAlphaBlending ();
  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  glMatrixMode (GL_PROJECTION);
  glPopMatrix ();
  glMatrixMode (GL_MODELVIEW);
  glPopMatrix ();

  glPopMatrix ();
}

void pause_display ()
{
//  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity ();
//  glShadeModel(GL_SMOOTH);
  glPushMatrix ();

  CColor color (255, 255, 255, 255);
  drawText (-3, -1, -1, "PAUSED", &color);

  glPopMatrix ();
//  glutSwapBuffers();
}

void credits_display ()
{
  glTranslatef (0, -3.5 + 0.015 * (float) creditstimer, 0);
  CColor col (255, 255, 255, 255);
  CColor col2 (255, 255, 0, 255);
  drawText (-8, 10, -2, "GAME PROGRAMMING", &col);
  drawText (-10, 8, -2, "GRAPHICS SOUND MUSIC", &col);
  drawText (-7.5, 6, -2, "THOMAS A. DREXL", &col2);
  drawText (-5, 2, -2, "INTRO MOON", &col);
  drawText (-6.5, 0, -2, "NORBERT DREXL", &col2);
}

void game_display ()
{
  int i;

  if (debug)
    printf ("\nentering myDisplayFunc()"); fflush (stdout);

  bool sunvisible = false, sunblinding = false;
  float pseudoview = getView ();

  if (fplayer->tl->y > l->getRayHeight (fplayer->tl->x, fplayer->tl->z))
	sunblinding = true;

// calculate light factor
  if (camera == 0 && sunblinding && day && weather == 0)
  {
    float np = fplayer->phi;
    if (np >= 180) np -= 360;
    sunlight = fabs (np) + fabs (fplayer->gamma - 180 - sungamma);
//  printf ("\nphi=%f, gamma=%f", fplayer->phi, fplayer->gamma);
    if (sunlight < 90)
    { sunlight = (90 - sunlight) / 20;
      if (sunlight < 1.0) sunlight = 1.0;
    /*printf ("\nlight=%f", sunlight); fflush (stdout);*/ }
    else sunlight = 1.0;
  }
  else
  {
    if (day) sunlight = 1.0;
    else sunlight = 0.75;
    if (flash)
    {
      sunlight = flash;
    }
  }


  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
//  glClear(GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity ();

  glShadeModel(GL_SMOOTH);


  glPushMatrix ();
  
  if (camera != 1 && camera != 5)
    glRotatef (-camtheta, 0.0, 0.0, 1.0);
  if (camera == 0)
    glRotatef (-fplayer->gamma + 180, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma, 1.0, 0.0, 0.0);
  glRotatef (-camphi, 0.0, 1.0, 0.0);
//  if (camera == 0)
//    glRotatef (-20, 1.0, 0.0, 0.0);

  // draw sky
  glDisable (GL_FOG);
  glDisable (GL_DEPTH_TEST);

  float mylight = sunlight;
  if (!day) mylight /= 0.75;
  if (mylight > 1.0 && day)
    mylight = mylight / 20.0 + 0.95;
  else if (mylight > 1.0 && !day)
    mylight = mylight / 5.0 + 0.8;
  gl->foglum = mylight;
  sphere->drawGL (tlminf, tlinf, tlnull, space->alpha, mylight, true, false);

  if (weather == 0 || weather == 2)
  {
  if (!day)
  {
    glPointSize (1.0);
    int stars = maxstar;
    if (weather != 2) stars = maxstar / 2;
    for (i = 0; i < stars; i ++)
    {
      glPushMatrix ();
      glRotatef (/*-camphi +*/ star [i]->phi, 0.0, 1.0, 0.0);
      if (camera == 0)
        glRotatef (/*-fplayer->gamma + 180 +*/ star [i]->gamma, 1.0, 0.0, 0.0);
      else
        glRotatef (/*camgamma +*/ star [i]->gamma, 1.0, 0.0, 0.0);
      glTranslatef (0, 0, -10);
      star [i]->draw ();
      glPopMatrix ();
    }
  }
  }

//  sphere.draw (tlnull, tlnull, , 1.0);
  glEnable (GL_DEPTH_TEST);
  glEnable (GL_FOG);
//  glPopMatrix ();


// draw sun or moon (or earth)
//  glPushMatrix ();
  float r = 10.0;
//  float p = -fplayer->phi, t = -fplayer->gamma;
  float fac = view, zfac = view * 0.2;
//  if (camera != 1 && camera != 5)
//    glRotatef (-camtheta, 0.0, 0.0, 1.0);
  if (weather == 0 || weather == 2)
  {
  if (camera == 0)
    glRotatef (/*-fplayer->gamma + 180 +*/ sungamma, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma + sungamma, 1.0, 0.0, 0.0);
//  glRotatef (-camphi, 0.0, 1.0, 0.0);
  float zf = -11;
  if (day) zf = -12;
  if (l->type == 1 && !day) zf = -8;
  glTranslatef (0, 0, zf);
/*  if (camera == 0)
    glRotatef (-fplayer->gamma + 180 + sungamma, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma + sungamma, 1.0, 0.0, 0.0);
  glRotatef (-camphi, 0.0, 1.0, 0.0);*/
  gl->extractFrustum ();
  if (gl->isPointInFrustum (-1, 1, 0) || gl->isPointInFrustum (-1, -1, 0) ||
      gl->isPointInFrustum (1, -1, 0) || gl->isPointInFrustum (1, 1, 0))
  {
    sunvisible = true;
    glDisable (GL_DEPTH_TEST);
    if (day) gl->enableTextures (texsun->textureID);
    else if (l->type != 1) gl->enableTextures (texmoon->textureID);
    else gl->enableTextures (texearth->textureID);
    if (day && l->type != 1)
      glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    gl->enableAlphaBlending ();
    glEnable (GL_ALPHA_TEST);
    float alphamax = 0.1;
    if (day) alphamax = 0.9;
    glAlphaFunc (GL_GEQUAL, alphamax);
  //  glDisable (GL_DITHER);
    glBegin (GL_QUADS);
    fac = view; zfac = view * 3.5;
    if (day && l->type != 1)
    {
      float gm = (40.0 - sungamma) / 80.0;
      if (gm < 0) gm = 0;
      if (gm > 0.5) gm = 0.5;
      glColor4f (1.0, 1.0 - gm, 0.8 - gm, 1.0);
    }
    else
      glColor4f (1.0, 1.0, 1.0, 1.0);
    glTexCoord2d (0, 1);
    glVertex3f (-1, 1, 0);
    glTexCoord2d (1, 1);
    glVertex3f (1, 1, 0);
  //  glColor4f (0.1, 0.9, 0.9, 1.0);
    glTexCoord2d (1, 0);
    glVertex3f (1, -1, 0);
    glTexCoord2d (0, 0);
    glVertex3f (-1, -1, 0);
    glEnd ();
//    if (day && l->type != 1)
//      glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
    glDisable (GL_ALPHA_TEST);
    glEnable (GL_DEPTH_TEST);
    glDisable (GL_TEXTURE_2D);
    gl->disableAlphaBlending ();
  }
  }
  glPopMatrix ();
  

  
    
  
    
  glPushMatrix ();

  /* Modeltransformation ausfuehren... */

  if (camera != 1 && camera != 5)
    glRotatef (-camtheta, 0.0, 0.0, 1.0);

  if (camera == 0)
    glRotatef (-fplayer->gamma + 180, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma, 1.0, 0.0, 0.0);

  glDisable (GL_FOG);
/*  glPushMatrix ();
  glDisable (GL_DEPTH_TEST);
  glBegin (GL_QUAD_STRIP);
  float fac = view, zfac = view * 0.2;
  glColor4f (0.0, 1.0, 1.0, 1.0);
  glVertex3f (-fac, 2.0*fac, -zfac);
  glVertex3f (fac, 2.0*fac, -zfac);
  glColor4f (0.1, 0.9, 0.9, 1.0);
  glVertex3f (-fac, fac*0.4, -zfac);
  glVertex3f (fac, fac*0.4, -zfac);
  glColor4f (0.5, 0.5, 0.5, 1.0);
  glVertex3f (-fac, -fac*0.125, -zfac);
  glVertex3f (fac, -fac*0.125, -zfac);
  glVertex3f (-fac, -2.0*fac, -zfac);
  glVertex3f (fac, -2.0*fac, -zfac);
  glEnd ();
  glEnable (GL_DEPTH_TEST);
  
  glPopMatrix ();*/
//  glEnable (GL_FOG);


  glRotatef (-camphi, 0.0, 1.0, 0.0);  /* Rotation um die Y-Achse */


    

//  glPushMatrix ();
//  if (camera == 0)
//    glRotatef (-20, 1.0, 0.0, 0.0);
  glScalef (1, 1, 1);








  /*glPushMatrix ();
  if (camera == 0)
    glRotatef (-20, 1.0, 0.0, 0.0);
  glDisable (GL_DEPTH_TEST);

  drawTexture (10.0, -fplayer->phi - 20, 20 + 30, -fplayer->phi + 20, - 20 + 30);

  glEnable (GL_DEPTH_TEST);
  gl->disableAlphaBlending ();
  glPopMatrix ();*/
  
  
//  fplayer->tl->y = -(0.6*zoom - (float)l->h[(int)camx+MAXX/2][MAXX/2-(int)camz]*zoomz * zoom);
//  if (camera != 50)
//    camy = fplayer->tl->y + fplayer->zoom / 3.0;
//  if (camera == 1 || camera == 2) camy += fplayer->zoom * 0.6;
  glTranslatef (-camx /*-2*px / MAXX * zoom*/, -camy /*0.62*zoom - (float)l->h[(int)px+MAXX/2][MAXX/2-(int)pz]*zoomz * zoom*/, -camz/*-2*pz / MAXX * zoom*/);    /* Verschiebung um -3 in z-Richtung */

//  glPushMatrix();









/*  if (lighting)
  {
    glEnable( GL_LIGHTING);
    glEnable( GL_LIGHT0 );
  }*/

  if (camera != 50)
  {
    gl->enableFog (pseudoview);
  }

//  glEnable (GL_DITHER);

// draw terrain
  l->calcDynamicLight (explosion);
  glEnable (GL_CULL_FACE);
  l->draw ((int) camphi, (int) fplayer->gamma);
  glDisable (GL_CULL_FACE);

  gl->extractFrustum ();
//  gl->enableTextures (texgrass);
//  glEnable (GL_CULL_FACE);
  if (camera != 50)
  {
    space->lum = sunlight;
	for (i = 0; i < space->no; i ++)
	{
	  if (space->o [i]->tl->y < l->getExactRayHeight (space->o [i]->tl->x, space->o [i]->tl->z))
		space->o [i]->lum = 0.5;
	  else
		space->o [i]->lum = 1.0;
	}
  if (flash > 5)
    flash1->draw ();
    if (lighting)
    {
      glEnable( GL_LIGHTING);
      glEnable( GL_LIGHT0 );
      glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      space->drawGL ();
      glDisable (GL_LIGHTING);
      for (i = 0; i < space->no; i ++)
      {
        AIObj *dobj = (AIObj *) space->o [i];
        if (dobj->draw && dobj->drawlight && dobj->active)
        {
          if (dobj->smoke)
            if ((dobj->id >= MISSILE1 && dobj->id <= MISSILE2) || (dobj->id >= FIGHTER1 && dobj->id <= FIGHTER2))
              if (!(dobj->ttl == 0 && dobj->id >= MISSILE1 && dobj->id <= MISSILE2))
              {
                dobj->smoke->draw ();
              }
        }
      }
    }
    else
    {
      space->drawGL ();
    }
  }
//  glDisable (GL_CULL_FACE);
  glDisable (GL_TEXTURE_2D);

  glDisable (GL_LIGHTING);

  if (camera == 0)
  {
    glDisable (GL_DEPTH_TEST);
    cockpit->drawTargeter ();
    glEnable (GL_DEPTH_TEST);
  }

  glPopMatrix ();

//  gl->enableAntiAliasing ();

  /* Where is the sun? */
/* double ra=10.0;
  double winx, winy, winz;
  winx = ra*sin(fplayer->gamma)*cos(fplayer->phi)*width;
  winy = ra*sin(fplayer->gamma)*sin(fplayer->phi)*height;
  winz = ra*cos(fplayer->gamma);
  double proj[16];
  double modl[16];
  int vp[4];
  glGetDoublev( GL_PROJECTION_MATRIX, proj );
  glGetDoublev( GL_MODELVIEW_MATRIX, modl );
  vp[0]=0; vp[1]=0; vp[2]=width; vp[3]=height;
//  gluProject (0, 0, 1.0, proj, modl, vp, &winx, &winy, &winz);
  double objx, objy, objz;
  gluUnProject (winx, winy, winz, modl, proj, vp, &objx, &objy, &objz);
  printf ("\nre: x=%f, y=%f, z=%f", objx, objy, objz); fflush (stdout);
  glBegin (GL_LINES);
  glVertex3f (-objx, -objy, objz);
  glVertex3f (-objx, -objy, 5);
  glEnd ();*/

// draw flares
  if (sunvisible && camera == 0 && sunblinding && day)
  {
  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  int maxi = 4;
  for (i = maxi - 1; i >= 1; i --)
  {
  glDisable (GL_DEPTH_TEST);
  glPushMatrix ();
  r = 10.0;
  fac = view; zfac = view * 0.2;
  int myphi = (int) camphi;
  if (camera != 1 && camera != 5)
    glRotatef (-camtheta, 0.0, 0.0, 1.0);
//  else
//    glRotatef (-20, 0.0, 0.0, 1.0);
  if (camera == 0)
    glRotatef (-fplayer->gamma + 180 + sungamma * i / maxi, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma + sungamma * i / maxi, 1.0, 0.0, 0.0);
  if (myphi < 180) myphi = myphi * i / maxi;
  else myphi = 360 - (360 - myphi) * i / maxi;
  glRotatef (-myphi, 0.0, 1.0, 0.0);
  glTranslatef (0, 0, (float) -10.0 * i / maxi);
  if (camera == 0)
    glRotatef (-fplayer->gamma + 180 + sungamma * i / maxi, 1.0, 0.0, 0.0);
  else
    glRotatef (camgamma + sungamma * i / maxi, 1.0, 0.0, 0.0);
  glRotatef (-myphi, 0.0, 1.0, 0.0);
  glDisable (GL_DEPTH_TEST);
  gl->enableTextures (texflare->textureID);
  gl->enableAlphaBlending ();
//  glDisable (GL_DITHER);
  glBegin (GL_QUADS);
  fac = view; zfac = view * 3.5;
  glColor4f (1.0, 1.0, 1.0, 1.0);
  glTexCoord2d (0, 1);
  glVertex3f (-0.5, 0.5, 0);
  glTexCoord2d (1, 1);
  glVertex3f (0.5, 0.5, 0);
//  glColor4f (0.1, 0.9, 0.9, 1.0);
  glTexCoord2d (1, 0);
  glVertex3f (0.5, -0.5, 0);
  glTexCoord2d (0, 0);
  glVertex3f (-0.5, -0.5, 0);
  glEnd ();
  glEnable (GL_DEPTH_TEST);
  glDisable (GL_TEXTURE_2D);
  gl->disableAlphaBlending ();
  glPopMatrix ();
  }
  glTexEnvi (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  }  


//  float zf, g, g2;
//  glPushMatrix ();
  if (camera == 0)
  {
    cockpit->drawCross ();
    cockpit->drawHeading ();
    cockpit->drawTargetedElement ();
    cockpit->drawRadar ();
  }
//  glPopMatrix ();
//  glutStrokeCharacter (GLUT_STROKE_ROMAN, 'A');

/*  drawText (-5, 0, -10, "DOGFIGHT");
  drawText (-5, -3, -10, "OPTIONS");*/

  mission->draw ();

  glPushMatrix ();
  glDisable (GL_DEPTH_TEST);
/*  glMatrixMode (GL_PROJECTION);
  glPushMatrix ();
  glLoadIdentity ();
  gluOrtho2D (0, width, 0, height);
  glScalef (1, -1, 1);
  glTranslatef (0, -height, 0);
  glMatrixMode (GL_MODELVIEW);
  glLoadIdentity ();

  glColor3d (255, 255, 0);
  char *c;
  char *string = "action fs demo";
  glRasterPos2f (20, 25);
  for (c = string; *c; c ++)
  {
    glutBitmapCharacter (GLUT_BITMAP_HELVETICA_12, *c);
//    glutStrokeCharacter (GLUT_STROKE_ROMAN, *c);
  }
  char buf [25];
  sprintf (buf, "FPS: %d", (int) fps);
  glRasterPos2f (20, 50);
  for (c = buf; *c; c ++)
  {
    glutBitmapCharacter (GLUT_BITMAP_8_BY_13, *c);
  }

  glMatrixMode (GL_PROJECTION);
  glPopMatrix ();
  glMatrixMode (GL_MODELVIEW);*/
  glPopMatrix ();

  char buf [25];
  CColor col;
  sprintf (buf, "FPS: %d", (int) fps);
  drawText (-25, 25, -3.5, buf, &col);

  if (missionstate == 1)
  {
    CColor colblue (0, 0, 255, 200);
    drawText (-3.5, 1, -1.2, "MISSION", &colblue);
    drawText (-3.5, -1, -1.2, "SUCCESS", &colblue);
    sprintf (buf, "SCORE: %d", mission->getScore (missionstate));
    drawText (-5, -4, -2, buf, &colblue);
  }
  else if (missionstate == 2)
  {
    CColor colred (255, 0, 0, 200);
    drawText (-3.5, 1, -1.2, "MISSION", &colred);
    drawText (-3, -1, -1.2, "FAILED", &colred);
    sprintf (buf, "SCORE: %d", mission->getScore (missionstate));
    drawText (-5, -4, -2, buf, &colred);
  }

  if (debug)
    printf ("\nleaving myDisplayFunc()"); fflush (stdout);
}

float lastspeed;
int gametimer;

void game_timer ()
{
  if (multiplayer) return;

  int i, i2;

  gametimer ++;

  if (debug)
    printf ("\nentering myTimerFunc()"); fflush (stdout);

    if (weather == 1 && !flash && !myrandom (30))
    {
      flash = 10;
      int fphi = (int) camphi + myrandom (50) - 25;
      if (fphi < 0) fphi += 360;
      else if (fphi >= 360) fphi -= 360;
      float pseudoview = getView ();
      float fdist = myrandom ((int) pseudoview - 20) + 10;
      float fx = fplayer->tl->x - sine [fphi] * fdist;
      float fz = fplayer->tl->z - cosi [fphi] * fdist;
      flash1->set (fx, l->getHeight (fx, fz), fz, camphi);
      int lev = (int) (128.0 - 80.0 * fdist / (pseudoview - 10));
      sound->setVolume (SOUND_THUNDER1, lev);
      sound->play (SOUND_THUNDER1);
    }

  if (initing) return;

  if (flash)
    flash --;
  if (flash <= 5 && flash > 0)
    flash --;

  if (lastspeed != fplayer->speed && !(gametimer & 15))
    setPlaneVolume ();
  lastspeed = fplayer->speed;

  for (i = 0; i < maxfighter; i ++)
  {
    for (i2 = 0; i2 < maxlaser; i2 ++)
      if (laser [i2]->active)
        fighter [i]->collide (laser [i2]);
    for (i2 = 0; i2 < maxmissile; i2 ++)
      if (missile [i2]->active)
        fighter [i]->collide (missile [i2]);
    for (i2 = 0; i2 < maxfighter; i2 ++)
      if (fighter [i2]->active)
        if (i != i2)
          fighter [i]->collide (fighter [i2]);
  }

  for (i = 0; i < maxfighter; i ++)
  {
    fighter [i]->aiAction ((AIObj **) fighter, missile, laser);
  }
  for (i = 0; i < maxlaser; i ++)
    laser [i]->move ();
  for (i = 0; i < maxmissile; i ++)
    missile [i]->aiAction ((AIObj **) fighter, missile, laser);

  for (i = 0; i < maxexplosion; i ++)
    explosion [i]->move ();

  if (fplayer->shield <= 0)
    camera = 1;
/*  if (!fplayer->active && !fplayer->draw)
    game_levelInit ();*/

  float cf = -fplayer->zoom / 2;
  camtheta = fplayer->theta;
  if (camera == 0)  // cockpit
  {
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom / 3.0;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 0;
  }
  if (camera == 1) // chase
  {
    cf = fplayer->zoom * 2;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 2) // backwards
  {
    cf = -fplayer->zoom * 2;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi + 180.0;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 3) // other players
  {
    cf = fighter [aktcam]->zoom * 2;
    camx = fighter [aktcam]->tl->x + cf * sine [(int) fighter [aktcam]->phi];// * MAXX / zoom / 2;
    camy = fighter [aktcam]->tl->y + fighter [aktcam]->zoom;
    camz = fighter [aktcam]->tl->z + cf * cosi [(int) fighter [aktcam]->phi];// * MAXX / zoom / 2;
    camphi = fighter [aktcam]->phi;
    camgamma = 20;
    camtheta = fighter [aktcam]->theta;
    fplayer->draw = 1;
  }
  else if (camera == 4) // missile
  {
    cf = missile [0]->zoom * 5;
    camx = missile [0]->tl->x + cf * sine [(int) missile [0]->phi];// * MAXX / zoom / 2;
    camy = missile [0]->tl->y + fplayer->zoom;
    camz = missile [0]->tl->z + cf * cosi [(int) missile [0]->phi];// * MAXX / zoom / 2;
    camphi = missile [0]->phi;
    fplayer->draw = 1;
  }
  else if (camera == 5) // top
  {
    cf = fplayer->zoom * 15;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + 5.5;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 1;
    camgamma = 50;
  }
  else if (camera == 6) // left
  {
    cf = fplayer->zoom * 2;
    camphi = fplayer->phi + 90.0;
    if (camphi >= 360) camphi -= 360;
    else if (camphi < 0) camphi += 360;
    camx = fplayer->tl->x + cf * sine [(int) camphi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) camphi];// * MAXX / zoom / 2;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 7) // right
  {
    cf = fplayer->zoom * 2;
    camphi = fplayer->phi + 270.0;
    if (camphi >= 360) camphi -= 360;
    else if (camphi < 0) camphi += 360;
    camx = fplayer->tl->x + cf * sine [(int) camphi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) camphi];// * MAXX / zoom / 2;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 50)
  {
    camx = 20;
    camz = 80;
    camy = 250;
    camphi = 20;
    camgamma = 75;
    game = GAME_PAUSE;
  }
  if (camphi >= 360.0) camphi -= 360.0;
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif

  fplayer->rectheta -= dtheta;
  fplayer->recgamma += dgamma;

//  printf ("%f, %f\n", fplayer->tl->x, fplayer->tl->z);
  missionstate = mission->processtimer ();

  if (missionstate == 2)
  {
    missionending ++;
    if (missionending >= 35)
    {
      missionending = 0;
      printf ("initing new mission"); fflush (stdout);
      missionactive = false;
      game_levelInit (0);
      switch_menu ();
    }
  }

  if (missionstate == 1)
  {
    missionending ++;
    if (missionending >= 35)
    {
      missionending = 0;
      printf ("initing new mission"); fflush (stdout);
      missionactive = false;
      game_levelInit (0);
      switch_menu ();
    }
  }

  if (debug)
    printf ("\nleaving myTimerFunc()"); fflush (stdout);
}

int net_thread_main (void *data)
{
  while (true)
  {

  int i, i2;

  gametimer ++;

  if (debug)
    printf ("\nentering myTimerFunc()"); fflush (stdout);

    if (weather == 1 && !flash && !myrandom (30))
    {
      flash = 10;
      int fphi = (int) camphi + myrandom (50) - 25;
      if (fphi < 0) fphi += 360;
      else if (fphi >= 360) fphi -= 360;
      float pseudoview = getView ();
      float fdist = myrandom ((int) pseudoview - 20) + 10;
      float fx = fplayer->tl->x - sine [fphi] * fdist;
      float fz = fplayer->tl->z - cosi [fphi] * fdist;
      flash1->set (fx, l->getHeight (fx, fz), fz, camphi);
      int lev = (int) (128.0 - 80.0 * fdist / (pseudoview - 10));
      sound->setVolume (SOUND_THUNDER1, lev);
      sound->play (SOUND_THUNDER1);
    }

  if (flash)
    flash --;
  if (flash <= 5 && flash > 0)
    flash --;

  if (lastspeed != fplayer->speed && !(gametimer & 15))
    setPlaneVolume ();
  lastspeed = fplayer->speed;

  for (i = 0; i < maxfighter; i ++)
  {
    for (i2 = 0; i2 < maxlaser; i2 ++)
      if (laser [i2]->active)
        fighter [i]->collide (laser [i2]);
    for (i2 = 0; i2 < maxmissile; i2 ++)
      if (missile [i2]->active)
        fighter [i]->collide (missile [i2]);
    for (i2 = 0; i2 < maxfighter; i2 ++)
      if (fighter [i2]->active)
        if (i != i2)
          fighter [i]->collide (fighter [i2]);
  }

  for (i = 0; i < maxfighter; i ++)
  {
    fighter [i]->aiAction ((AIObj **) fighter, missile, laser);
  }
  for (i = 0; i < maxlaser; i ++)
    laser [i]->move ();
  for (i = 0; i < maxmissile; i ++)
    missile [i]->aiAction ((AIObj **) fighter, missile, laser);

  for (i = 0; i < maxexplosion; i ++)
    explosion [i]->move ();

  if (fplayer->shield < 0)
    camera = 1;
/*  if (!fplayer->active && !fplayer->draw)
    game_levelInit ();*/

  float cf = -fplayer->zoom / 2;
  camtheta = fplayer->theta;
  if (camera == 0)  // cockpit
  {
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom / 3.0;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 0;
  }
  if (camera == 1) // chase
  {
    cf = fplayer->zoom * 2;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 2) // backwards
  {
    cf = -fplayer->zoom * 2;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi + 180.0;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 3) // other players
  {
    cf = fighter [aktcam]->zoom * 2;
    camx = fighter [aktcam]->tl->x + cf * sine [(int) fighter [aktcam]->phi];// * MAXX / zoom / 2;
    camy = fighter [aktcam]->tl->y + fighter [aktcam]->zoom;
    camz = fighter [aktcam]->tl->z + cf * cosi [(int) fighter [aktcam]->phi];// * MAXX / zoom / 2;
    camphi = fighter [aktcam]->phi;
    camgamma = 20;
    camtheta = fighter [aktcam]->theta;
    fplayer->draw = 1;
  }
  else if (camera == 4) // missile
  {
    cf = missile [0]->zoom * 5;
    camx = missile [0]->tl->x + cf * sine [(int) missile [0]->phi];// * MAXX / zoom / 2;
    camy = missile [0]->tl->y + fplayer->zoom;
    camz = missile [0]->tl->z + cf * cosi [(int) missile [0]->phi];// * MAXX / zoom / 2;
    camphi = missile [0]->phi;
    fplayer->draw = 1;
  }
  else if (camera == 5) // top
  {
    cf = fplayer->zoom * 15;
    camx = fplayer->tl->x + cf * sine [(int) fplayer->phi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + 5.5;
    camz = fplayer->tl->z + cf * cosi [(int) fplayer->phi];// * MAXX / zoom / 2;
    camphi = fplayer->phi;
    fplayer->draw = 1;
    camgamma = 50;
  }
  else if (camera == 6) // left
  {
    cf = fplayer->zoom * 2;
    camphi = fplayer->phi + 90.0;
    if (camphi >= 360) camphi -= 360;
    else if (camphi < 0) camphi += 360;
    camx = fplayer->tl->x + cf * sine [(int) camphi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) camphi];// * MAXX / zoom / 2;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 7) // right
  {
    cf = fplayer->zoom * 2;
    camphi = fplayer->phi + 270.0;
    if (camphi >= 360) camphi -= 360;
    else if (camphi < 0) camphi += 360;
    camx = fplayer->tl->x + cf * sine [(int) camphi];// * MAXX / zoom / 2;
    camy = fplayer->tl->y + fplayer->zoom;
    camz = fplayer->tl->z + cf * cosi [(int) camphi];// * MAXX / zoom / 2;
    fplayer->draw = 1;
    camgamma = 20;
  }
  else if (camera == 50)
  {
    camx = 20;
    camz = 80;
    camy = 250;
    camphi = 20;
    camgamma = 75;
    game = GAME_PAUSE;
  }
  if (camphi >= 360.0) camphi -= 360.0;
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif

  fplayer->rectheta -= dtheta;
  fplayer->recgamma += dgamma;

//  printf ("%f, %f\n", fplayer->tl->x, fplayer->tl->z);
  missionstate = mission->processtimer ();

  if (missionstate == 2)
  {
    missionending ++;
    if (missionending >= 35)
    {
      missionending = 0;
      printf ("initing new mission"); fflush (stdout);
      missionactive = false;
      game_levelInit (0);
      switch_menu ();
    }
  }

  if (missionstate == 1)
  {
    missionending ++;
    if (missionending >= 35)
    {
      missionending = 0;
      printf ("initing new mission"); fflush (stdout);
      missionactive = false;
      game_levelInit (0);
      switch_menu ();
    }
  }

  if (debug)
    printf ("\nleaving myTimerFunc()"); fflush (stdout);


  if (multiplayer)
  {

    if (isserver)
    {
      int len = fplayer->net_write ();
      server->sendMessage (1, fplayer->net, len);
      while (server->getMessage (1, fighter [1]->net))
        fighter [1]->net_read ();
    }
    else
    {
      int len = fplayer->net_write ();
      client->sendMessage (fplayer->net, len);
      while (client->getMessage (fighter [0]->net))
        fighter [0]->net_read ();
      
    }

  }

#ifdef HAVE_SDL
    SDL_Delay (50);
#endif
  }
}

void menu_timer ()
{
  menutimer ++;
  if (!(menutimer & 0xFF))
  {
    if (camera == 5)
    {
      camera = 1;
      if (missile [0]->active)
        camera = 4;
    }
    else if (camera == 1 || camera == 4) camera = 2;
    else if (camera == 2) camera = 5;
  }
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}

void credits_timer ()
{
  creditstimer ++;
  if (creditstimer > 360)
    creditstimer = 0;
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}
//#include <time.h>

void create_key (unsigned char key, int x, int y)
{
  if (key == 's')
  {
    game_levelInit (1000);
    switch_game ();
    missionactive = true;
  }
}

void join_key (unsigned char key, int x, int y)
{
  if (key == 's')
  {
    game_levelInit (1000);
    switch_game ();
    missionactive = true;
  }
}

void create_timer ()
{
#ifndef USE_GLUT
//  server->createSocketSet ();
  server->getClient ();
  SDL_Delay (100);
#endif
}

void join_timer ()
{
#ifndef USE_GLUT
  client->getServer ("Lara", "client1");
  SDL_Delay (100);
#endif
}

void myInit ()
{
  int i;
  if (debug)
    printf ("\nentering myInit()"); fflush (stdout);

  if (debug)
    printf ("\n initing landscape"); fflush (stdout);

  texsun = gl->genTextureTGA ("../textures/sun2.tga", 1, 2, 0);
  texmoon = gl->genTextureTGA ("../textures/moon1.tga", 1, 2, 0);
  texearth = gl->genTextureTGA ("../textures/earth.tga", 1, 0, 0);
  texflare = gl->genTextureTGA ("../textures/flare1.tga", 1, 2, 0);
  texgrass = gl->genTextureTGA ("../textures/grass1.tga", 0, 0, 1);
  texrocks = gl->genTextureTGA ("../textures/rocks1.tga", 0, 0, 1);
  texwater = gl->genTextureTGA ("../textures/water1.tga", 0, 0, 1);
  texredstone = gl->genTextureTGA ("../textures/redstone2.tga", 0, 0, 1);
  textree = gl->genTextureTGA ("../textures/tree1.tga", 0, 3, 1);
  textree2 = gl->genTextureTGA ("../textures/tree2.tga", 0, 3, 1);
  textree3 = gl->genTextureTGA ("../textures/tree3.tga", 0, 3, 1);
  textree4 = gl->genTextureTGA ("../textures/tree4.tga", 0, 3, 1);
  texsmoke = gl->genTextureTGA ("../textures/smoke1.tga", 0, 4, 1);
  texsmoke2 = gl->genTextureTGA ("../textures/smoke2.tga", 0, 4, 1);
  texcross = gl->genTextureTGA ("../textures/cross.tga", 0, 2, 1);
  texcross2 = gl->genTextureTGA ("../textures/cross2.tga", 0, 2, 1);
//  texfont1 = gl->genTextureTGA ("textures/font1.tga", 0, 3, 0);


//  l = new GLLandscape (space);

  tlinf = new CVector3 (1E10, 1E10, 1E10);
  tlminf = new CVector3 (-1E10, -1E10, -1E10);
  tlnull = new CVector3 (0, 0, 0);

  if (debug)
    printf ("\n initing fighters"); fflush (stdout);

  for (i = 0; i < maxgroundobj; i ++)
  {
    groundobj [i] = new DynamicObj (space, &model_wall1, 3);
  }

/*  obj = new Model ();
  obj->loadFromFile ("./data/f4.v3d");*/

  CModel *explsphere = new CSphere ();
  ((CSphere *) explsphere)->init (1, 9);
  explsphere->setColor (new CColor (255, 255, 1));
  for (i = 0; i < explsphere->object [0]->numVertices; i ++)
    explsphere->object [0]->vertex [i].color.setColor (myrandom (100) + 155, myrandom (100) + 100, 0);
//  ((CSphere *) explsphere)->invertNormals ();
  for (i = 0; i < maxexplosion; i ++)
  {
    explosion [i] = new CExplosion (space, explsphere);
  }

  for (i = 0; i < maxfighter; i ++)
  {
    fighter [i] = new Fighter (space, &model_fig, 0.4);
  }

  if (debug)
    printf ("\n initing sphere"); fflush (stdout);

  objsphere = new CSphere (1, 9, 1, 1, 1);
  sphere = new CSpaceObj (objsphere, 10.0);
  //sphere = new CSpaceObj ();
  sphere->rot->b = 90;
  sphere->draw = 2;
  sphere->drawlight = false;

  flash1 = new Flash ();

  if (debug)
    printf ("\n initing lasers"); fflush (stdout);

//  objlaser = new CModel ();
//  objlaser->loadFromFile ("./data/c1.v3d");
  for (i = 0; i < maxlaser; i ++)
  {
    laser [i] = new DynamicObj (space, &model_cannon1, 0.07);
  }

  if (debug)
    printf ("\n initing missiles"); fflush (stdout);

//  objmissile = new CModel ();
//  objmissile->loadFromFile ("./data/r1.v3d");
  for (i = 0; i < maxmissile; i ++)
  {
    missile [i] = new AIObj (space, &model_missile, 0.1);
  }

  for (i = 0; i < maxstar; i ++)
  {
    star [i] = new Star (myrandom (360), myrandom (85), 0.4 + 0.1 * myrandom (8));
  }

  cockpit = new Cockpit ();

  game_levelInit (0);

  menu_reshape ();

  if (debug)
    printf ("\nleaving myInit()"); fflush (stdout);
}

class InitKugel
{
  public:
  int explosion;
  CModel *m;
  CVector3 tl;
  InitKugel(){}

  InitKugel (CModel *m)
  {
    tl.x = (int) (0.1 * myrandom(800) - 40);
    tl.y = (int) (0.1 * myrandom(800) - 40);
    tl.z = (int) (0.1 * myrandom(800) - 40);
    this->m = m;
    explosion = 0;
  }

  InitKugel (float x, float y, float z, CModel *m)
  {
    tl.x = x;
    tl.y = y;
    tl.z = z;
    this->m = m;
    explosion = 0;
  }
  
  void draw()
  {
    if (explosion > 200) return;
    if (explosion) explosion ++;
    CVector3 tlnull;
    CRotation rot;
    glPushMatrix();
    m->draw3 (&tlnull, &tl, &rot, 0.8, explosion);
    glPopMatrix();
  }
};


CRotation rot;
CRotation rot2;
CVector3 tl;
CVector3 tl2;
int initexplode = 0;
float inittextz = -5;
float inittextrot = 0;
InitKugel *mykugel [100];
int i;
int inittimer = 0;

void init_reshape ()
{
  /* Darstellung auf gesamten Clientbereich des Fensters zulassen */
  glViewport(0, 0, (GLint) width, (GLint) height);

  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  /* angle, aspect, near Clip, far Clip */
  float v = view;
  if (camera == 50) v = 100000.0;
  gluPerspective (80.0, 1.0, 0.20, 80); // should be sqrt(2) or 1.5
  glPolygonMode (GL_FRONT_AND_BACK, polygonMode);
}

void myFirstInit ()
{
  int i;


  gl = new GL (1.0, 1000.0);
  texfont1 = gl->genTextureTGA ("../textures/font1.tga", 0, 1, 0);
  g_Load3ds.Import3DS (&model_fig, "../models/fig7.3ds");
  model_fig.setName ("EAGLE");
  g_Load3ds.Import3DS (&model_figa, "../models/fig4.3ds");
  model_figa.setName ("SHARK");
  g_Load3ds.Import3DS (&model_figt, "../models/transp1.3ds");
  model_figt.setName ("TRANSPORT");
  g_Load3ds.Import3DS (&model_cannon1, "../models/cannon1.3ds");
  g_Load3ds.Import3DS (&model_cannon2, "../models/cannon2.3ds");
  model_cannon2.nolight = true;
  model_cannon2.object [0]->vertex [2].color.c [0] = 50;
  model_cannon2.object [0]->vertex [2].color.c [1] = 50;
  model_cannon2.object [0]->vertex [2].color.c [2] = 50;
  model_cannon2.object [0]->vertex [1].color.c [0] = 50;
  model_cannon2.object [0]->vertex [1].color.c [1] = 50;
  model_cannon2.object [0]->vertex [1].color.c [2] = 50;
  g_Load3ds.Import3DS (&model_missile, "../models/missile1.3ds");
  g_Load3ds.Import3DS (&model_flak1, "../models/flak1.3ds");
  g_Load3ds.Import3DS (&model_ship1, "../models/ship1.3ds");
  g_Load3ds.Import3DS (&model_tent1, "../models/tent1.3ds");
  g_Load3ds.Import3DS (&model_wall1, "../models/wall1.3ds");
/*	for(i = 0; i < model.numOfMaterials; i++)
	{
		if(strlen(model.pMaterials[i]->strFile) > 0)
		{
//			CreateTexture(g_Texture, model.pMaterials[i].strFile, i);
		}
		model.pMaterials[i]->texureId = i;
	}*/

  
  /* Z-Buffer f. Berechnung verdeckter Flaechen einschalten */
  glEnable(GL_DEPTH_TEST);

  /* Vorder- u. Rueckseite der Polygone nur als Randlinien darstellen */
  glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);

  float pi = atan (1.0) * 4.0;
  for (i = 0; i < 360; i ++)
  {
    sine [i] = sin ((float) i / 180.0 * pi);
    cosi [i] = cos ((float) i / 180.0 * pi);
  }

  if (debug)
    printf ("\n initing space"); fflush (stdout);
  space = new Space ();
  space->drawlight = true;
  clip1 = space->z1;
  clip2 = space->z2;
  clip1->x = -ZOOM;
  clip1->y = -ZOOM;
  clip1->z = -ZOOM;
  clip2->x = ZOOM;
  clip2->y = ZOOM;
  clip2->z = ZOOM;

  init_reshape ();

  CColor* mycolor = new CColor (255, 255, 100);
  CColor* mycolor2 = new CColor (155, 155, 55);
  CSphere *mysphere = new CSphere (1, 8, 1, 1, 1);
  mysphere->setColor (mycolor2);
  mysphere->setNorthPoleColor (mycolor, 1.9);
  for (i = 0; i < 100; i++)
  {
    mykugel [i] = new InitKugel (mysphere);
  }

  tl.x = -1.5;
  tl.y = 1.0;
  tl.z = -5.0;
  tl2.x = 1.5;
  tl2.y = 1.0;
  tl2.z = -5.0;
  rot.a = 270;
  rot2.a = 270;
}


void init_key (int key, int x, int y)
{
//  game_quit ();
  myInit ();
  switch_menu ();
  fplayer->ai = true;
  camera = 5;
}

void init_display ()
{
  int i;
  char buf [20];
  char buf2 [20];
  CVector3 vec;
  CColor color (200, 200, 200, 255);

//  gluPerspective (80.0, (float) width / height, 0.20, 50.0); // should be sqrt(2) or 1.5
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity ();
//  glShadeModel(GL_SMOOTH);
//  glPushMatrix ();
//  gluPerspective (80.0, (float) width / height, 0.20, 150.0); // should be sqrt(2) or 1.5

/*  glBegin (GL_TRIANGLES);
  glColor3ub (255,255,0);
  glVertex3f (-1,-1,-1.1);
  glVertex3f (1,-1,-1.1);
  glVertex3f (0,1,-1.1);
  glEnd ();*/

  glPushMatrix ();

  glTranslatef (1,1,-50);
  glEnable (GL_DEPTH_TEST);
  glPushMatrix ();
  gl->rotate (0 ,inittimer, 0);
  gl->rotate (0 ,0 ,inittimer);
  int num = 50;
  if (quality < 2) num = 10;
  for (i = 0; i < num; i++)
  {
    mykugel[i]->draw ();
  }
  glPopMatrix ();
  glPushMatrix ();
  gl->rotate (0 ,0 ,360 - inittimer);
  gl->rotate (0 ,360 - inittimer, 0);
  for (i = 100 - num; i < 100; i++)
  {
    mykugel[i]->draw ();
  }
  glPopMatrix ();
  glPopMatrix ();


  glPushMatrix ();
  glTranslatef (0,0,-10);
  glEnable (GL_DEPTH_TEST);
  model_fig.draw2 (&vec, &tl, &rot, 1.0, initexplode);
  glPopMatrix ();


  glPushMatrix ();
  glTranslatef (0,0,-5);
  glEnable (GL_DEPTH_TEST);
  model_fig.draw2 (&vec, &tl2, &rot2, 1.0, initexplode);
  glPopMatrix ();

  glPushMatrix ();
  glTranslatef (0,0,inittextz);
  gl->rotate ((int) inittextrot, 0, 0);
  strcpy (buf, "GL-117");
  buf2 [1] = 0;
  for (i = 0; i < 10; i++)
  {
    buf2 [0] = buf [i];
    drawText (i-3, -0.5, 0.05, buf2, &color);
    gl->rotate (-18, 0, 0);
  }

  glPopMatrix ();
  //drawText (0, 0, -0.9, "LOADING...", &color);

  drawText (-20, -20, -3, VERSIONSTRING, &color);

//  glPopMatrix ();
//  glutSwapBuffers ();
}

void init_timer ()
{
  if (initexplode > 30) initexplode = -1;
  if (inittextz < -0.5)
  {
    inittextz += 0.06;
  }
  else
  {
    if (!mykugel [0]->explosion)
      for (int i = 0; i < 100; i ++)
        mykugel [i]->explosion ++;
  }
  tl.z += 0.15;
  tl2.z += 0.15;
  if (!mykugel [0]->explosion)
    inittimer ++;
  if (mykugel [0]->explosion >= 150)
  {
    init_key (27, 0, 0); // switch to menu
  }
//  initexplode ++;
  inittextrot += 5;
  
//  rot.a ++;
  if (tl.z > -4.0)
  {
    rot.b ++;
    rot2.b --;
  }
//  rot.c ++;
#ifdef USE_GLUT
  glutPostRedisplay();
#else
  sdldisplay = true;
#endif
}

static void myKeyboardFunc (unsigned char key, int x, int y)
{
  if (game == GAME_PLAY || game == GAME_PAUSE)
    game_key (key, x, y);
  else if (game == GAME_INIT)
    init_key (key, x, y);
  else if (game == GAME_MENU)
    menu_key (key, x, y);
  else if (game == GAME_CREDITS)
    credits_key (key, x, y);
  else if (game == GAME_CREATE)
    create_key (key, x, y);
  else if (game == GAME_JOIN)
    join_key (key, x, y);
}

static void mySpecialFunc (int key, int x, int y)
{
  if (game == GAME_PLAY || game == GAME_PAUSE)
    game_keyspecial (key, x, y);
}

static void myPassiveMotionFunc (int x, int y)
{
  mousex = x; mousey = y;
  if (game == GAME_PLAY)
    game_mousemotion (x, y);
  else if (game == GAME_MENU)
    menu_mouse (-1, -1, x, y);
}

static void myMouseFunc (int button, int state, int x, int y)
{
  if (game == GAME_PLAY)
  {
    game_mouse (button, state, x, y);
  }
  if (game == GAME_MENU)
  {
    menu_mouse (button, state, x, y);
  }
}

static void myReshapeFunc (int width, int height)
{
  ::width = width;
  ::height = height;
  if (game == GAME_PLAY || game == GAME_PAUSE)
    game_reshape ();
  else if (game == GAME_MENU)
    menu_reshape ();
  else if (game == GAME_INIT)
    init_reshape ();
  else if (game == GAME_CREDITS)
    credits_reshape ();
}

static void myDisplayFunc ()
{
  if (game == GAME_INIT)
  {
    init_display ();
    game_view ();
//    myInit();
//    game = GAME_PLAY;
  }
  else if (game == GAME_PLAY)
  {
    game_display ();
    game_view ();
  }
  else if (game == GAME_PAUSE)
  {
    game_display ();
    pause_display ();
    game_view ();
  }
  else if (game == GAME_MENU)
  {
    if (camera == 50) camera = 0;
    game_display ();
    menu_display ();
    game_view ();
  }
  else if (game == GAME_CREDITS)
  {
    if (camera == 50) camera = 0;
    game_display ();
    credits_display ();
    game_view ();
  }
}

static void myIdleFunc ()
{
#ifdef USE_GLUT
  glutPostRedisplay ();
#endif
}

static void myJoystickAxisFunc (int x, int y, int t, int r)
{
  if (game == GAME_PLAY)
  {
    game_joystickaxis (x, y, t, r);
  }
}

static void myJoystickButtonFunc (int button)
{
  if (game == GAME_PLAY)
  {
    game_joystickbutton (button);
  }
}

static void myJoystickHatFunc (int hat)
{
  if (game == GAME_PLAY)
  {
    game_joystickhat (hat);
  }
}

#define TIMER_INTERVAL 30

static void myTimerFunc (int value)
{
//  fplayer->aiAction (l);
  if (game == GAME_PLAY)
    game_timer ();
  else if (game == GAME_INIT)
    init_timer ();
  else if (game == GAME_MENU)
  {
    if (!missionactive)
      game_timer ();
    menu_timer ();
  }
  else if (game == GAME_CREDITS)
  {
    credits_timer ();
  }
  else if (game == GAME_CREATE)
    create_timer ();
  else if (game == GAME_JOIN)
    join_timer ();

#ifdef USE_GLUT
  glutTimerFunc (TIMER_INTERVAL, myTimerFunc, 0);
#endif
}

static void sdlTimerFunc ()
{
  if (game == GAME_PLAY)
    game_timer ();
  else if (game == GAME_INIT)
    init_timer ();
  else if (game == GAME_MENU)
  {
    if (!missionactive)
      game_timer ();
    menu_timer ();
  }
  else if (game == GAME_CREDITS)
  {
    credits_timer ();
  }
  else if (game == GAME_CREATE)
    create_timer ();
  else if (game == GAME_JOIN)
    join_timer ();
}

#ifndef USE_GLUT
Uint32 sdlTimeLeft ()
{
  static Uint32 nexttime = 0;
  Uint32 now;
  now = SDL_GetTicks ();
  if (nexttime <= now)
  {
    nexttime = now + TIMER_INTERVAL;
    return 0;
  }
  return nexttime - now;
}

int joystickx = 0, joysticky = 0, joystickt = 0, joystickr = 0;
int joystickbutton = -1;

void sdlMainLoop ()
{
  SDL_Event event;
  while (1)
  {
    while (SDL_PollEvent (&event))
    {
      switch (event.type)
      {
        case SDL_MOUSEMOTION:
          myPassiveMotionFunc (event.motion.x, event.motion.y);
          break;
        case SDL_MOUSEBUTTONDOWN:
          myMouseFunc (event.button.button, event.button.state, event.button.x, event.button.y);
          break;
        case SDL_KEYDOWN:
          if (!event.key.keysym.unicode)
            mySpecialFunc (event.key.keysym.sym, 0, 0);
          else
            myKeyboardFunc (event.key.keysym.sym, 0, 0);
          break;
        case SDL_JOYAXISMOTION:
//          if (abs (event.jaxis.value) > 500)
          {
            if (event.jaxis.axis == 0)
            {
              joystickx = event.jaxis.value;
            }
            else if (event.jaxis.axis == 1)
            {
              joysticky = event.jaxis.value;
            }
            else if (event.jaxis.axis == 2)
            {
              joystickt = event.jaxis.value;
            }
            else if (event.jaxis.axis == 3)
            {
              joystickr = event.jaxis.value;
            }
            if (joystickx > -3000 && joystickx < 3000) joystickx = 0;
            if (joysticky > -3000 && joysticky < 3000) joysticky = 0;
//            printf ("\naxis=%d, val=%d", event.jaxis.axis, event.jaxis.value); 
          }
          break;
        case SDL_JOYBUTTONDOWN:
          joystickbutton = event.jbutton.button;
          if (joystickbutton >= 2)
            myJoystickButtonFunc (joystickbutton);
          break;
        case SDL_JOYBUTTONUP:
          joystickbutton = -1;
          break;
        case SDL_JOYHATMOTION:
          myJoystickHatFunc (event.jhat.value);
          break;
        case SDL_ACTIVEEVENT:
          sdlreshape = true;
          sdldisplay = true;
          break;
      }
    }
//    printf ("\nx=%d, y=%d", joystickx, joysticky);
    myJoystickAxisFunc (joystickx, joysticky, joystickt, joystickr);
    if (joystickbutton == 0)
      myJoystickButtonFunc (0);
    else
      joystickbutton = -1;
    if (sdldisplay) myDisplayFunc ();
    sdldisplay = false;
    if (sdlreshape) myReshapeFunc (width, height);
    sdlreshape = false;
    SDL_Delay (sdlTimeLeft ());
    sdlTimerFunc ();
  }
}
#endif

int main (int argc, char **argv)
{
  printf ("\nStartup %s ... ", VERSIONSTRING); fflush (stdout);

  load_config ();
  save_config ();

/*
  time_t t;
  time (&t);
  srandom ((long) t);*/

  srand (1);

  server = NULL;
  client = NULL;

#ifdef USE_GLUT
  printf ("\nUsing GLUT only"); fflush (stdout);
  glutInit(&argc, argv);

  glutInitDisplayMode(GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE);
  char gamestr [256];
  sprintf (gamestr, "%dx%d:%d", width, height, bpp);
  glutGameModeString (gamestr);
  if (fullscreen && glutGameModeGet (GLUT_GAME_MODE_POSSIBLE))
  {
//    width = 800; height = 600;
    glutEnterGameMode ();
  }
  else
  {
    glutInitWindowPosition (0, 0);
    glutInitWindowSize (width, height);
    if (glutCreateWindow ("GL-117") == GL_FALSE)
      exit(1);
  }

//  glutFullScreen ();
  myFirstInit ();

  sound = new SoundSystem ();

  glutReshapeFunc(myReshapeFunc);
  glutDisplayFunc(myDisplayFunc);
  glutKeyboardFunc(myKeyboardFunc);
  glutSpecialFunc(mySpecialFunc);
  glutPassiveMotionFunc(myPassiveMotionFunc);
  glutMouseFunc(myMouseFunc);
  glutIdleFunc(myIdleFunc);
  glutTimerFunc(20, myTimerFunc, 0);

  gluPerspective (80.0, (float) width / height, 0.20, 50.0); // should be sqrt(2) or 1.5
  glutMainLoop();
#else
  printf ("\nUsing SDL and GLUT"); fflush (stdout);
	if (SDL_Init (SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK) < 0)
  {
		fprintf (stderr, "\nCouldn't initialize SDL: %s\n", SDL_GetError ());
		exit (1);
	}
	atexit (SDL_Quit);

  sound = new SoundSystem ();
  sound->volumesound = volumesound;
  sound->volumemusic = volumemusic;
  sound->setVolume ();
  sound->setVolumeMusic ();

  sound->playMusic (MUSIC_DARK1);

#ifdef HAVE_SDL_NET
	// initialize SDL_net
	if(SDLNet_Init()==-1)
	{
		fprintf (stderr, "\nSDLNet_Init: %s\n",SDLNet_GetError()); fflush (stderr);
		exit(2);
	}
  printf ("\nUsing SDL_net"); fflush (stdout);
#endif

	if (bpp == 0) {
		if ( SDL_GetVideoInfo()->vfmt->BitsPerPixel <= 8 ) {
			bpp = 8;
		} else {
			bpp = 16;
		}
	}

	Uint32 video_flags;
  video_flags = SDL_OPENGL;
  if (fullscreen) video_flags |= SDL_FULLSCREEN;

	int rgb_size[3];
	switch (bpp) {
	  case 8:
		rgb_size[0] = 2;
		rgb_size[1] = 3;
		rgb_size[2] = 3;
		break;
	  case 15:
	  case 16:
		rgb_size[0] = 5;
		rgb_size[1] = 5;
		rgb_size[2] = 5;
		break;
    default:
		rgb_size[0] = 8;
		rgb_size[1] = 8;
		rgb_size[2] = 8;
		break;
	}
	SDL_GL_SetAttribute (SDL_GL_RED_SIZE, rgb_size [0]);
	SDL_GL_SetAttribute (SDL_GL_GREEN_SIZE, rgb_size [1]);
	SDL_GL_SetAttribute (SDL_GL_BLUE_SIZE, rgb_size [2]);
	SDL_GL_SetAttribute (SDL_GL_DEPTH_SIZE, 16);
	SDL_GL_SetAttribute (SDL_GL_DOUBLEBUFFER, 1);
	if (SDL_SetVideoMode (width, height, bpp, video_flags) == NULL)
  {
  	if (SDL_VideoModeOK (width, height, bpp, video_flags) != 0)
    {
		  fprintf (stderr, "\nCouldn't set GL mode: %s\n", SDL_GetError ());
		  SDL_Quit ();
		  exit (1);
    }
	}

	SDL_WM_SetCaption ("GL-117", "GL-117");

  SDL_ShowCursor (0);

  myFirstInit ();
  myReshapeFunc (width, height);

  joystick = SDL_NumJoysticks ();
  if (joystick > 0)
  {
    SDL_JoystickEventState (SDL_ENABLE);
    sdljoystick = SDL_JoystickOpen (0);
  }
  else sdljoystick = NULL;
  
	SDL_EnableUNICODE (1);
	SDL_EnableKeyRepeat (SDL_DEFAULT_REPEAT_DELAY,
	                     SDL_DEFAULT_REPEAT_INTERVAL);

  sdlMainLoop ();
#endif

  return 0;
}

#endif

